drkns 26.08.2017 11:20:44 +0100 - build 5014

1. В макрофункции date творилась дичь:
   Согласно документации, "%Z" должно было возвращать "Имя часового пояса или пусто, если часовой пояс не задан".
   На самом же деле возвращалась разница между UTC и текущей TZ в формате ±hhmm, т. е. почти как %z в strftime, но, ВНИМАНИЕ, без учёта DST bias.
   Что же это значит? А значит это, например, то, что все даты во всех changelogах (включая этот) имеют мало общего с действительностью.

   Теперь:
     %Z - это на самом деле ИМЯ часового пояса, как обещано.
     %z - это смещение локального времени относительно UTC.

   Не забудьте исправить %Z на %z в своём макросе.

shmuel 24.08.2017 15:16:45 +0200 - build 5013

1. MCTL_GETLASTERROR можно теперь вызывать и после исполнения MSSC_POST и MCTL_EXECSTRING.

2. MCTL_EXECSTRING теперь учитывает флаг KMFLAGS_SILENTCHECK.

shmuel 23.08.2017 12:57:35 +0200 - build 5012

1. Флаг KMFLAGS_SILENTCHECK игнорировался в команде MSSC_POST.

drkns 18.08.2017 09:30:57 +0000 - build 5011

1. Не работало центрирование кнопок в диалоге поиска при изменении размера.

drkns 17.08.2017 22:31:49 +0000 - build 5010

1. С форума: не обновляется строка горячих клавиш после просмотра сети.

2. С форума: в диалоге поиска некорректно перерисовывался разделитель при изменении размера.

drkns 16.08.2017 11:43:28 +0000 - build 5009

1. Уточнение 5008.

drkns 16.08.2017 09:54:19 +0000 - build 5008

1. Там же: при выравнивании по левому/правому краю текст отображался полностью, даже если не влезал в указанные рамки.

drkns 16.08.2017 09:22:10 +0000 - build 5007

1. C форума: DI_TEXT + DIF_CENTERTEXT выравнивался по центру диалога вместо относительно координат X1 и X2.

drkns 14.08.2017 21:38:39 +0000 - build 5006

1. Теперь FCTL_<G|S>ETUSERSCREEN можно использовать и из режимов редактора (-e) и просмотра (-v).

drkns 13.08.2017 17:07:42 +0000 - build 5005

1. Уточнение 4959.

drkns 11.08.2017 01:15:42 +0000 - build 5004

1. Рефакторинг.

drkns 09.08.2017 00:11:01 +0000 - build 5003

1. Ещё раз о владельцах.

drkns 08.08.2017 20:27:34 +0000 - build 5002

1. 0003466: Зависание/падение по перерасходу памяти при добавлении новых столбцов панели без указания ширины

2. С форума: Не показывает владельца файла на шаре windows

svs 08.08.2017 12:26:57 +0300 - build 5001

1. SQLite 3.20.0

drkns 06.08.2017 11:07:04 +0000 - build 5000

1. Ещё одно уточнение 4996.

drkns 04.08.2017 20:07:24 +0000 - build 4999

1. С форума: "Падение при выходе “наверх” из панели результатов RESearch"

drkns 04.08.2017 00:27:23 +0000 - build 4998

1. Уточнение 4997 - погнулась замена.

2. Там же - криво работала замена, содержащая "\r", и уже давно.

drkns 01.08.2017 20:39:18 +0000 - build 4997

1. Продолжение #3462 - не меняем позицию курсора без необходимости.

drkns 31.07.2017 20:01:11 +0000 - build 4996

1. Уточнение 4995.1.

2. 0003462: Поиск всех вхождений теряет вхождение в первой строке

3. Там же - не снимаем выделение раньше времени, а также если ничего не нашли.

drkns 30.07.2017 01:45:36 +0000 - build 4995

1. Рефакторинг.

drkns 23.07.2017 22:34:57 +0000 - build 4994

1. 0003457: Мышь работает в FAR даже при отключённом параметре "Настройки интерфейса - Мышь"

2. Рефакторинг.

drkns 23.07.2017 10:31:34 +0000 - build 4993

1. Не работал поиск в справке.

2. В некоторых случаях не работало автодополнение.

drkns 22.07.2017 13:25:18 +0000 - build 4992

1. С форума: Ошибочная индикация позиции ошибки в регэкспе

drkns 21.07.2017 19:29:12 +0000 - build 4991

1. Уточнение 4989.

drkns 20.07.2017 23:10:16 +0000 - build 4990

1. Вернём защиту от нехваток памяти, добавленную в 1741 и потерянную в 3791.

drkns 20.07.2017 01:09:52 +0000 - build 4989

1. Рефакторинг. Остановим расползание PANEL_STOP по коду.

drkns 18.07.2017 20:34:50 +0000 - build 4988

1. Рефакторинг.

2. Coverity warnings.

shmuel 18.07.2017 13:36:33 +0200 - build 4987

1. M#3428: добавить GUID-ы для диалогов редактирования/вставки пунктов меню пользователя.

drkns 17.07.2017 21:53:50 +0000 - build 4986

1. 0003454: Completion путей перестал распознавать / в качестве разделителя.

shmuel 12.07.2017 23:53:19 +0200 - build 4985

1. Глючил DM_SETTEXT для DI_LISTBOX (начиная от билда 4248).

drkns 04.07.2017 23:44:29 +0000 - build 4984

1. Автообновление панелей не работало в каталогах с нетрадиционными именами.

2. Связанный с п. 1 рефакторинг filesystemwatcher, ибо как-то всё весьма мутно было.

drkns 03.07.2017 19:31:28 +0000 - build 4983

1. В некоторых случаях макрос мог вызвать исключение в меню со включенным фильтром.

drkns 02.07.2017 13:53:50 +0000 - build 4982

1. С форума: Странные значения в диалогах перемещения/копирования

drkns 01.07.2017 13:08:48 +0000 - build 4981

1. Стабы в vc_crt_fix_impl.cpp заменены более-менее рабочими версиями.

2. Уточнение работы leak-детектора.

drkns 28.06.2017 19:02:42 +0000 - build 4980

1. Ошибка отображения информации о заблокированном файле.

2. fmt v4.0.0.

3. TinyXML-2 v5.0.1

drkns 25.06.2017 02:03:37 +0000 - build 4979

1. Рефакторинг.

drkns 23.06.2017 16:48:00 +0000 - build 4978

1. С форума: ненужный запрос привилегий

drkns 22.06.2017 23:26:01 +0000 - build 4977

1. Рефакторинг.

drkns 21.06.2017 07:30:17 +0000 - build 4976

1. В некоторых случаях плагин мог вызвать исключение в меню со включенным фильтром.

svs 19.06.2017 07:24:13 +0300 - build 4975

1. SQLite 3.19.3

drkns 18.06.2017 10:59:10 +0000 - build 4974

1. Уточнение 4945.

drkns 05.06.2017 13:26:32 +0200 - build 4973

1. Уточнение 4887.

2. Рефакторинг.

svs 30.05.2017 23:13:19 +0300 - build 4972

1. SQLite 3.19.2

drkns 29.05.2017 14:46:17 +0000 - build 4971

1. Уточнение 4969.

shmuel 27.05.2017 02:27:03 +0200 - build 4970

1. Уточнение 4585: при переключении между панелью Фара и плагина (в любую сторону) не сохранялись
   кастомные сортировки.

drkns 26.05.2017 21:45:31 +0000 - build 4969

1. Продолжение 4963.

svs 24.05.2017 21:58:27 +0300 - build 4968

1. SQLite 3.19.1

drkns 23.05.2017 23:10:16 +0000 - build 4967

1. Ещё одно уточнение 4963.

drkns 22.05.2017 23:20:20 +0000 - build 4966

1. Уточнение 4963.

drkns 22.05.2017 20:44:12 +0000 - build 4965

1. Ещё всякое на тему gcc 7.

drkns 20.05.2017 23:45:02 +0000 - build 4964

1. gcc 7.

drkns 19.05.2017 23:29:09 +0000 - build 4963

1. 0003434: В функции FormatFileSize параметр Width не полностью соотвествуют документации.
   Изменение в API: "сколько получится" теперь подразумевается при 0, а не при -1.

2. Прочие исправления (а возможно и новые баги) в той же функции и окресностях.

drkns 16.05.2017 07:34:39 +0000 - build 4962

1. Уточение процесса загрузки плагинов.

drkns 15.05.2017 14:39:00 +0000 - build 4961

1. Продолжение 4959 - отображением ошибок загрузки плагинов теперь заведует соответствующий загрузчик,
   дабы не пытаться показать LastError там, где его нет. Параметра SilentLoadPlugin больше нет.

drkns 14.05.2017 20:32:53 +0000 - build 4960

1. Уточнение 4957.

drkns 14.05.2017 20:09:37 +0000 - build 4959

1. Расширим немного Adapter API:
   BOOL WINAPI GetError(ErrorInfo* info)
     - Far вызывает эту функцию после каждого обращения к адаптеру чтобы узнать, всё ли там хорошо.
       Если не всё - будет показано сообщение с текстом ошибки.

drkns 13.05.2017 20:07:39 +0000 - build 4958

1. Поправим погнутую сортировку.

drkns 13.05.2017 11:11:40 +0000 - build 4957

1. 0003430: Ошибка повышения привилегий в Far 3.0.4949

drkns 11.05.2017 00:06:47 +0000 - build 4956

1. 0003433: Если выполненная программа поменяла заголовок консоли, Far его не восстановит

2. Пара мелочей.

drkns 09.05.2017 22:40:36 +0000 - build 4955

1. Уточнение 4950 - падало на сообщениях без строк.

drkns 06.05.2017 21:45:46 +0000 - build 4954

1. Уточнение 4945.

drkns 05.05.2017 00:31:34 +0000 - build 4953

1. Уточнение 4952.

drkns 04.05.2017 20:45:42 +0000 - build 4952

1. Рефакторинг.

drkns 03.05.2017 00:02:38 +0000 - build 4951

1. Уточнение 4950.

drkns 02.05.2017 23:55:28 +0000 - build 4950

1. Немного сократим копирование данных в Message().

zg 02.05.2017 16:38:35 +0200 - build 4949

1. уточнение 4945: не работала команда if exist.

drkns 01.05.2017 22:42:32 +0000 - build 4948

1. Уточнение 4945.

zg 01.05.2017 16:49:59 +0200 - build 4947

1. уточнение 4945: в командной строке и в строках редактирования не работал CtrlEnd при отключённом автодополнении.

zg 01.05.2017 16:05:46 +0200 - build 4946

1. уточнение 4945: в редакторе не работал регистронезависимый поиск.

drkns 01.05.2017 00:21:40 +0000 - build 4945

1. Рефакторинг.

drkns 27.04.2017 20:58:46 +0000 - build 4944

1. Убираем пробелы при обработке pushd.

2. Более корректно убираем кавычки при обработке set.

zg 25.04.2017 12:59:57 +0200 - build 4943

1. исключение при вызове mf.fsplit('a.:',0x4+0x8)

drkns 24.04.2017 07:59:10 +0000 - build 4942

1. Уточнение 4940 ещё раз.

drkns 23.04.2017 22:24:28 +0000 - build 4941

1. Уточнение 4936.

2. Уточнение 4940.

3. Рефакторинг.

drkns 23.04.2017 15:52:18 +0000 - build 4940

1. 0003216: Клавиша Shift игнорируется в диалогах при включённой настройке автозавершения "Подставлять первый подходящий вариант"

drkns 22.04.2017 20:39:26 +0000 - build 4939

1. Уточнение 4938.

2. Рефакторинг.

drkns 22.04.2017 14:04:11 +0000 - build 4938

1. 0003424: Новый параметр командной строки для наследования заголовка консоли

2. Уточнение работы дополнения:
   - сортировка без учёта кавычек
   - сохранение уже введённого регистра
   - выделение учтывает позицию курсора

3. Рефакторинг.

drkns 18.04.2017 22:21:06 +0000 - build 4937

1. Рефакторинг.

drkns 17.04.2017 22:16:12 +0000 - build 4936

1. Panel.RememberLogicalDrives теперь, наверное, можно пользоваться - сохранённый список дисков будет обновлён при необходимости.

2. При запуске с плагиновых панелей удаление временного файла производится после закрытия панели, а не сразу.

3. Рефакторинг.

drkns 12.04.2017 18:58:51 +0000 - build 4935

1. Продолжение 4934.

drkns 11.04.2017 07:51:48 +0000 - build 4934

1. Обработка Num-клавиш в меню редактирования режимов панелей.

drkns 08.04.2017 19:00:16 +0000 - build 4933

1. Рефакторинг.

drkns 06.04.2017 07:53:14 +0000 - build 4932

1. Не работал вайп пустых файлов.

drkns 05.04.2017 20:10:41 +0000 - build 4931

1. Уточнение 4928.

2. Пара мелочей.

zg 05.04.2017 20:41:01 +0200 - build 4930

1. 0003419: Crash при ресайзе окна содержащего открытый выпадающий спискок.

svs 02.04.2017 20:22:22 +0300 - build 4929

1. SQLite 3.18.0

drkns 01.04.2017 13:54:43 +0000 - build 4928

1. Рефакторинг.

shmuel 28.03.2017 13:40:20 +0200 - build 4927

1. M#3415: ошибка в menu.itemstatus

drkns 26.03.2017 12:56:32 +0000 - build 4926

1. Рефакторинг.

zg 26.03.2017 14:48:27 +0200 - build 4925

1. RestoreScreen сразу восстанавливает содержимое экрана.

drkns 24.03.2017 18:18:14 +0000 - build 4924

1. Уточнение 4923.

drkns 23.03.2017 23:28:58 +0000 - build 4923

1. Рефакторинг.

w17 23.03.2017 21:39:02 +0300 - build 4922

1. forum: Автоматическая замена шары на букву диска
   При переходе из списка шар сервера к выделенному элементу по Enter теперь не происходит
   переход к диску (если он назначен), по CtrlPgDn - старое поведение (если есть диск - переход к нему).

drkns 21.03.2017 20:39:52 +0000 - build 4921

1. From the forum: Crash in cancelled file edit in NetBox

drkns 21.03.2017 01:31:42 +0000 - build 4920

1. Не всегда загружались отладочные символы.

2. Рефакторинг.

drkns 20.03.2017 23:25:32 +0000 - build 4919

1. Уточнение 4888.

drkns 16.03.2017 23:14:59 +0000 - build 4918

1. Рефакторинг.

shmuel 15.03.2017 21:40:52 +0200 - build 4917

1. Уберём нестандартное поведение клавиш Right и Left при перемещении между чекбоксами в диалоге.
   (Если со временем выявится, что прежнее поведение предпочтительнее - вернём прежнее).
   Радиобаттоны не трогаем, так как повлияет на диалог выбора цвета.

drkns 15.03.2017 11:30:29 +0000 - build 4916

1. Уточнение 4907.

2. Рефакторинг.

drkns 13.03.2017 15:01:25 +0000 - build 4915

1. Коррекция обработки SEH-исключений в неосновных нитях.

drkns 13.03.2017 13:39:47 +0000 - build 4914

1. С форума: Удаляется архив, содержащий другой архив

drkns 11.03.2017 00:05:34 +0000 - build 4913

1. С форума: съехал вправо заголовок окна справки.

zg 10.03.2017 13:55:54 +0200 - build 4912

1.при определённых условиях в пользовательском меню редактор/просмотр вызванные по edit:/view: были модальными.

drkns 09.03.2017 07:35:59 +0000 - build 4911

1. 0003404: `Lock editing of read-only files` is ignored (regression)

drkns 08.03.2017 19:14:38 +0000 - build 4910

1. Уберём constexpr у статических объектов - в VS2017 с ним всё ещё хуже, чем раньше.

drkns 08.03.2017 17:34:21 +0000 - build 4909

1. VS2017 support.

2. VS2017 & clang warnings.

3. Рефакторинг.

zg 07.03.2017 03:02:10 +0200 - build 4908

1. убрана глобальная переменная WaitInMainLoop.

drkns 06.03.2017 14:08:55 +0000 - build 4907

1. Выход из плагина network мог вызывать переход в несуществующую папку.

2. Рефакторинг.

zg 06.03.2017 14:02:30 +0200 - build 4906

1. 0003401: Странный баг с часами в редакторе.

drkns 05.03.2017 16:01:22 +0000 - build 4905

1. С форума: при работе по сети с NAS QNAP почему-то при заходе на любую шару текущий и родительский каталоги дополнительно добавляются в список.
   В QNAP, видимо, тоже не читали "2.4.17 FileIdBothDirectoryInformation".

drkns 28.02.2017 18:57:23 +0000 - build 4904

1. Не удалялись временные файлы, созданные во время вызова просмотра из результатов поиска.

drkns 27.02.2017 19:04:21 +0000 - build 4903

1. 0003358: ArcLite. The system cannot find the path specified

drkns 22.02.2017 23:45:29 +0000 - build 4902

1. При обработке команды 'set' не удалялись кавычки из фильтра.

drkns 21.02.2017 18:50:57 +0000 - build 4901

1. Опечатка в 4883.

drkns 20.02.2017 19:16:22 +0000 - build 4900

1. Coverity warnings.

drkns 18.02.2017 19:05:09 +0000 - build 4899

1. Рефакторинг, переименования.

svs 14.02.2017 20:19:16 +0300 - build 4898

1. SQLite 3.17.0

zg 12.02.2017 20:58:11 +0200 - build 4897

1. уточнение 4889.

drkns 11.02.2017 15:51:04 +0000 - build 4896

1. Рефакторинг.

drkns 10.02.2017 22:44:19 +0000 - build 4895

1. Уточнение 4892.

drkns 10.02.2017 22:12:46 +0000 - build 4894

1. Рефакторинг.

yjh 08.02.2017 23:33:29 +0300 - build 4893

1. адаптеция ulink-хелпера к хидерам VS2015sp3 (const)
2. в предыдущем коммите внесена некомпилируемая ошибка (потеря части строки)

drkns 08.02.2017 19:50:19 +0000 - build 4892

1. Рефакторинг.

drkns 08.02.2017 19:44:46 +0000 - build 4891

1. С форума - файлы, запущенные через системные ассоциации пишутся в историю без кавычек, даже если имеют пробелы в именах, из-за чего повторный запуск через Ctrl+E невозможен.

zg 07.02.2017 12:15:01 +0200 - build 4890

1. уточнение 4889.

zg 30.01.2017 17:04:33 +0200 - build 4889

1. при вызове ECTL_SETTITLE из EE_REDRAW не сбрасывается буфер консоли.

drkns 24.01.2017 22:13:49 +0000 - build 4888

1. Уточнение 4887.

2. Рефакторинг.

drkns 23.01.2017 19:30:10 +0000 - build 4887

1. Уточнение 4885.

2. Рефакторинг.

w17 23.01.2017 19:46:07 +0300 - build 4886

1. forum: Не вставить символ как пометку в раскраске

drkns 20.01.2017 18:35:54 +0000 - build 4885

1. 0003385: Ломается пользовательское меню при его редактировании.

drkns 19.01.2017 23:30:22 +0000 - build 4884

1. Новые версии tinyxml2 и fmt.

drkns 19.01.2017 23:23:24 +0000 - build 4883

1. Рефакторинг.

svs 11.01.2017 15:22:11 +0300 - build 4882

1. SQLite 3.16.2

svs 04.01.2017 23:15:57 +0300 - build 4881

1. SQLite 3.16.1

w17 02.01.2017 13:31:46 +0300 - build 4880

1. Уточнение 4874

w17 02.01.2017 12:14:24 +0300 - build 4879

1. Уточнение и продолжение 4875

drkns 30.12.2016 21:51:04 +0200 - build 4878

1. Убран забытый отладочный код.

drkns 30.12.2016 20:12:15 +0200 - build 4877

1. Рефакторинг.

drkns 28.12.2016 23:04:30 +0200 - build 4876

1. С форума: в процессе переноса файлов с описаниями на панели мог отображаться мусор.

2. Рефакторинг.

w17 24.12.2016 21:57:03 +0300 - build 4875

1. 0003361: Запрашиваются админ. права для переименования файла

w17 24.12.2016 21:39:58 +0300 - build 4874

1. 0003366: расширение зоны действия Ctrl-Shift-S

w17 22.12.2016 20:51:29 +0300 - build 4873

1. -падение вьювера при поиске в ооочень длинных строках.

drkns 19.12.2016 20:38:48 +0200 - build 4872

1. Рефакторинг.

drkns 18.12.2016 18:52:41 +0200 - build 4871

1. Рефакторинг.

zg 17.12.2016 01:01:39 +0200 - build 4870

1. 0003367: Undo оставляет пробелы, которых не было.

drkns 14.12.2016 01:41:17 +0200 - build 4869

1. 0003353: Ошибка отрисовки при выходе машины из спячки.

2. Пара мелочей.

drkns 06.12.2016 09:32:48 +0200 - build 4868

1. Отменим пока 4866.1, т. к. стало хуже.

drkns 06.12.2016 02:43:44 +0200 - build 4867

1. Уточнение 4866.

drkns 06.12.2016 00:43:52 +0200 - build 4866

1. 0003361: Запрашиваются админ. права для переименования файла
   Суть не в запросе прав, а в поломанном копире. Часть 1, не факт, что поможет.

2. Если System.WipeSymbol установить в -1, то для вайпа будут использоваться случайные значения.

3. Рефакторинг.

svs 02.12.2016 12:10:47 +0300 - build 4865

1. SQLite 3.15.2

drkns 01.12.2016 22:11:17 +0200 - build 4864

1. Неверный путь для ".." на панели в списке экранов по F12

2. Мелкий рефакторинг.

drkns 29.11.2016 21:50:31 +0200 - build 4863

1. Падение при вызове меню ассоциаций, если ассоциации отсутствовали.

zg 29.11.2016 19:09:02 +0200 - build 4862

1. продолжение 4808.1.

zg 29.11.2016 17:06:30 +0200 - build 4861

1. с форума: в папке Far ищем файлы с маской"*gs.x*" (в чистом фаре должен найтись один файл).
   вместо результатов поиска пустое поле, а в статусе (внизу) три точки.

drkns 28.11.2016 17:01:39 +0200 - build 4860

1. С форума: постоянные блоки, редактор, строка длиннее ширины экрана
   переходим в конец строки (происходит горизонтальный скрол экрана), выделяем небольшую подстроку, нажимаем Home, Far молча схлопывается

drkns 27.11.2016 11:48:40 +0200 - build 4859

1. При смене диска мышью не всегда устанавливался текущий каталог панели.

drkns 26.11.2016 14:11:57 +0200 - build 4858

1. Частичный откат 4853 ради совместимости с W2k.

drkns 26.11.2016 03:41:05 +0200 - build 4857

1. В gcc wcschr и ему подобные снимали константность с возвращаемого указателя.
   Багу 10 лет и чинить его, похоже, не собираются.

zg 25.11.2016 23:42:39 +0200 - build 4856

1. Уточнение 4853.2.

drkns 25.11.2016 17:46:52 +0200 - build 4855

1. Уточнение 4853.2.

drkns 25.11.2016 17:34:15 +0200 - build 4854

1. gcc 5.

drkns 25.11.2016 15:41:04 +0200 - build 4853

1. 0003355: Far виснет после запроса привилегий при поиске в архивах.

2. Продолжение 4849.

drkns 23.11.2016 23:32:50 +0200 - build 4852

1. С форума: падало при постоянных блоках и выделенном блоке от почти начала строки до ее конца и нажатии Enter в начале строки

w17 23.11.2016 08:18:32 +0300 - build 4851

1. Fix 2643 -- пропадание текста в просмотре.

drkns 23.11.2016 02:44:51 +0200 - build 4850

1. Некорректно отображался hex-просмотр.

drkns 22.11.2016 03:33:12 +0200 - build 4849

1. Продолжим начатое в 4848:
   - обновляем по таймауту, как везде
   - из поиска частично удалены остатки былой роскоши (но не все)
   - мелкие правки в смежных модулях.

zg 21.11.2016 20:27:54 +0200 - build 4848

1. диалог с результатами поиска теперь обновляется из главного потока. вся синхронизация в диалогах и меню убрана.

drkns 21.11.2016 10:20:02 +0200 - build 4847

1. Ещё одно уточнение 4834.

2. Рефакторинг.

w17 20.11.2016 15:40:36 +0300 - build 4846

1. Fix 2201.

drkns 19.11.2016 14:44:48 +0200 - build 4845

1. После 4834 криво работало меню ассоциаций.

2. Пара мелочей.

drkns 18.11.2016 20:16:18 +0200 - build 4844

1. Ещё пара уточнений 4834.

drkns 18.11.2016 17:53:42 +0200 - build 4843

1. Уточнение выравнивания строк по правому краю в элементах интерфейса.

2. Coverity warnings.

3. Рефакторинг.

zg 17.11.2016 11:48:08 +0200 - build 4842

1. 0003352: CtrlC сбрасывает состояние "неизменённый текст".

zg 16.11.2016 14:48:22 +0200 - build 4841

1. таскание диалога мышью и клавиатурой разделены.

svs 15.11.2016 11:18:33 +0300 - build

1. Добавка в файлы Помоши про команды "far:config" и "far:about"

drkns 15.11.2016 07:32:16 +0200 - build 4840

1. Убран workaround, добавленный в 4835 - исправлено в библиотеке.

zg 13.11.2016 23:24:26 +0200 - build 4839

1. уточнение 4838 для меню.

zg 13.11.2016 20:44:50 +0200 - build 4838

1. убран прямой опрос ввода при перетаскивании диалога.

drkns 13.11.2016 18:38:58 +0200 - build 4837

1. Уточнение 4834.

drkns 13.11.2016 14:47:30 +0200 - build 4836

1. 0003348: Far(build 4834) Trap on show folder/file attribute dialog

drkns 13.11.2016 14:17:47 +0200 - build 4835

1. gcc версия не запускалась в пещерных ОС.

drkns 12.11.2016 13:07:03 +0200 - build 4834

1. Вместо FormatString, FormatScreen, str_printf, ostringstream и прочего зоопарка используется fmtlib.
   Изменений много, возможны чудеса.

2. Прочий рефакторинг на эту же тему.

svs 08.11.2016 08:10:59 +0300 - build 4833

1. SQLite 3.15.1

drkns 04.11.2016 00:29:33 +0200 - build 4832

1. Уточнение 4831.

zg 31.10.2016 20:55:32 +0200 - build 4831

1. 0003337: Не восстанавливается заголовок консоли, начиная c 4809.

drkns 21.10.2016 00:55:50 +0200 - build 4830

1. Coverity warnings.

2. Пара мелочей.

shmuel 20.10.2016 19:36:54 +0200 - build 4829

1. M#3275: Allow plugins to load and edit unsaved macro
   Макробраузер при нажатии F4/AltF4 на несохранённом клавиатурном макросе вызывает фаровский диалог "Macro settings".

drkns 20.10.2016 01:41:37 +0200 - build 4828

1. Очередные танцы вокруг Maximise/Restore и Alt+F9.

svs 17.10.2016 11:50:09 +0300 - build 4827

1. SQLite 3.15.0

drkns 15.10.2016 14:32:31 +0200 - build 4826

1. С форума: иногда при уменьшении размеров консоли во внутренний буфер попадал мусор.

2. Всякие прочие мелочи на эту же тему. Если что-нибудь где-нибудь отвалится - пишите.

zg 15.10.2016 03:59:22 +0200 - build 4825

1. уточнение 4808.1.

2. ACTL_REDRAWALL мог перерисовывать не все окна.

w17 14.10.2016 20:34:39 +0300 - build 4824

1. Привычное поведение при показе числа фоновых окон.
   Panel.ScreenNumber теперь 3-state, с умолчанием = 1.
   Число диалогов показываем только для состояния 2.

zg 13.10.2016 17:16:58 +0200 - build 4823

1. 0003327: ECTL_REDRAW does not redraw during processing.

drkns 13.10.2016 09:33:05 +0200 - build 4822

1. Уточнение 4603. Передаём перечисленное в кастомную сортировку только если оно уже считано или будет.

drkns 12.10.2016 23:24:37 +0200 - build 4821

1. 0003304: Вывод на консоль из плагина удваивается за пределами окна

zg 11.10.2016 18:16:57 +0200 - build 4820

1. уточнение 4818: при нажатии enter на панели multiarc задавался вопрос на распаковку.

2. уточнение 4818: аналогичное поведение для запуска по enter встроенных ассоциаций.

drkns 10.10.2016 23:09:35 +0200 - build 4819

1. Сократим немного копипасту в проверке времени изменения файла.

zg 10.10.2016 16:33:04 +0200 - build 4818

1. 0003325: Detect external file editing and post back to plugin.

drkns 10.10.2016 02:27:15 +0200 - build 4817

1. Уточнение 4816.

drkns 09.10.2016 21:48:44 +0200 - build 4816

1. Рефакторинг.

drkns 09.10.2016 01:42:02 +0200 - build 4815

1. Уточнение 4796.4.

2. В makefile_vc можно выключать LTCG для отладочных целей.

3. Команды из svn_tag_build_ssl.m4 переехали в svn_tag_build_ssl.bat.
   Также теперь оно явно показывает, какой тег собирается создавать.

drkns 08.10.2016 15:14:07 +0200 - build 4814

1. В режиме постоянных блоков сбрасывалось выделение в строке при замене.

zg 08.10.2016 13:51:32 +0200 - build 4813

1. 0003324: Find/Replace in editor does not highlight found entries.

drkns 08.10.2016 10:38:23 +0200 - build 4812

1. Обход очередного бага VS.

drkns 08.10.2016 02:27:23 +0200 - build 4811

1. Продолжение 4810.2.

drkns 08.10.2016 01:10:06 +0200 - build 4810

1. Ещё раз о флагах консоли: вместо создания с нуля наследуем существующие и меняем только то, что нам нужно.

2. Рефакторинг.

drkns 06.10.2016 22:59:17 +0200 - build 4809

1. Не сохранялись флаги консоли ENABLE_AUTO_POSITION и ENABLE_INSERT_MODE:
   - окно могло неоптимально позиционироваться при разворачивании;
   - запущенный из фара, например, cmd мог внезапно оказаться в режиме 'overwrite'.

2. Пара мелочей.

zg 06.10.2016 19:59:25 +0200 - build 4808

1. уточнение 4803 для вложенных диалогов.

2. уточнение 4807.

zg 05.10.2016 20:37:13 +0200 - build 4807

1. уточнение 4803 для граббера.

drkns 04.10.2016 09:47:59 +0200 - build 4806

1. Уточнение 4794 & 4805.

drkns 03.10.2016 21:28:23 +0200 - build 4805

1. 0003318: "Message not found" errors when opening F9 > Options > Colors

drkns 02.10.2016 18:45:31 +0200 - build 4804

1. Рефакторинг.

zg 01.10.2016 18:23:05 +0200 - build 4803

1. 0003051: Вызов ECTL_REDRAW из диалога.

drkns 01.10.2016 14:28:21 +0200 - build 4802

1. В некоторых случаях не удалялись временные файлы после просмотра архивов.

drkns 01.10.2016 00:08:29 +0200 - build 4801

1. Уточнение 4800.

drkns 30.09.2016 19:31:55 +0200 - build 4800

1. 0003315: unload:plugin.dll not close panel

drkns 30.09.2016 12:04:12 +0200 - build 4799

1. Уточнение 4798.

drkns 29.09.2016 17:30:16 +0200 - build 4798

1. Не работали модификаторы с mouse wheel.

2. CtrlP/CtrlM теперь не должны конфликтовать со встроенным буфером обмена.

3. Падение при нажатии AltEnd на панели плагина с нестандартными колонками.

4. Рефакторинг.

drkns 25.09.2016 20:32:14 +0200 - build 4797

1. 0001040: Main Usermenu & Console Command: "CLS & ECHO. & ipconfig /all & ECHO. & ECHO. & PAUSE" doesn't work.

drkns 25.09.2016 20:06:40 +0200 - build 4796

1. 0003255: Content of symbolic links not copied

2. 0003309: File associations - Ctrl-Up and Ctrl-Down do not move items

3. 0003310: PluginW.pas out of sync with plugin.hpp

4. 0003311: Incorrect QueryDosDevice call in MatchNtPathRoot (pathmix.cpp)

drkns 22.09.2016 02:17:12 +0200 - build 4795

1. Древний, ещё как минимум со времён 1.65 баг - в главном меню можно было получить переполнение стека.

2. Рефакторинг.

drkns 18.09.2016 02:48:50 +0200 - build 4794

1. Обход бага VS. Подробности - connect #3103404.

drkns 17.09.2016 22:13:26 +0200 - build 4793

1. constexpr.

2. longPathAware = true для Windows 10.

3. Рефакторинг.

drkns 15.09.2016 02:23:25 +0200 - build 4792

1. Уточнение 4784.1.

2. Code analysis warnings.

drkns 13.09.2016 18:28:08 +0200 - build 4791

1. Падение при копировании выделенного UTF-8 текста из вьювера.

2. Некорректное преобразование text/hex в диалоге поиска.

3. Падение при нажатии End на radiobutton в диалоге.

4. Не обновлялся экран редактора при прокрутке по Ctrl-Up/Down из меню "Find all".

svs 13.09.2016 15:13:03 +0300 - build 4790

1. SQLite 3.14.2

drkns 12.09.2016 23:35:38 +0200 - build 4789

1. Уточнение 4788.3.

2. Пара мелочей.

drkns 12.09.2016 19:23:16 +0200 - build 4788

1. Вывод плагином диалога при загрузке мог оставлять заголовок консоли пустым.

2. DM_SETTEXT во время DN_INITDIALOG сбрасывал 'unchanged' в строках ввода.

3. Глобальная замена __int64 -> long long и прочий рефакторинг.

drkns 11.09.2016 18:53:56 +0200 - build 4787

1. 0003299: начиная с версии 3.0.4784 x86 нельзя создать новую ассоциацию - не сохраняется после редактирования

drkns 11.09.2016 04:28:53 +0200 - build 4786

1. 0003294: Пустая строка комбобокса

2. Уточнение обработки DIF_EDITOR в диалогах.

3. Пара мелочей.

drkns 09.09.2016 23:40:13 +0200 - build 4785

1. После 4778 криво работал WindowMode.

drkns 08.09.2016 23:08:42 +0200 - build 4784

1. Рефакторинг.

2. TinyXML-2 4.0.1.

shmuel 06.09.2016 09:16:24 +0200 - build 4783

1. При записи/модификации/удалении клавиатурных макросов с помощью Ctrl.Ctrl. :
   a) Существующие стационарные макросы, назначенные на то же сочетание (area,key) приравниваются
      к встроенным кнопкосочетаниям Far, то-есть Far больше не предлагает их удалить либо переопределить.
   b) Для существующих клавиатурных макросов поведение остаётся прежним.

drkns 05.09.2016 20:21:32 +0200 - build 4782

1. С форума: не работало копирование после Ctrl+L Tab Ctrl+L.

zg 05.09.2016 19:25:21 +0200 - build 4781

1. с форума: Если вызвать команду FCTL_GETUSERSCREEN в момент когда на экране диалог (то же если меню или справка),
   то этот диалог почему-то остаётся в буфере.

zg 05.09.2016 12:27:54 +0200 - build 4780

1. продолжение 4777.

drkns 05.09.2016 00:52:20 +0200 - build 4779

1. Оказывается, есть плагины, считающие, что можно в Message передавать nullptr вместо "".

2. GCC warnings.

drkns 04.09.2016 23:49:35 +0200 - build 4778

1. Рефакторинг keyboard.cpp. Выкинуто много, много копипасты. Возможны сказочные чудеса.

2. Уточнение отрисовки часов при старте.

3. 4777 мог падать при закрытии некоторых окон.

zg 04.09.2016 21:21:02 +0200 - build 4777

1. рефакторинг менеджера окон.

zg 04.09.2016 15:37:13 +0200 - build 4776

1. если запрещена перерисовка диалога, не перерисовываем списки и открытые комбобоксы.

drkns 03.09.2016 18:19:14 +0200 - build 4775

1. Падение при определённых манипуляциях с панелями плагинов.

2. Утечка там же.

zg 01.09.2016 17:39:45 +0200 - build 4774

1. 0003288: ShowTotalSize for Plugin.

drkns 01.09.2016 01:21:07 +0200 - build 4773

1. Продолжение 4772.

drkns 31.08.2016 03:08:55 +0200 - build 4772

1. Очередное переосмысление концепции обработки исключений.

zg 29.08.2016 19:46:17 +0200 - build 4771

1. FSF.FarNameToInputRecord неправильно заполнял KeyEvent.uChar.UnicodeChar для клавиш типа "AltShift8".

drkns 25.08.2016 14:55:58 +0200 - build 4770

1. Добавим нормальную валидацию конфигурационных параметров, дабы не размызвать проверки ровным слоем по всему коду.

2. Второй параметр Editor.Set теперь опционален (по умолчанию -1).

shmuel 25.08.2016 14:24:34 +0200 - build 4769

1. Ещё одно уточнение 4767.

shmuel 25.08.2016 13:53:19 +0200 - build 4768

1. Уточнение 4767.

shmuel 25.08.2016 13:27:23 +0200 - build 4767

1. MacroAPI: вызов Editor.Set(0) выставлял длину таба равной нулю, что в дальнейшем приводило к падению.

drkns 25.08.2016 00:57:25 +0200

1. Продолжение валидации шапок.

drkns 24.08.2016 18:08:24 +0200 - build 4766

1. Уточнения обработки исключений.

2. После 4709 не работало изменение размера консоли с помощью "mode x, y".

drkns 23.08.2016 11:20:47 +0200 - build 4765

1. Не работал поиск в UTF8-файлах во вьювере.

2. Там же - криво работал поиск по регулярным выражениям.

drkns 22.08.2016 22:01:40 +0200

1. GCC 6.

drkns 22.08.2016 11:43:23 +0200

1. Приведены в порядок шапки во всех cpp/hpp.

2. Добавлен скрипт для валидации п. 1.

drkns 20.08.2016 14:01:57 +0200 - build 4764

1. Уточнение 4757.1.

drkns 19.08.2016 09:45:27 +0200 - build 4763

1. Уточнение 4762.

drkns 18.08.2016 22:11:54 +0200 - build 4762

1. Продолжение 0003274.

drkns 18.08.2016 21:15:20 +0200 - build 4761

1. Уточнение 4760.1.

drkns 18.08.2016 02:34:26 +0200 - build 4760

1. 0003274: В полях ввода комбинация клавиш переключения языка Ctrl-Shift ошибочно фиксирует начало изменения поля
   Обработка FEDITLINE_CLEARFLAG частично вынесена в EditControl.

2. Прочий мелкий рефакторинг.

svs 17.08.2016 20:23:57 +0300 - build 4759

1. SQLite 3.14.1

drkns 15.08.2016 09:23:14 +0200 - build 4758

1. Более параноидальные опции для GCC.

drkns 14.08.2016 15:28:56 +0200 - build 4757

1. Рефакторинг всего, связанного с кодировками.

2. -flto для GCC. Far.exe внезапно похудел аж на ~750 K.

drkns 13.08.2016 17:07:34 +0200 - build 4756

1. Ещё одно уточнение 4747.

svs 09.08.2016 10:31:09 +0300 - build 4755

1. SQLite 3.14.0

drkns 08.08.2016 23:38:23 +0200 - build 4754

1. Рефакторинг.

drkns 07.08.2016 21:59:50 +0200 - build 4753

1. После 4747 не работали адаптеры.

drkns 07.08.2016 15:01:50 +0200 - build 4752

1. Пара оптимизаций работы с буфером обмена.

drkns 06.08.2016 14:56:47 +0200 - build 4751

1. Уточнение обработки некорректных hex-строк в диалогах.

2. В одном из предыдущих билдов погнулась диагностика исключений.

drkns 04.08.2016 22:16:44 +0200 - build 4750

1. Уточнение 4748.

drkns 03.08.2016 23:30:06 +0200 - build 4749

1. Вместо %1, %2, %3... в коде и языковых файлах теперь {0}, {1}, {2}...
   Если у вас были свои lng - в них надо сделать замену первого на второе.

drkns 02.08.2016 22:18:59 +0200 - build 4748

1. Рефакторинг.

drkns 30.07.2016 21:27:07 +0200 - build 4747

1. Рефакторинг.

zg 30.07.2016 20:43:15 +0200 - build 4746

1. [Wishes 0002857]: Распознавать нажатия сочетаний нескольких модификаторов.

drkns 29.07.2016 01:34:39 +0200 - build 4745

1. Файловые панели зачем-то физически перечитывали свое содержимое (со всеми побочными эффектами, типа внезапной смены текущего каталога процесса) при простой перерисовке окна,
   которая, в общем случае, может произойти когда угодно. О сколько нам открытий чудных...

drkns 23.07.2016 12:48:09 +0200 - build 4744

1. Не сбрасываем цвет текста при вложенных вызовах FCTL_GETUSERSCREEN.

drkns 16.07.2016 13:51:54 +0200 - build 4743

1. Иногда, если очень повезёт, вызов редактора после работы с панельным плагином мог приводить к падению.

drkns 09.07.2016 22:56:35 +0200 - build 4742

1. Ansi-плагины, у которых ресурсы недостаточно хороши, могли не загружаться.

drkns 09.07.2016 01:21:52 +0200 - build 4741

1. И ещё один баг там же.

drkns 08.07.2016 22:07:58 +0200 - build 4740

1. Некорректная обработка backspace в local user menu.

drkns 08.07.2016 09:12:06 +0200 - build 4739

1. 0003265: Не работает "cd \ " в командной строке

drkns 06.07.2016 23:04:32 +0200 - build 4738

1. Coverity warnings.

drkns 06.07.2016 00:46:21 +0200 - build 4737

1. Рефакторинг.

drkns 03.07.2016 21:15:27 +0200 - build 4736

1. Временные файлы могли удаляться раньше времени.

drkns 03.07.2016 19:11:29 +0200 - build 4735

1. При определенных условиях мог падать поиск во вьювере.

drkns 03.07.2016 18:07:21 +0200 - build 4734

1. Рефакторинг.

drkns 02.07.2016 15:10:30 +0200 - build 4733

1. 0003261: Crash on ф: in command line

drkns 01.07.2016 01:13:59 +0200 - build 4732

1. Рефакторинг.

drkns 30.06.2016 10:25:43 +0200 - build 4731

1. Продолжение экспериментальных изменений в запускателе.

drkns 29.06.2016 21:51:02 +0200 - build 4730

1. Продолжение экспериментов:
   - вложенные вызовы FCTL_<G|S>ETUSERSCREEN можно.
   - поддержка FCTL_SETUSERSCREEN без предварительного FCTL_GETUSERSCREEN (раньше работало).

drkns 29.06.2016 09:41:59 +0200 - build 4729

1. 'Защита' от вложенных вызовов FCTL_<G|S>ETUSERSCREEN.

2. Пара мелочей.

drkns 27.06.2016 22:43:25 +0200 - build 4728

1. Продолжение экспериментальных изменений в запускателе.

drkns 27.06.2016 00:46:22 +0200 - build 4727

1. Продолжение экспериментальных изменений в запускателе.
   Должны лучше работать Ctrl-G и многострочные команды в User Menu.

shmuel 26.06.2016 16:37:24 +0200 - build 4726

1. Расширение возможностей функции Panel.SetCustomSortMode().

drkns 24.06.2016 23:19:28 +0200 - build 4725

1. С форума: при запуске программ индикатор административных прав почему-то остаётся на экране.

drkns 24.06.2016 01:39:45 +0200 - build 4724

1. Продолжение 4723 - исключение для ShiftEnter и поддержка run as.

drkns 24.06.2016 01:15:01 +0200 - build 4723

1. Очень экспериментальная фича: встроенные ассоциации распространяются на комстроку.

drkns 23.06.2016 22:46:27 +0200 - build 4722

1. Уточнение 4710.

drkns 23.06.2016 21:09:03 +0200 - build 4721

1. Новый параметр: far:config -> System.Executor.Comspec, определяет используемый командный процессор (по умолчанию %comspec%).

2. В System.Executor.ComspecArguments и System.Executor.ComspecCondition поддерживаются переменные окружения.

drkns 21.06.2016 21:33:36 +0200 - build 4720

1. Продолжение 4712.

2. gcc warning.

drkns 20.06.2016 00:20:17 +0200 - build 4719

1. Переменные в ExcludeCmds не разворачивались при использовании в автодополнении.

drkns 20.06.2016 00:15:19 +0200 - build 4718

1. #0003257: (far 3.0.4700.x64) Исключительная ситуация во Viewer при поиске HEX-значений

t-rex 19.06.2016 21:15:20 +0200 - build 4717

1. Mantis#2467: Застряёт регэксп поиск с заменой в редакторе

2. Не собиралось почему то в VC2015 update 3 (вроде баг в последнем)

drkns 18.06.2016 18:09:29 +0200 - build 4716

1. Уточнение 4715.

drkns 18.06.2016 13:55:55 +0200 - build 4715

1. С форума: неверная прорисовка часов с учетом региональных настроек.

drkns 18.06.2016 12:52:50 +0200 - build 4714

1. С форума: после копирования или переноса исчезают значки жестких ссылок на пассивной панели.

drkns 18.06.2016 11:51:33 +0200 - build 4713

1. Обход бага выхода из полноэкранного режима в Windows 10.

drkns 17.06.2016 22:38:32 +0200 - build 4712

1. Частичный откат предыдущих экспериментов с режимами консоли.

2. WindowMode расширен: добавлены два дополнительных параметра StickyX (по умолчанию true) и StickyY (по умолчанию false),
   определяющие, к каким осям должен подстраиваться размер (и где, соответственно, должны отсутствовать полосы прокрутки).

drkns 17.06.2016 17:44:53 +0200 - build 4711

1. Пара глюков WindowMode.

drkns 17.06.2016 15:12:33 +0200 - build 4710

1. Восстановим работоспособность в Win2k.

w17 16.06.2016 19:27:33 +0300 - build 4709

1. Снова уточнение 4697.
   Отслеживание переключения полноэкранного режима Win10 с настройкой консоли: [ ] Wrap text output on resize
   Восстановление оригинального размера консольного буфера при выходе
   Не должен ломаться ConEmu для System.WindowMode = false

zg 15.06.2016 22:27:05 +0200 - build 4708

1. с форума: ShiftEnd и ShiftHome в панелях тормозят.

drkns 14.06.2016 18:31:09 +0200 - build 4707

1. Системные ассоциации, у которых "associated program" - bat или cmd, запускались в отдельном окне.

drkns 13.06.2016 19:32:18 +0200 - build 4706

1. С форума: проблема с панелями Fullscreen view

zg 12.06.2016 21:04:46 +0200 - build 4705

1. после 4685 визуальные проблемы со скроллингом в редакторе мышкой.

drkns 12.06.2016 16:32:43 +0200 - build 4704

1. Ещё раз 0003254:
   - System.Executor.ComspecCondition по умолчанию пуст и используется встроенная логика (<>|& вне кавычек, как раньше).
   - используется внутренний RegExp, т. к. реализации std::regex в поддерживаемых компиляторах оставляют желать лучшего (особенно в gcc, где оно, видимо, просто для красоты).

drkns 12.06.2016 14:55:52 +0200 - build 4703

1. 0003254: Far 3.0 build 4700-4702 crashes on long file lists (!&)

drkns 11.06.2016 22:55:07 +0200 - build 4702

1. Ещё одно уточнение работы запускателя.

drkns 11.06.2016 20:05:25 +0200 - build 4701

1. Рефакторинг.

drkns 10.06.2016 23:49:57 +0200 - build 4700

1. Рефакторинг.

drkns 09.06.2016 01:50:33 +0200 - build 4699

1. Ещё раз #0003223: Добавлен параметр System.Executor.ComspecCondition, определяющий, когда команду следует запускать через comspec.

w17 08.06.2016 21:15:44 +0300 - build 4698

1. Уточнение 4697 - не пытаемся отключать Win10 full-screen, просто ничего не делаем по Alt-F9 для него.

w17 08.06.2016 17:25:01 +0300 - build 4697

1. Пытаемся нормально отрабатывать полноэкранный режим Win10.

zg 08.06.2016 15:46:48 +0200 - build 4696

1. уточнение 4676.

zg 02.06.2016 01:51:47 +0200 - build 4695

1. с форума: Если в диалоге начать записывать макрос (нажать Ctrl.), то индикатор записи макроса сразу не появляется,
   а только после нажатия дополнительной клавиши (и то не любой).

drkns 01.06.2016 22:51:16 +0200 - build 4694

1. С форума: Menu.Id в диалогах приводило к падению.

2. Не пересохраняем farmenu.ini после Alt-F4, дабы кривые файлы меню не терялись сразу же.

drkns 25.05.2016 20:16:03 +0200 - build 4693

1. При [x] Cursor at the end неадекватно работала замена в редакторе, содержащая \t.

zg 24.05.2016 13:58:55 +0200 - build 4692

1. уточнение 4685.

zg 24.05.2016 00:30:32 +0200 - build 4691

1. уточнение 4685.

drkns 23.05.2016 18:05:10 +0200 - build 4690

1. Уточнение работы запускателя.

svs 23.05.2016 15:51:37 +0300 - build 4689

1. SQLite 3.13.0

drkns 22.05.2016 21:51:25 +0200 - build 4688

1. 0003245: Падение при нажатии Shift-F2 в User Menu

2. Рефакторинг.

drkns 21.05.2016 20:30:22 +0200 - build 4687

1. По мотивам #0003244 - отображаем часы в соответствии с региональными настройками ОС.

zg 21.05.2016 11:27:47 +0200 - build 4686

1. с форума: резкое замедление работы UNDO/REDO в редакторе.

2. замедление встроенной замены после 4673.

zg 21.05.2016 04:45:34 +0200 - build 4685

1. с форума: Измеряем время исполнения CtrlAltEnd, находясь в начале файла %FARHOME%\changelog.

2. медленная работа ECTL_INSERTTEXT после 4673.

3. gcc warning.

drkns 20.05.2016 21:57:30 +0200 - build 4684

1. 0003099: В функции Menu не всегда работает флаг FMENU_CHANGECONSOLETITLE

drkns 20.05.2016 21:16:12 +0200 - build 4683

1. #0003243 Пункты user-menu, в которых вызывается .cmd начали запускаються в отдельном окне.

drkns 19.05.2016 19:03:12 +0200 - build 4682

1. Уточнение 4679.

zg 19.05.2016 18:08:09 +0200 - build 4681

1. артефакты при altf9 из комбобокса.

drkns 19.05.2016 01:35:59 +0200 - build 4680

1. Уточнение 4679.

drkns 19.05.2016 00:40:27 +0200 - build 4679

1. Продолжение экспериментов с запускателем:
   - тип запуска (консольный с ожиданием / тихий без ожидания) теперь определяется и для системных ассоциаций тоже.
   - System.Executor.BatchType больше нет, всё должно корректно работать автоматически.

zg 18.05.2016 19:37:11 +0200 - build 4678

1. при определённых условиях позиция курсора в текущей строке после ECTL_DELETESTRING была неверной.

drkns 17.05.2016 20:41:13 +0200 - build 4677

1. Рефакторинг - добавим немного const.

zg 17.05.2016 13:03:38 +0200 - build 4676

1. уточнение 4673 для ECTL_SETPOSITION.

drkns 16.05.2016 22:55:36 +0200 - build 4675

1. Ещё одно уточнение работы запускателя.

drkns 15.05.2016 22:00:35 +0200 - build 4674

1. Уточнение 4668.

zg 15.05.2016 17:37:36 +0200 - build 4673

1. убрана блокировка перерисовки окон.

zg 15.05.2016 00:33:49 +0200 - build 4672

1. с форума: символ из "бюжэхъё" не включается в быстрый поиск.

drkns 13.05.2016 00:33:18 +0200 - build 4671

1. Уточнение обработки исключений для gcc.

2. Дополнительная информация в исключениях, брошенных вручную (function, file, line).

3. Рефакторинг.

drkns 11.05.2016 23:59:21 +0200 - build 4670

1. Уточнение обработки DM_GETDIALOGINFО.

2. Warnings.

3. Убраны неиспользуемые #include.

drkns 10.05.2016 22:45:32 +0200 - build 4669

1. Немного переделан способ вывода прогресса копирования.
   По идее, должны исправиться все существующие баги с прорисовкой.
   В реальности, как обычно, возможно всё.

2. Не хватало стандартных шапок в некоторых *.hpp.

drkns 10.05.2016 18:04:22 +0200 - build 4668

1. С форума: после нажатия Enter на офисных документах в панелях Far терпеливо ждёт когда документ будет закрыт.

drkns 09.05.2016 15:17:11 +0200 - build 4667

1. clang warnings.

2. Пара мелочей.

zg 09.05.2016 14:00:08 +0200 - build 4666

1. уточнение 4638.1: Dlg.* в раскрытом комбобоксе.

zg 08.05.2016 13:27:59 +0200 - build 4665

1. уточнение 4638.1: макрообласть для комбобокса - "Dialog".

2. опубликован тип окна WTYPE_COMBOBOX. ACTL_GETWINDOWINFO в Id возвращает хэндл родительского диалога.

drkns 08.05.2016 01:12:06 +0200 - build 4664

1. Уточнение 4663.2.

2. Повысим уровень предупреждений для thirdparty-библиотек.

drkns 07.05.2016 17:45:49 +0200 - build 4663

1. Уточнение расчета общего индикатора удаления.

2. Рефакторинг.

drkns 04.05.2016 23:22:57 +0200 - build 4662

1. После 4435 не работало разворачивание переменных в диалоге создания папки.

2. Рефакторинг.

drkns 04.05.2016 10:20:21 +0200 - build 4661

1. Уточнение 4656.2.

2. Пара мелочей.

drkns 03.05.2016 16:58:07 +0200 - build 4660

1. Уточнение 4656.2.

drkns 03.05.2016 13:51:34 +0200 - build 4659

1. 0003229: Removing mounted VHDX files from the drive menu makes file locked

drkns 03.05.2016 11:28:32 +0200 - build 4658

1. 0003228: Shell команда CD не находит путь есть в конце выполняемой стоки стоит пробел

drkns 02.05.2016 19:51:44 +0200 - build 4657

1. C форума: Выполняем в комстроке FAR: notepad %FARHOME%\changelog. Получаем ошибку "The system cannot find the path specified."

2. Рефакторинг.

drkns 02.05.2016 12:23:29 +0200 - build 4656

1. 0003227: Не работает открытие папки в проводнике через Shift+Enter

2. FCTL_GETUSERSCREEN / FCTL_SETUSERSCREEN должны работать более адекватно.

3. Рефакторинг.

drkns 30.04.2016 20:54:00 +0200 - build 4655

1. 0003225: Зависание при нажатии на "крестик" консоли из модального редактора

drkns 30.04.2016 15:16:06 +0200 - build 4654

1. Продолжим чинить запускатель.

drkns 29.04.2016 19:13:57 +0200 - build 4653

1. С форума: в текущей ночной при попытке запустить команду far из комстроки far он сам себя не находит.

drkns 29.04.2016 17:31:01 +0200 - build 4652

1. Продолжение 4646 - уберём ненужные блокировки окон.

drkns 29.04.2016 16:10:52 +0200 - build 4651

1. Продолжение 4648.

drkns 29.04.2016 13:55:48 +0200 - build 4650

1. И ещё раз.

drkns 29.04.2016 10:36:00 +0200 - build 4649

1. Уточнение 4644.

drkns 29.04.2016 09:32:30 +0200 - build 4648

1. Продолжение 4631 - восстановим работоспособность System.ShowCheckingFile.

drkns 28.04.2016 19:43:18 +0200 - build 4647

1. Продолжение 4631.

drkns 28.04.2016 19:06:43 +0200 - build 4646

1. Продолжение 4631 - уберём ненужные блокировки окон.

drkns 28.04.2016 16:52:55 +0200 - build 4645

1. Уточнение 4644.

drkns 28.04.2016 16:47:33 +0200 - build 4644

1. Продолжение экспериментальных изменений в запускателе:
   - System.Executor.NotQuotedShell и System.Executor.ComSpecParams больше нет. Однако, теперь есть System.Executor.ComspecArguments, управляющий одновременно и ключами, и кавычками.
     По умолчанию значение совместимо с cmd.exe - /S /C "{0}", где {0} будет заменено исполняемой командой.
     Для bash замените на -c '{0}', для tcc - на -с {0}
   - (частично) #0003223: при передаче в comspec разворачивалось больше, чем нужно.

2. Используем std::atomic<T> вместо Interlocked*().

zg 28.04.2016 13:20:04 +0200 - build 4643

1. в комбобоксе не срабатывал хоткей для текущего элемента.

drkns 28.04.2016 10:40:27 +0200 - build 4642

1. Уточнение 4631.

drkns 26.04.2016 22:50:38 +0200 - build 4641

1. Уточнение 4635: показываем "remaining:" при копировании одного файла и обновляем его с той же частотой, что и скорость.

zg 26.04.2016 16:23:31 +0200 - build 4640

1. в диалоге копирования была возможность выбрать "Also ask on R/O files".

2. уточнение посылки DN_INPUT/DN_CONTROLINPUT для открытого комбобокса.

3. убрано странное поведение по восстановлению старой позиции в списке, если DN_LISTHOTKEY обработан.

zg 26.04.2016 03:41:23 +0200 - build 4639

1. убран неиспользуемый код.

zg 25.04.2016 23:43:02 +0200 - build 4638

1. при открытом комбобоксе не работал граббер.

2. DM_SETCOMBOBOXEVENT возвращало мусор.

drkns 24.04.2016 11:15:15 +0200 - build 4637

1. Уточнение 4633.

drkns 24.04.2016 10:02:26 +0200 - build 4636

1. Уточнение 4635.

drkns 23.04.2016 19:19:54 +0200 - build 4635

1. По просьбам телезрителей: в диалоге копирования отображаем счётчики как "%done% / %total%", а не наоборот.

2. Рефакторинг.

drkns 23.04.2016 02:03:50 +0200 - build 4634

1. С форума: lua:far.Message"aaa". После закрытия диалога заголовок консоли не восстанавливается.

drkns 23.04.2016 01:59:07 +0200 - build 4633

1. Рефакторинг.

shmuel 23.04.2016 00:03:37 +0200 - build 4632

1. Экспериментально: снятие тормозов с ECTL_INSERTSTRING (стало быстрее примерно в 50 раз).

drkns 20.04.2016 22:42:13 +0200 - build 4631

1. При вызове диалогов через главное меню не устанавливался правильный заголовок консоли.
   Да и в целом с этим заголовком творилась какая-то дичь. Многое переделано, возможны баги.

drkns 20.04.2016 17:33:13 +0200 - build 4630

1. Рефакторинг.

zg 20.04.2016 13:21:24 +0200 - build 4629

1. уточнение 4628.

zg 20.04.2016 02:44:24 +0200 - build 4628

1. убрана отложенная сортировка цветовых областей в редакторе.

w17 20.04.2016 01:39:19 +0300 - build 4627

1. Fix 4492.

drkns 19.04.2016 22:42:16 +0200 - build 4626

1. gcc build fix.

2. Refactoring.

svs 19.04.2016 18:18:01 +0300 - build 4625

1. SQLite 3.12.2

w17 19.04.2016 13:18:14 +0300 - build 4624

1. Уточнение 4622.

drkns 16.04.2016 01:21:23 +0200 - build 4623

1. Рефакторинг и переименования.

w17 14.04.2016 16:24:08 +0300 - build 4622

1. M#3183: Panel FreeInfo, TotalInfo - add options for human-readable format (e.g. "1.375 T" free space)
   Ctrl-Shift-S (M#3089) теперь влияет и на показ общего размера и свободного места в файловой панели.
   Параметр изменился Panel.Info.ShowBytes -> Panel.ShowBytes

zg 14.04.2016 00:25:20 +0200 - build 4621

1. 0003213: Время перерисовки редактора почему-то становится пропорционально размеру файла.

zg 13.04.2016 23:39:18 +0200 - build 4620

1. 0003212: Зависание при вызове ShowHelp/DialogRun после VCTL_QUIT/ECTL_QUIT.

svs 11.04.2016 10:16:53 +0300 - build 4619

1. SQLite 3.12.1

drkns 08.04.2016 16:05:19 +0200 - build 4618

1. С форума: "Где-то портится память и в результате иногда падает."

drkns 06.04.2016 23:43:12 +0200 - build 4617

1. И ещё раз.

drkns 06.04.2016 22:42:14 +0200 - build 4616

1. Fix of fix of 4564.

drkns 06.04.2016 19:41:18 +0200 - build 4615

1. С форума: ANSI плагины потеряли курсор файловой панели (4602).

drkns 06.04.2016 19:17:59 +0200 - build 4614

1. Уточнение 4425.

w17 06.04.2016 18:13:35 +0300 - build 4613

1. Fix 4564.

w17 06.04.2016 13:29:38 +0300 - build 4612

1. M#3200: Неоднообразное поведение по Ctrl+F на "нормальной папке" и на ".."
   [R]Ctrl+[[R]Alt+]F; на ".." теперь не добавляют завершающий '\'

drkns 05.04.2016 21:49:33 +0200 - build 4611

1. При определённых условиях поиск в панели плагина приводил к падению.

2. Пара мелочей.

drkns 03.04.2016 14:37:41 +0200 - build 4610

1. Ещё раз 4609.1.

2. Пара мелочей.

drkns 03.04.2016 00:05:57 +0200 - build 4609

1. С форума: "С некоторых пор описания файлов неожидано стали регистрозависимые".

drkns 31.03.2016 10:00:26 +0200 - build 4608

1. Уточнение 4603. Не показываем "?" если владелец не определён.

2. Прочий мелкий рефакторинг.

drkns 29.03.2016 19:15:04 +0200 - build 4607

1. Уточнение 4603. Возвращаем плагинам перечисленное только если оно уже считано.

drkns 27.03.2016 20:33:46 +0200 - build 4606

1. Рефакторинг.

drkns 26.03.2016 23:33:54 +0200 - build 4605

1. Уточнение 4603.

drkns 26.03.2016 21:56:52 +0200 - build 4604

1. Подавляем запросы прав при раскраске.

drkns 26.03.2016 21:16:07 +0200 - build 4603

1. Продолжим начатое в 4602. Запрашиваем дополнительную информацию о файлах тоже по мере необходимости. Это относится к:
   - количество жёстких ссылок
   - количество потоков
   - размер потоков
   - владелец
   - content data
   Это значит, что включение всего этого хозяйства не должно замедлять открытие папки, кроме случаев, когда оно является критерием сортировки.

drkns 26.03.2016 01:03:37 +0200 - build 4602

1. Раскрашиваем файлы в панели не все сразу, а по мере необходимости.
   Должно дать заметный эффект при большом количестве групп и/или файлов.

drkns 25.03.2016 10:08:48 +0200 - build 4601

1. Уточнение 4599.

drkns 25.03.2016 01:21:22 +0200 - build 4600

1. Уточнение 4574.

drkns 24.03.2016 23:40:39 +0200 - build 4599

1. 0003201: Message возвращает результат на 1 меньше ожидаемого

drkns 24.03.2016 23:04:54 +0200 - build 4598

1. Спрашиваем имя & пароль при cd \\server\share

w17 24.03.2016 20:32:59 +0300 - build 4597

1. Уточнение 4596. Вернём переключение когда Info панель неактивна.

w17 24.03.2016 17:14:32 +0300 - build 4596

1. Уточнение 4595. Переключение только при активной панели информации.

w17 24.03.2016 16:14:28 +0300 - build 4595

1. Продолжение 4590, 4594 переключение по Ctrl-Shift-S.

w17 24.03.2016 14:55:56 +0300 - build 4594

1. Продолжение 4590.
   Режим показа размера настраивается: Panel.Info.ShowBytes (default=false); переключение по Ctrl-S.

drkns 24.03.2016 02:05:31 +0200 - build 4593

1. Падение при нажатии +/- в панели информации, если там присутствовал вьювер.

drkns 23.03.2016 20:31:08 +0200 - build 4592

1. С форума: Не логичное поведение при удалении сетевого диска

w17 23.03.2016 17:59:00 +0300 - build 4591

1. M#3089: Мелкая правка в панели информации (Ctrl+L)

w17 22.03.2016 13:55:04 +0300 - build 4590

1. Продолжение 4587 -- EOPT_SHOWSCROLLBAR; VCTL_GETINFO: VOPT_SHOWxxx, VOPT_QUICKVIEW.

drkns 22.03.2016 08:27:45 +0200 - build 4589

1. Уточнение 4585.

drkns 21.03.2016 17:11:49 +0200 - build 4588

1. Macro ARRAYSIZE -> constexpr std::size

shmuel 21.03.2016 16:05:35 +0200 - build 4587

1. ECTL_GETINFO: в перечисление EDITOR_OPTIONS добавлены флаги EOPT_SHOWTITLEBAR и EOPT_SHOWKEYBAR.

drkns 21.03.2016 15:31:02 +0200 - build 4586

1. Продолжение 4584.

drkns 20.03.2016 11:57:40 +0200 - build 4585

1. Продолжение 4584.

drkns 20.03.2016 00:41:42 +0200 - build 4584

1. Убираем костыли, щедро расставленные повсеместно для поддержки VS2010 и компании.

drkns 19.03.2016 23:19:41 +0200

1. Given that our German users aren't happy with "#0003145: New German translation", I'm reverting it to the previous version.
   Only previously untranslated strings are picked from #0003145 now.

drkns 18.03.2016 18:03:45 +0200

1. Для сборки требуются VC++ 2015 / GCC 5.

drkns 18.03.2016 12:00:11 +0200 - build 4583

1. Продолжение 4582 - сортируем без расширения структуры FileListItem, которая и без того жирная.
   Кроме того, возможно, будет немного быстрее.

shmuel 17.03.2016 18:18:54 +0200 - build 4582

1. Кастомные сортировки в панелях повреждали содержимое внутренних структур FileListItem
   (это проявлялось при сборке Far с GCC 5.2 или 5.3).
   Алгоритм кастомной сортировки пришлось изменить, теперь нет прямой манипуляции с памятью.

drkns 14.03.2016 23:51:08 +0200 - build 4581

1. Вернём поведение ACTL_REDRAWALL, существовавшее до 4545.

shmuel 14.03.2016 11:39:07 +0200 - build 4580

1. При выводе на экран меню "Критерий сортировки" (CtrlF12) указатель ставится на текущую сортировку.

svs 14.03.2016 10:33:31 +0300 - build 4579

1. SQLite 3.11.1

shmuel 13.03.2016 21:45:25 +0200 - build 4578

1. Уточнение 4577.

shmuel 13.03.2016 01:35:20 +0200 - build 4577

1. В функции Panel.LoadCustomSortMode таблица параметров может включать в себя опциональное поле
   'Condition' (функцию). Данная функция может использоваться, например, в интерактивном режиме
   работы для изменения параметров сортировки, а также для её отмены.

drkns 12.03.2016 16:37:16 +0200 - build 4576

1. 0003194: Странное поведение при вставке в комстроку * и ? вплоть до падения

2. 0003195: Неверная подстановка имён файлов/каталогов с пробелами при включённой опции "Подставлять первый подходящий вариант"

3. 0003196: Автозавершение имён исполняемых файлов из %PATH% предлагается без кавычек даже для файлов с пробелами в имени

shmuel 11.03.2016 18:57:02 +0200 - build 4575

1. FCTL_GETPANELINFO выставляло значение SortMode для кастомных сортировок на 1 больше действительного.

drkns 10.03.2016 00:22:16 +0200 - build 4574

1. При вызове Menu.Show("\2qwe\n\4asd") терялись первые буквы в пунктах.

2. Из user menu выкинута прэлэстная логика превращения любого кривого hotkey в F1.

3. Уточнение 829.2 - подставляем FILE_FLAG_POSIX_SEMANTICS и для TRUNCATE_EXISTING.

4. Прочий мелкий рефакторинг.

drkns 08.03.2016 13:23:22 +0200 - build 4573

1. 0003189: Падение Far 3.0 при выставлении в формате командной строки чего-нибудь, содержащего "(%)"

2. 0003190: Не появляется список автозавершения после включения опции "Подставлять первый подходящий вариант"

drkns 05.03.2016 03:19:56 +0200 - build 4572

1. Уточнение 4568.

2. Рефакторинг.

drkns 04.03.2016 22:49:36 +0200 - build 4571

1. VC2015 build fix.

drkns 04.03.2016 22:12:43 +0200 - build 4570

1. Немного переделана работа с описаниями - теперь в файлы должно вноситься меньше изменений при обновлении.

2. Прочий рефакторинг.

drkns 03.03.2016 21:29:48 +0200 - build 4569

1. Уточнение 4568.

drkns 03.03.2016 02:14:30 +0200 - build 4568

1. Рефакторинг.

zg 01.03.2016 00:16:46 +0200 - build 4567

1. невозможно при определённых условиях прервать сканирование размера каталога в qview.

drkns 29.02.2016 22:23:24 +0200 - build 4566

1. Уточнение 4565.

drkns 28.02.2016 20:01:24 +0200 - build 4565

1. При детаче консоли (Ctrl+Shift+Tab) скопируем алиасы из старой в новую.

drkns 27.02.2016 18:05:26 +0200 - build 4564

1. Рефакторинг.

2. Немного переименований.

w17 26.02.2016 19:47:29 +0300 - build 4563

1. Experimental: M#2983: Far3, подсчёт размера папки на удалённом компе, глюк с links
   ВСЕ пройденные реальные каталоги пишутся в std::set VisitedDirs.
   Это сделано сознательно. Во-первых так не надо учитывать мнооого тонкостей, во-вторых
   если в ScanTree каталоги можно пропускать то на мой взгляд иначе просто не получится.
   Но желающие естественно всё это могут оптимизировать.

drkns 25.02.2016 18:04:48 +0200 - build 4562

1. 0003187: Symlink на сетевой каталог не работает после редактирования целевого каталога в диалоге атрибутов

svs 24.02.2016 09:40:36 +0300 - build 4561

1. SQLite 3.11.0

drkns 23.02.2016 19:46:47 +0200 - build 4560

1. 0003185: Panel in unsorted mode is showing the first file/folder as the last

drkns 20.02.2016 22:01:11 +0200 - build 4559

1. gcc build fix.

drkns 20.02.2016 21:53:30 +0200 - build 4558

1. Продолжение 4548: обрабатываем все исключения единообразно.

drkns 20.02.2016 15:56:08 +0200 - build 4557

1. Продолжение 4548: показываем более правильный стек на x86, показываем source file/line в стеке и в основном диалоге.

2. В UnquoteExternal() учтём прямой слеш тоже.

w17 20.02.2016 15:03:22 +0300 - build 4556

1. Уточнение 4523. Учтём "D:\Path Name"\ в UnquoteExternal()

drkns 20.02.2016 04:16:03 +0200 - build 4555

1. Продолжение 4548: загружаем pdb только тогда, когда нужно.

drkns 19.02.2016 21:58:30 +0200 - build 4554

1. Уточнение 4552.

2. VC2015 warning.

w17 19.02.2016 22:31:34 +0300 - build 4553

1. Уточнение 4552, восстановление сборки VS2010.

drkns 19.02.2016 00:08:34 +0200 - build 4552

1. Еще раз на тему Alt+F8 во вьювере:
   - наличие %, h, 0x etc. в строке больше не меняет запомненный режим;
   - модификатор d, указанный в справке, не работал в принципе.
     Что прелестно - он и не мог работать, т. к., например, 1234d - валидное hex-число.
     Поэтому для явного указания "это decimal" теперь используется модификатор 'm'.
   - все модификаторы (кроме %) теперь работают и для задания левой позиции.
   - в диалог добавлены кнопки Ok/Cancel.

drkns 17.02.2016 19:43:48 +0200 - build 4551

1. После 4525 текст команды в user screen отображался не тем цветом.

drkns 14.02.2016 20:45:46 +0200 - build 4550

1. Вместо "Language data is incorrect or damaged" показываем "filename.lng: language data is incorrect or damaged" дабы не гадать, что там за файл.

2. Текст во всех исключениях, унаследованных от std::exception, трактуется как UTF-8.

drkns 14.02.2016 13:00:58 +0200 - build 4549

1. Восстановим сообщение об ошибке импорта XML.

2. Latest TinyXML-2.

3. SQLite 3.10.2.

drkns 13.02.2016 16:59:45 +0200 - build 4548

1. В сообщения об исключительных ситуациях добавлена кнопка "Stack".
   Для того, чтобы она работала адекватно, нужен Far.pdb.

2. Рефакторинг.

drkns 12.02.2016 23:30:30 +0200 - build 4547

1. Уточнена логика блокирования Ctrl+F10 в редакторе/просмотре: теперь блокируется только для модальных окон.

drkns 10.02.2016 23:21:06 +0200 - build 4546

1. Рефакторинг. Немного сократим код в менеджере.

drkns 09.02.2016 22:33:44 +0200 - build 4545

1. Рефакторинг.

drkns 08.02.2016 01:30:51 +0200 - build 4544

1. После 4320 иногда неадекватно работало выделение после Ctrl-A.

drkns 07.02.2016 18:30:10 +0200 - build 4543

1. Переход к колонке по Alt-F8 во вьювере не работал, если первый параметр был указан в процентах (пример из справки).

2. Мелкий рефакторинг. %очередная мантра о том, что однобуквенные переменные плохо влияют на вашу карму%.

3. Warnings.

drkns 06.02.2016 04:01:40 +0200 - build 4542

1. 0003169: исчезают панели при запуске внешнего редактора

drkns 05.02.2016 21:26:41 +0200 - build 4541

1. Уточнение 4525.

drkns 05.02.2016 09:41:13 +0200 - build 4540

1. С форума: Пропадает курсор в запущенных внешних консольных приложениях.

drkns 03.02.2016 19:25:05 +0200 - build 4539

1. Передвинем хак для M#2922 в более подходящее место и упростим его.

w17 03.02.2016 17:48:03 +0300 - build 4538

1. Уточнение 4537.

w17 03.02.2016 16:10:50 +0300 - build 4537

1. M#2922: символьная ссылка на исполняемый файл создает отдельную консоль при запуске

drkns 03.02.2016 09:11:50 +0200 - build 4536

1. Восстановим поведение выделения в диалогах как до 4484.

drkns 02.02.2016 22:19:45 +0200 - build 4535

1. С форума: запуск far /v или far /e при включенном автосохранении сбивал настройки панелей.

drkns 02.02.2016 21:34:08 +0200 - build 4534

1. Уточнение 4525 для нетривиальных условий запуска.

drkns 02.02.2016 21:17:56 +0200 - build 4533

1. Адаптация граббера к 4526.

drkns 02.02.2016 19:55:16 +0200 - build 4532

1. С форума: в одном из билдов 4482-4484 сломался Editor.SetStr

drkns 02.02.2016 09:55:00 +0200 - build 4531

1. При удалении элемента из списка дополнения не обновлялось содержимое комстроки.

drkns 01.02.2016 23:00:10 +0200 - build 4530

1. Оптимизация 4525 для System.WindowMode = true

2. System.WindowMode теперь true по умолчанию, ибо:
   - это хорошо;
   - нужно тестирование.

w17 01.02.2016 16:53:33 +0300 - build 4529

1. M#3161: Extend GoTo (AltF8)

drkns 01.02.2016 10:34:36 +0200 - build 4528

1. Продолжение 4525.

drkns 01.02.2016 03:16:02 +0200 - build 4527

1. Продолжение 4525.

drkns 01.02.2016 01:11:06 +0200 - build 4526

1. Говорят, после 4516 странно работала средняя кнопка мыши в панелях.

drkns 31.01.2016 22:59:13 +0200 - build 4525

1. 0002900: Меню из файла-списка: проблема при вызове из User menu
   Переписана половина запускателя, исправлено множество багов, возможно, наделано новых.

2. System.Executor.SilentExternal больше нет.

3. Нажатие Enter при отключенных панелях теперь прокручивает вывод, как в cmd.

w17 29.01.2016 21:57:57 +0300 - build 4524

1. Fix 4484. aka M#3162: Исчезновение текста во вьювере

w17 29.01.2016 16:55:57 +0300 - build 4523

1. Продолжение 4521.
   Теперь "D:\Path Name"\ глобальная фича - так работает QuoteSpace().

w17 27.01.2016 23:06:51 +0300 - build 4522

1. Экспериментально: кастомизация языковых файлов без редактирования генерируемых 'родных' файлов .lng

   Чтобы работало надо:
   1) создать полные версии языковых файлов обновлённым генератором lng.generator.exe, в новой сборке должны быть.
   2) создать свой файл с изменениями для нужных языков

   Имя файла = <Оригинал>.custom, например FarRus.lng.custom, FarEng.lng.custom
   Файл ищется в %FARHOME% и %FARPROFILE% (можно создать 2 файла)

   Файл должен содержать строки вида:
   MessageId = "Modified Text"
   например:
   MListFileSize = " %1 bytes in %2 files, %3 folders "
   Нужный MessageId можно найти в оригинальном файле, там это выглядит так:
   //[MessageId]
   "Original text"
   //[MListFileSize]
   " Bytes: %1, files: %2, folders: %3 "
   Такой формат также допустим в .lng.custom файлах.
   //[MListFileSize]
   " %1 bytes in %2 files, %3 folders "

w17 26.01.2016 14:09:42 +0300 - build 4521

1. M#3011: Ctrl+Enter works wrong for ".." for case if path have spaces
   "D:\Path Name\" --> "D:\Path Name"\

drkns 26.01.2016 09:43:57 +0200 - build 4520

1. Уточнение 4516.

2. С форума: лишняя перерисовка меню ассоциаций.

drkns 26.01.2016 02:19:36 +0200 - build 4519

1. Уточнение 4516.

drkns 26.01.2016 00:15:06 +0200 - build 4518

1. С форума: При повторном просмотре файла по F3 меняется его отображение

drkns 24.01.2016 20:10:32 +0200 - build 4517

1. Пара уточнений 4516.

drkns 24.01.2016 14:35:53 +0200 - build 4516

1. При попытке открыть две info- или qview панели через главное меню Far падал.
   Причина классическая - экземпляр панели уничтожался в контексте собственных вызовов.
   Расставлять дальше delaydestroy бессмысленно, поэтому логика владения панелями переделана.
   Теперь нет кучи мутных голых указателей, ссылающихся на что попало в зависимости от погоды.
   Каждая панель - это умный указатель и живёт столько, сколько нужно.
   Возможны причудливые баги, как обычно.

2. Продолжим выносить код из panel.cpp в более подходящие места, дабы хвост поменьше крутил собакой.
   Возможны не менее причудливые баги.

3. Прочий рефакторинг.

drkns 22.01.2016 09:52:55 +0200 - build 4515

1. С форума: mf.clip(5) и mf.clip(5,0) перестали переключать буфер обмена

svs 18.01.2016 17:22:16 +0300 - build 4514

1. SQLite 3.10.1

drkns 17.01.2016 23:48:17 +0200 - build 4513

1. Рефакторинг. Код меню смены диска вынесен из panel.cpp в отдельный файл.

2. При запуске команд по Ctrl-G могло срабатывать ненужное автодополнение в комстроке.

drkns 16.01.2016 11:46:23 +0200 - build 4512

1. 0002953: When the tree3.far cache file exists, calling the tree dialog (Alt-F10) crashes Far manager
   class Panel - это просто праздник какой-то, там есть всё. Даже то, чего там быть не должно по определению.

drkns 15.01.2016 23:27:57 +0200 - build 4511

1. 0003153: Стартовать следующий сеанс грабера в режиме предыдущего (прямоугольный/поточный)

drkns 15.01.2016 10:04:34 +0200 - build 4510

1. Несистемная функция копирования некорректно обрабатывала разреженные файлы с размером блока более 4 GB.

drkns 14.01.2016 22:05:38 +0200 - build 4509

1. 0003151: Переход на новую строку при сдвиге блока граббера в поточном режиме

svs 12.01.2016 22:10:42 +0300 - build 4508

1. SQLite 3.10.0

drkns 11.01.2016 19:50:50 +0200 - build 4507

1. Продолжение 4506.1.

drkns 10.01.2016 17:18:42 +0200 - build 4506

1. В граббер добавлен режим потокового выделения. Переключается пробелом.
   При копировании в буфер производится попытка склеить разбитые свёрткой строки, корректность результата не гарантируется.

2. Из граббера можно выйти по F10.

3. Немного перевода английской справки.

4. Пара мелочей.

drkns 08.01.2016 16:54:54 +0200 - build 4505

1. 003148: При копировании нескольких строк в редакторе FAR и последующей вставке ломается содержимое

drkns 08.01.2016 14:47:08 +0200 - build 4504

1. Немного чёрной магии, чтобы VS2015 билд мог запускаться в Win2k.

drkns 04.01.2016 14:00:46 +0200 - build 4503

1. Продолжение 4502.1.

2. Уточнение 4431.

drkns 03.01.2016 21:18:13 +0200 - build 4502

1. Продолжим рефакторинг буфера обмена.

2. clip(3) и clip(4) похоже, не работали чуть менее, чем совсем.

drkns 01.01.2016 16:05:03 +0200 - build 4501

1. Распространим 4496 и на вертикальные блоки тоже.

2. Размер данных пишем всегда.

drkns 01.01.2016 15:07:30 +0200 - build 4500

1. Убрано дублирование вертикального блока в буфере обмена.

2. Рефакторинг.

zg 31.12.2015 20:03:12 +0200 - build 4499

1. падение в GetPluginDirList. возвращалась освобождённая память.

2. gcc warning.

drkns 30.12.2015 17:05:27 +0200 - build 4498

1. Продолжение 3596. Более параноидальная работа с адаптерами.

drkns 30.12.2015 10:59:13 +0200 - build 4497

1. TinyXML-2 v3.0.0.

2. Пара мелочей.

w17 29.12.2015 13:10:24 +0300 - build 4496

1. Копирование/вставка текста содержащего символ(ы) '\0' в редакторе.
   При копировании текста в буфер обмена, если в нём содержатся нулевые символы,
   создаётся дополнительный 4-х байтовый блок, куда записывается длина текста.
   Тип блока 'Notepad++ binary text length', должен быть совместим с Paste Special notepad++.

drkns 28.12.2015 17:59:08 +0200 - build 4495

1. Каталог %farlocalproflie%\PluginsData не создавался автоматически, что могло приводить к последствиям.

drkns 28.12.2015 16:32:20 +0200 - build 4494

1. Уточнение 4493.

drkns 28.12.2015 15:28:08 +0200 - build 4493

1. Рефакторинг.

w17 27.12.2015 11:08:48 +0300 - build 4492

1. M#3142: Сломана вставка текста из борландовской IDE

drkns 25.12.2015 21:54:47 +0200

1. 0003145: New German translation

drkns 22.12.2015 09:38:41 +0200 - build 4491

1. С форума: Если открыть в редакторе приложенный файл и нажать End, FAR падает.

2. #0003143: При движении стрелками в редакторе добавляются пробелы

drkns 21.12.2015 20:25:07 +0200 - build 4490

1. Рефакторинг, продолжение 4484.

drkns 21.12.2015 08:13:52 +0200 - build 4489

1. И ещё.

drkns 20.12.2015 19:10:39 +0200 - build 4488

1. И ещё.

drkns 20.12.2015 16:47:03 +0200 - build 4487

1. И ещё одно уточнение 4484.1.

drkns 20.12.2015 16:20:08 +0200 - build 4486

1. Рефакторинг, продолжение 4484.

drkns 20.12.2015 03:05:03 +0200 - build 4485

1. Уточнение 4484.1.

drkns 19.12.2015 21:59:59 +0200 - build 4484

1. Рефакторинг. Перетряхнуто много в строках ввода и, как следствие, редакторе. Возможны последствия.

2. Продолжение 4473, учтём пожелания телезрителей: кнопки вставляют новый текст в позицию курсора, а не заменяют всё.

zg 19.12.2015 14:36:32 +0200 - build 4483

1. убрана двойная конвертация INPUT_RECORD в FarKey и обратно.

drkns 19.12.2015 14:07:47 +0200 - build 4482

1. 0003137: Опечатка в выводе Far.exe -?
   На самом деле вывод правильный, ошибка в другом месте.

drkns 18.12.2015 19:39:04 +0200 - build 4481

1. И ещё одно уточнение 4473.

w17 18.12.2015 13:24:46 +0300 - build 4480

1. Experimental: M#1910: "Add to archive" hotkey does not work in Temporary Panel.

drkns 17.12.2015 21:32:47 +0200 - build 4479

1. Уточнение 4473: Selection при отсутствии блока берёт всю строку.

drkns 17.12.2015 20:56:42 +0200 - build 4478

1. User menu, состоящее из одних разделителей (коварство пользователей не знает границ), приводило к AV.

zg 16.12.2015 22:53:06 +0200 - build 4477

1. assert при вводе alt-65536 в редакторе.

drkns 16.12.2015 20:53:34 +0200 - build 4476

1. И ещё одно уточнение 4473.

drkns 16.12.2015 19:48:28 +0200 - build 4475

1. Продолжение 4473, учтём пожелания телезрителей.

drkns 16.12.2015 11:48:50 +0200 - build 4474

1. Уточнение 4473.

drkns 16.12.2015 00:42:39 +0200 - build 4473

1. Опция Editor settings - [x] Pick up the word удалена.
   Вместо неё теперь кнопки [ Word ] и [ Selection ] прямо в диалоге поиска, вставляющие в строку то, что на них написано.
   Selection берёт только первую строку блока. При отсутствии блока берёт слово.

2. DlgBuilder неправильно рассчитывал вертикальные координаты при наличии двух колонок разной высоты.

3. Рефакторинг.

drkns 12.12.2015 18:50:14 +0200

1. Весь исходный код теперь в utf-8.

2. Добавим include guards в *.hpp, т.к. gcc не может в #pragma once в файлах с BOM. /o

drkns 12.12.2015 15:41:11 +0200 - build 4472

1. С форума: Если убрать типы дисков (Ctrl-1), то не будет убирать subst диск кнопкой del.

drkns 11.12.2015 22:58:53 +0200 - build 4471

1. 0003131: Пропадают галочки напротив отмеченных в меню "Используя кодовую страницу" кодировок

drkns 11.12.2015 22:02:06 +0200 - build 4470

1. С форума: если в строке поиска была задана только одна группа, то в строке замены следует считать метасимоволами подстроки до $1

drkns 11.12.2015 21:24:01 +0200 - build 4469

1. Падение при замене с регексами.

drkns 09.12.2015 20:28:43 +0200 - build 4468

1. debug & gcc.

2. syslog & gcc.

drkns 08.12.2015 00:25:17 +0200 - build 4467

1. Рефакторинг.

2. Еще немного на тему 4461.

shmuel 07.12.2015 21:04:04 +0200 - build 4466

1. M#3129: Несколько строк склеивается в одну

drkns 07.12.2015 21:03:09 +0200 - build 4465

1. Уточнение 4461.

drkns 04.12.2015 00:24:07 +0200 - build 4464

1. Рефакторинг.

2. Warnings.

3. GCC build fix.

drkns 01.12.2015 20:24:11 +0200 - build 4463

1. Вернём workaround для бага в kernel32::GetFinalPathNameByHandleW, потерянный в 2155.

drkns 30.11.2015 22:18:30 +0200 - build 4462

1. Рефакторинг.

2. Ukrainian translation from Vlad Lozynskyi.

drkns 27.11.2015 13:40:00 +0200 - build 4461

1. 0003124: Не восстанавливает постоянные сетевые соединения при запуске от имени другого пользователя.

drkns 26.11.2015 08:49:29 +0200 - build 4460

1. Уточнение 4459.

drkns 23.11.2015 21:40:04 +0200 - build 4459

1. Рефакторинг.

drkns 21.11.2015 02:26:19 +0200 - build 4458

1. В некотрых случаях при выделении слов в редакторе кликами мыши могло получаться несколько выделенных блоков.

shmuel 17.11.2015 14:41:37 +0200 - build 4457

1. Функция FSF.FarInputRecordToName при некоторых значениях своего первого аргумента могла
   не возвращаться, покуда не поступит ввод от консоли.

drkns 15.11.2015 11:59:17 +0200 - build 4456

1. Продолжение 4455.

drkns 15.11.2015 01:37:43 +0200 - build 4455

1. Оказывается, Far уже можно полноценно собрать в clang. Немного связанной с этим реорганизации в препроцессорных макросах.

svs 07.11.2015 00:28:32 +0300 - build 4454

1. SQLite 3.9.2

drkns 01.11.2015 19:04:35 +0200 - build 4453

1. Рефакторинг, предупреждения VS15 и прочие мелочи.

drkns 01.11.2015 18:59:48 +0200 - build 4452

1. Задел на будущее: разломаем FindFiles на два отдельных класса: интерфейс и непосредственно поиск.

drkns 31.10.2015 13:07:10 +0200 - build 4451

1. 0003077: Exception при поиске в альтернативных потоках

shmuel 28.10.2015 19:12:06 +0200 - build 4450

1. Мелкий рефакторинг в макросистеме.

w17 27.10.2015 19:36:48 +0300 - build 4449

1. Продолжение 4448. Не падаем в обработчике STACK_OVERFLOW, minidump покажет корректное место переполнения стека.

w17 27.10.2015 17:39:42 +0300 - build 4448

1. Experimental: Кнопка записи минидампа (%FARPROFILE%\Far.mdmp) при обработке SEHException.

drkns 27.10.2015 01:26:44 +0200 - build 4447

1. 0003026: FindFiles access violation exception

drkns 26.10.2015 09:25:44 +0200 - build 4446

1. Формат статусной строки вынесен в lng.

drkns 24.10.2015 11:59:47 +0200 - build 4445

1. 0003053: Раскраска файлов с >1 хардлинком замедляет панели на сетевых дисках
   Добавлена проверка имени FS для тех ОС, которые не умеют FILE_SUPPORTS_HARD_LINKS.

drkns 24.10.2015 02:29:09 +0200 - build 4444

1. 0002520: Неправильный текст системной ошибки

2. 0003089: Мелкая правка в панели информации (Ctrl+L) (частично).

drkns 24.10.2015 01:21:54 +0200 - build 4443

1. Немного переименований для исправления предупреждений VS2015.

drkns 24.10.2015 00:04:08 +0200 - build 4442

1. С форума: показываем число папок в текущей панели.

2. Warnings.

w17 20.10.2015 16:21:53 +0300 - build 4441

1. M#3100: Crash on search in invalid ZIP archive
   Симптоматическое лечение.

svs 19.10.2015 10:31:45 +0300 - build 4440

1. SQLite 3.9.1

drkns 18.10.2015 13:18:18 +0200 - build 4439

1. В редакторе некорректно обрабатывались переводы строк для кодовых страниц, где они отличны от 0x0d / 0x0a (EBCDIC etc.)

drkns 17.10.2015 14:35:10 +0200 - build 4438

1. Рефакторинг.

svs 16.10.2015 12:33:02 +0300 - build 4437

1. Mantis#0003062: FSF.CopyToClipboard+FCT_COLUMN рассинхронизирует буфер обмена
   Для FCT_STREAM юзается SetClipboard, которая самостоятельно очищает буфер.
   Для FCT_COLUMN юзается SetClipboardFormat(FCF_VERTICALBLOCK_UNICODE), которая не очищает буфер, а добавляет туда данные. Соответственно OEM остается нетронутым.

   <АХТУНГ!>
   	SetClipboardFormat просто добавляет к существующему содержимому данные по вертикальному блоку.
   </АХТУНГ!>

svs 15.10.2015 16:40:58 +0300 - build 4436

1. Mantis#0003061: FSF.CopyToClipboard + FCT_COLUMN: вертикальные блоки, совместимые со сторонними приложениями
   Поддержка вертикальных блоков "Borland IDE Block Type" и "MSDEVColumnSelect" наравне с "FAR_VerticalBlock_Unicode".

   Новые типы в клипборд Far добавляет только при копировании вертикального блока.
   В клипборде:
     "FAR_VerticalBlock_Unicode" "родной" фаровский блок
     "Borland IDE Block Type" блок содержит 1 байт и равен 0x02
     "MSDEVColumnSelect"      блок содержит 0 байт.
     Сами данные содержатся в "CF_UNICODETEXT".

   При вставке в редактор Far знает про эти блоки и вставляет вертикальный блок.

svs 15.10.2015 13:15:19 +0300 - build 4435

1. Mantis#0003070: DI_EDIT+DIF_EDITEXPAND: переменные разворачиваются преждевременно
   "Разворот" будет только если диалоговая процедура вернула TRUE.

svs 14.10.2015 17:41:39 +0300 - build 4434

1. SQLite 3.9.0

2. Mantis#0003033: Дефект при отрисовке рамки в DI_TEXT+DIF_SEPARATORUSER

drkns 12.10.2015 18:26:07 +0200 - build 4433

1. Ещё одно уточнение 4431.

w17 12.10.2015 14:00:11 +0300 - build 4432

1. уточнение 4431.

drkns 11.10.2015 16:04:27 +0200 - build 4431

1. Рефакторинг.

drkns 02.10.2015 09:36:40 +0200 - build 4430

1. 0003080: Alternate editor/viewer in FindFile results: temporary files will be deleted on FindFile closing. This should give enough time for external editor to open temporary file.

drkns 29.09.2015 21:44:11 +0200 - build 4429

1. С форума: "Что-то случилось с сообщениями при удалении сетевого диска после 4424"

2. В подтверждение отключения subst-диска добавлено отображение пути.

3. Пара мелочей.

drkns 29.09.2015 09:06:03 +0200 - build 4428

1. gcc build fix

2. Рефакторинг.

drkns 26.09.2015 21:44:35 +0200 - build 4427

1. 0003093: Не закрывается по нажатию Esc диалог "Диск" (Alt-F1,Alt-F2), если текущая папка в панели - UNC

2. Рефакторинг.

drkns 24.09.2015 22:50:09 +0200 - build 4426

1. Не теряем уже введённый текст при прокрутке истории в комстроке.

2. Рефакторинг.

3. Warnings.

drkns 23.09.2015 02:45:20 +0200 - build 4425

1. Рефакторинг.

drkns 21.09.2015 19:19:19 +0200 - build 4424

1. Уточнение 4423.1.

drkns 18.09.2015 22:40:33 +0200 - build 4423

1. Теперь мы умеем и //вот/такие/пути тоже.

2. GCC build fix

3. Рефакторинг.

drkns 17.09.2015 22:04:20 +0200 - build 4422

1. Рефакторинг.

drkns 17.09.2015 20:59:50 +0200 - build 4421

1. Уточнение и упрощение логики автообновления переменных окружения.

svs 17.09.2015 19:11:41 +0300 - build 4420

1. Уточнение build 4419 в соответствии с заложенной логикой (описано в хелпе)

svs 17.09.2015 19:04:05 +0300 - build 4419

1. Mantis#0003078: Редактор конфигурации *помечает некоторые параметры как изменённые даже в новом профиле
   Только про "System.CopyBufferSize".


svs 10.09.2015 10:31:11 +0300 - build 4418

1. Mantis#0003055: Отсутствие ID'а у "диалога удаления файлов", невозможность проверки.

    DeleteWipeId                     = {9C054039-5C7E-4B04-96CD-3585228C916F}  --> Dlg.Id
    Основной диалог уничтожения файлов/папок

    DeleteRecycleId                  = {85A5F779-A881-4B0B-ACEE-6D05653AE0EB}  --> Dlg.Id
    Основной диалог удаления файлов/папок в корзину

    DeleteFileFolderId               = {85A5F779-A881-4B0B-ACEE-6D05653AE0EB}  --> Dlg.Id
    Основной диалог удаления файлов/папок

    Дальше разнообразные предупреждения по теме удаления/уничтожения:

    DeleteLinkId                     = {B1099BC3-14BD-4B22-87AC-44770D4189A3}  --> Dlg.Id
    Диалог "Удаление ссылки"

    DeleteFolderId                   = {4E714029-11BF-476F-9B17-9E47AA0DA8EA}  --> Dlg.Id
    Диалог удаления папки
    (System.DeleteToRecycleBin = fasle)

    DeleteFolderRecycleId            = {A318CBDC-DBA9-49E9-A248-E6A9FF8EC849}  --> Dlg.Id
    Диалог удаления папки в корзину
    (System.DeleteToRecycleBin = true)

    WipeFolderId                     = {E23BB390-036E-4A30-A9E6-DC621617C7F5}  --> Dlg.Id
    Диалог уничтожения папки

    DeleteAskDeleteROId              = {8D4E84B3-08F6-47DF-8C40-7130CD31D0E6}  --> Dlg.Id
    Подтверждение удаления ReadOnly-файла

    DeleteAskWipeROId                = {6792A975-57C5-4110-8129-2D8045120964}  --> Dlg.Id
    Подтверждение уничтожения ReadOnly-файла

    WipeHardLinkId                   = {5297DDFE-0A37-4465-85EF-CBF9006D65C6}  --> Dlg.Id
    Диалог-предупреждение об уничтожении файла с несколькими хардлинками

    RecycleFolderConfirmDeleteLinkId = {26A7AB9F-51F5-40F7-9061-1AE6E2FBD00A}  --> Dlg.Id
    Предупреждение о том, что папка содержит символические ссылки и при очистке корзины
    данные будут потеряны и нужно разорвать связи (см. MRecycleFolderConfirmDeleteLink?)

    CannotRecycleFileId              = {52CEB5A5-06FA-43DD-B37C-239C02652C99}  --> Dlg.Id
    Не удалось удалить файл в корзину

    CannotRecycleFolderId            = {BBD9B7AE-9F6B-4444-89BF-C6124A5A83A4}  --> Dlg.Id
    Не удалось удалить папку в корзину


svs 08.09.2015 17:50:24 +0300 - build 4417

1. Mantis#0002905: Присвоить гуид диалогу Apply command (CtrlG)

    ApplyCommandId                   = {044EF83E-8146-41B2-97F0-404C2F4C7B69}  --> Dlg.Id
    Диалог "Применить команду" (CtrlG)


w17 08.09.2015 16:09:18 +0300 - build 4416

1. Уточнение 4414 -typo

w17 08.09.2015 12:29:00 +0300 - build 4415

1. Продолжение 4392, 4394 (M#2951)
   Убираем следы дерева из меню команд и кейбара.

svs 07.09.2015 16:06:23 +0300 - build 4414

1. Mantis#0003084: Добавить GUIDs

    DescribeFileId                   = {D8AF7A38-8357-44A5-A44B-A595CF707549}  --> Dlg.Id
    Диалог ввода описаний (CtrlZ)

    SelectDialogId                   = {29C03C36-9C50-4F78-AB99-F5DC1A9C67CD}  --> Dlg.Id
    Диалог установки выделения файлов (Add)

    UnSelectDialogId                 = {34614DDB-2A22-4EA9-BD4A-2DC075643F1B}  --> Dlg.Id
    Диалог снятия выделения файлов (Subtract)

    SUBSTDisconnectDriveError1Id     = {FF18299E-1881-42FA-AF7E-AC05D99F269C}  --> Dlg.Id
    SUBSTDisconnectDriveError2Id     = {43B0FFC2-70BE-4289-91E6-FE9A3D54311B}  --> Dlg.Id
    Диалоги ошибок удаления SUBST-дисков

    RemoteDisconnectDriveError1Id    = {C9439386-9544-49BF-954B-6BEEDE7F1BD0}  --> Dlg.Id
    RemoteDisconnectDriveError2Id    = {F06953B8-25AA-4FC0-9899-422FC1D49F7A}  --> Dlg.Id
    Диалоги ошибок отключения Net-дисков

    EjectHotPlugMediaErrorId         = {D6DC3621-877E-4BE2-80CC-BDB2864CE038}  --> Dlg.Id
    Диалог ошибки отключения "флешек"

    VHDDisconnectDriveErrorId        = {B890E6B0-05A9-4ED8-A4C3-BBC4D29DA3BE}  --> Dlg.Id
    Диалог ошибки отключения виртуальных дисков

    ChangeDriveCannotReadDiskErrorId = {F3D46DC3-380B-4264-8BF8-10B05B897A5E}
    Диалог ошибки смены диска


drkns 04.09.2015 21:47:21 +0200 - build 4413

1. Рефакторинг.

shmuel 04.09.2015 13:40:29 +0200 - build 4412

1. M#3083: Контент-колонка не обновляется при переключении режимов панели

drkns 02.09.2015 21:13:07 +0200 - build 4411

1. 0003080: Alternate editor/viewer in FindFile results

drkns 29.08.2015 00:46:04 +0200 - build 4410

1. Refactoring

2. VC2015 warnings

3. Whole program optimization in VC Release builds

w17 15.08.2015 10:46:45 +0300 - build 4409

1. Уточнение 4408

w17 15.08.2015 00:24:24 +0300 - build 4408

1. M#281: Автоподстановка переменных среды не позволяет работать с путями вида C:\%AppData%

drkns 14.08.2015 22:33:52 +0200 - build 4407

1. 0003056: При отметке файлов левой панели - "портится" разделитель панелей

zg 31.07.2015 15:36:58 +0200 - build 4406

1. с форума: ищу файлы (маска любая), из найденных выбираю любой, находящийся не в текущей папке,
   и жму на нём F4. Если в открывшемся редакторе нажать Ctrl-F10, то отобразятся панели.

svs 30.07.2015 00:03:25 +0300 - build 4405

1. SQLite 3.8.11.1

drkns 29.07.2015 23:25:17 +0200 - build 4404

1. Не сортируем файлы описаний при изменении.

drkns 28.07.2015 23:15:06 +0200 - build 4403

1. Рефакторинг.

svs 28.07.2015 11:24:22 +0300 - build 4402

1. SQLite 3.8.11

shmuel 11.07.2015 02:20:25 +0200 - build 4401

1. M#3019: Number of custom columns is limited to 10 for plugin
   -> Now it is limited to 100 (C0...C99).

drkns 09.07.2015 00:39:19 +0200 - build 4400

1. Рефакторинг.

drkns 05.07.2015 19:19:57 +0200 - build 4399

1. Рефакторинг.

drkns 04.07.2015 21:54:54 +0200 - build 4398

1. После 4394.1 падал диалог поиска в некоторых сценариях.
   Сюда же - убедительная просьба не использовать одно- и двухбуквенные имена переменных в коде для чего бы то ни было, кроме индексов.

drkns 02.07.2015 23:37:09 +0200 - build 4397

1. С форума: Странное поведение поиска F7/Shift-F7 в редактировании

2. Warnings.

zg 28.06.2015 02:50:26 +0200 - build 4396

1. ACTL_SETCURRENTWINDOW, VCTL_QUIT и ECTL_QUIT выполняются сразу.

2. ACTL_COMMIT ничего не делает и оставлена для совместимости.

w17 26.06.2015 18:43:53 +0300 - build 4395

1. Косметика.

w17 25.06.2015 13:28:40 +0300 - build 4394

1. В диалогах элементы с флагами DIF_CENTERGROUP|DIF_HIDDEN не должны занимать место.

2. Продолжение 4392 -- при отключении дерева его пункты в меню и кнопки в диалогах теперь не показываются.

3. Новый параметр far:config -- Editor.NewFileUnixEOL
   Если задать значение True, во вновь создаваемых файлах будут использоваться юниксовые концы строк <LF>.

drkns 24.06.2015 22:13:33 +0200 - build 4393

1. Рефакторинг.

w17 15.06.2015 16:31:15 +0300 - build 4392

1. M#2951: Выкинуть все связанное с построением дерева каталогов из far3
   Пока не выкидываем, просто по-умолчанию отключаем.
   Для ценителей дерева можно через far:config сделать Panel.Tree.TurnOffCompletely = False.

drkns 09.06.2015 00:59:20 +0200 - build 4391

1. В меню дополнения клик мыши работал не так, как нажатие Enter.

drkns 06.06.2015 23:50:38 +0200 - build 4390

1. Более корректное решение для 4388.

drkns 05.06.2015 00:28:50 +0200 - build 4389

1. Уточнение 4387.3.

drkns 04.06.2015 23:42:07 +0200 - build 4388

1. VC10.

drkns 04.06.2015 21:34:47 +0200 - build 4387

1. Более параноидальные настройки предупреждений для gcc.

2. В какой-то из предыдущих версий была погнута проверка наличия определённых функций в ОС. Могло аукаться в неожиданных местах.

3. Рефакторинг.

zg 03.06.2015 21:49:26 +0200 - build 4386

1. 0003001: В ночных сборках сломалась работа скрипта BookmarkManager.

drkns 03.06.2015 20:24:43 +0200 - build 4385

1. 0003000: проблема копирования экрана с ключом /ag

zg 29.05.2015 23:39:54 +0200 - build 4384

1. 0002997: Improper sorting after Compare Folders.

zg 29.05.2015 19:12:18 +0200 - build 4383

1. на чистом профиле FARLANG устанавливается в пустое значение.

svs 21.05.2015 07:33:01 +0300 - build 4382

1. SQLite 3.8.10.2

drkns 18.05.2015 22:39:06 +0200 - build 4381

1. Warnings mix:
   - для vc подавление предупреждений вынесено в отдельный файл
   - -Wextra для gcc.

2. Рефакторинг.

zg 16.05.2015 04:38:48 +0200 - build 4380

1. 0002994: GUID для диалогов в User Menu, вызываемых посредством !?<title>?<init>!.

drkns 15.05.2015 21:52:32 +0200 - build 4379

1. Уточнение 4376.

2. Пара мелочей.

drkns 15.05.2015 00:03:45 +0200 - build 4378

1. Рефакторинг.

drkns 14.05.2015 08:41:28 +0200 - build 4377

1. Уточнение 4364.

drkns 14.05.2015 00:00:00 +0200 - build 4376

1. Рефакторинг.

zg 10.05.2015 02:14:51 +0200 - build 4375

1. 0002991: Dynamic selection mark in panels.

svs 09.05.2015 23:17:24 +0300 - build 4374

1. SQLite 3.8.10.1

drkns 08.05.2015 18:51:45 +0200 - build 4373

1. Ошибка в вычислении размера файла при копировании с учётом ADS.

drkns 08.05.2015 01:29:05 +0200 - build 4372

1. 0002990: Viewer crashed if opened from temporary editor

svs 07.05.2015 20:33:44 +0300 - build 4371

1. SQLite 3.8.10

drkns 07.05.2015 16:23:58 +0200 - build 4370

1. В диалоге прогресса копирования отображается количество обработанных байт.

drkns 06.05.2015 22:16:11 +0200 - build 4369

1. И ещё раз.

drkns 06.05.2015 20:26:51 +0200 - build 4368

1. И ещё раз.

drkns 06.05.2015 17:29:36 +0200 - build 4367

1. Пара уточнений 4366.

drkns 06.05.2015 16:39:28 +0200 - build 4366

1. С форума: Авто-дополнение переменных окружения в ком. строке

2. far:config: опция Editor.WordDiv переименована в System.WordDiv.

3. Рефакторинг.

drkns 04.05.2015 14:51:59 +0200 - build 4365

1. Уточнение 4364.

drkns 04.05.2015 14:42:35 +0200 - build 4364

1. С форума: Падение в редакторе при вызове замены текста при [x] Pick up the word
   Попутно немного переделана логика поиска слова в строке.

drkns 01.05.2015 21:11:56 +0200 - build 4363

1. Рефакторинг.

zg 30.04.2015 01:15:07 +0200 - build 4362

1. рефакторинг: обработка нажатий клавиш.

drkns 26.04.2015 13:40:02 +0200 - build 4361

1. Продолжение 4356.

drkns 26.04.2015 03:26:55 +0200 - build 4360

1. Уточнение 4356.

drkns 26.04.2015 01:04:53 +0200 - build 4359

1. Продолжение 4356.

zg 26.04.2015 00:40:10 +0200 - build 4358

1. уточнение 4353.2: Отпускание модификатора может быть воспринято как BreakKey для меню.

drkns 25.04.2015 23:44:26 +0200 - build 4357

1. Уточнение 4356.

drkns 25.04.2015 22:27:47 +0200 - build 4356

1. Рефакторинг.

zg 23.04.2015 12:54:15 +0200 - build 4355

1. уточнение 4352 для FarInputRecordToName.

zg 23.04.2015 02:01:09 +0200 - build 4354

1. уточнение 4345: не работал xlat в редакторе.

zg 22.04.2015 21:26:13 +0200 - build 4353

1. DM_SETMOUSEEVENTNOTIFY переименована в DM_SETINPUTNOTIFY.

2. в DN_INPUT теперь приходят все события консоли.

zg 22.04.2015 14:23:46 +0200 - build 4352

1. уточнение 4337: фар реагирует на отжатия модификаторов.

drkns 15.04.2015 22:47:32 +0200 - build 4351

1. 0002872: Не ломать кодовую страницу файла FarMenu.ini

2. Связанный с #1 рефакторинг.

w17 14.04.2015 15:03:44 +0300 - build 4350

1. Откат 4324+, невостребованная фича.

drkns 13.04.2015 14:09:29 +0200 - build 4349

1. В истории могли дублироваться элементы (баг в sqlite_unicode.c)

zg 13.04.2015 13:27:28 +0200 - build 4348

1. уточнение 4337: ralt не включает фильтр в меню.

drkns 13.04.2015 10:40:22 +0200 - build 4347

1. Уточнение 4309.

drkns 13.04.2015 09:52:11 +0200 - build 4346

1. Уточнение 4345.

drkns 12.04.2015 22:26:53 +0200 - build 4345

1. Рефакторинг.

drkns 12.04.2015 21:02:09 +0200 - build 4344

1. По мотивам http://forum.farmanager.com/viewtopic.php?f=9&t=9034:
   - Экспериментально: добавлена поддержка юникода в SQLite, работа с базами теперь может вестись регистронезависимо.
   - Запоминание позиции в просмотре/редакторе производится регистронезависимо.
   - Для того, чтобы это работало адекватно, history.db надо удалить, или, если жалко, обновить по инструкции в вышеуказанном топике.
   - Если это актуально ещё где-то, кроме запоминания позиций в просмотре/редакторе - пишите.

zg 12.04.2015 19:46:28 +0200 - build 4343

1. уточнение 4332: смена кодировки в редакторе.

drkns 12.04.2015 15:18:07 +0200 - build 4342

1. С форума: падение при far /import

2. Рефакторинг.

drkns 11.04.2015 23:04:41 +0200 - build 4341

1. Рефакторинг.

2. Warnings.

zg 10.04.2015 13:29:09 +0200 - build 4340

1. уточнение 4337: сбрасывалось выделение при редактировании.

2. нажатие numlock, capslock, scrolllock снимало признак неизменённости в полях ввода.

3. gcc warnings.

zg 10.04.2015 01:25:50 +0200 - build 4339

1. при ненулевом FarDialogItem.MaxLength некорректно инициализировался элемент диалога.

svs 09.04.2015 06:54:08 +0300 - build 4338

1. SQLite 3.8.9

zg 09.04.2015 03:05:55 +0200 - build 4337

1. изолирована обработка нажатия CtrlAltShift.

drkns 05.04.2015 19:07:30 +0200 - build 4336

1. Рефакторинг. Немного переименований и перенос некоторых функций.

drkns 03.04.2015 20:55:27 +0200 - build 4335

1. 0002980: Неисправности в меню "Code pages".

zg 03.04.2015 14:10:08 +0200 - build 4334

1. уточнение 4330.

zg 03.04.2015 13:55:43 +0200 - build 4333

1. уточнение 4332.

zg 03.04.2015 02:57:53 +0200 - build 4332

1. 0002979: Редактирование любых файлов без потерь в режиме UTF-8.

drkns 02.04.2015 23:15:07 +0200 - build 4331

1. Рефакторинг.

2. Из меню дополнения в комстроке не вызывалось меню плагинов.

zg 02.04.2015 16:15:43 +0200 - build 4330

1. с форума: Получить содержимое ком. строки плагином из юзер меню.

w17 01.04.2015 20:26:38 +0300 - build 4329

1. Некорректно работал поиск по словам Find file, если слово попадало ровно на конец блока.

shmuel 29.03.2015 20:49:04 +0200 - build 4328

1. Уточнение 4261.

drkns 28.03.2015 16:51:12 +0200 - build 4327

1. Рефакторинг.

w17 26.03.2015 13:57:16 +0300 - build 4326

1. Уточнение 4324

w17 26.03.2015 13:51:15 +0300 - build 4325

1. Уточнение 4324

w17 25.03.2015 13:23:12 +0300 - build 4324

1. Experimental: Продолжение 3717 (M#2208: Запоминать, в какой папке была запущена команда).
   Новый параметр конфигурации System.PerFolderCmdHistory.
   Умолчание = false, если true - в историю записываюся одинаковые команды
   если каталоги запуска отличаются. В стандартной истории фар дубли команд не показываются.

drkns 21.03.2015 16:50:29 +0200 - build 4323

1. Копирование текста из полей ввода могло вызывать ассерты.

zg 21.03.2015 16:47:45 +0200 - build 4322

1. удалена пасхалка от валентина. если, например, в командной строке ввести магический набор букв:
   lua:far.InputRecordToName ({EventType=far.Flags.KEY_EVENT,KeyDown=true,RepeatCount=1,VirtualKeyCode=45,VirtualScanCode=82,UnicodeChar=0,ControlKeyState=258})
   вызывался граббер.

zg 21.03.2015 00:32:43 +0200 - build 4321

1. событие FARMACRO_KEY_EVENT удалено.

2. временное уточнение 4318 для нажатий shift/alt/ctrl.

drkns 20.03.2015 09:36:40 +0200 - build 4320

1. Продолжение 4309.

drkns 19.03.2015 22:55:49 +0200 - build 4319

1. Уточнение 4280.

zg 19.03.2015 19:12:19 +0200 - build 4318

1. рефакторинг: обработка нажатий клавиш.

w17 19.03.2015 13:08:26 +0300 - build 4317

1. M#2971: Падение при использовании регулярного выражения с большим количеством групп

zg 19.03.2015 00:34:46 +0200 - build 4316

1. рефакторинг: обработка нажатий клавиш.

drkns 18.03.2015 22:06:40 +0200 - build 4315

1. Продолжение 4309.

zg 18.03.2015 16:13:08 +0200 - build 4314

1. уточнение 4309: по ctrla в редакторе выделялся блок неопределённого типа.

zg 18.03.2015 15:36:39 +0200 - build 4313

1. уточнение 4305: в ProcessEditorInputW перестали приходить сообщения об отпускании клавиш.

drkns 18.03.2015 08:59:33 +0200 - build 4312

1. В некоторых случаях не инициализировались объекты синхронизации.

drkns 18.03.2015 08:18:21 +0200 - build 4311

1. Уточнение 4309.

drkns 17.03.2015 23:32:39 +0200 - build 4310

1. 0002970: Случаи необновления заголовка окна

drkns 17.03.2015 22:42:42 +0200 - build 4309

1. Продолжаем ломать редактор. Возможны сказочные баги.

zg 17.03.2015 18:48:44 +0200 - build 4308

1. уточнение 4306.

drkns 17.03.2015 09:46:47 +0200 - build 4307

1. 0002969: В ProcessViewerEventW не приходят сообщения о закрытии QuickView

zg 17.03.2015 00:30:18 +0200 - build 4306

1. с форума: проблемы с EF_OPENMODE_USEEXISTING.

zg 15.03.2015 03:02:46 +0200 - build 4305

1. в ProcessEditorInput не посылаются псевдоклавиши KEY_IDLE и KEY_NONE.

w17 12.03.2015 17:40:22 +0300 - build 4304

1. Уточнение 4302.

drkns 11.03.2015 20:07:31 +0200 - build 4303

1. Уточнение 4298.

w17 11.03.2015 15:50:45 +0300 - build 4302

1. Устранение запроса повышения привилегий при посмотре файла на флэшке с NTFS под Win Server 2008 R2 SP1

w17 11.03.2015 13:20:04 +0300 - build 4301

1. Уточнение 4279.

drkns 09.03.2015 23:54:31 +0200 - build 4300

1. Уточнение 4298.

zg 09.03.2015 20:27:35 +0200 - build 4299

1. опечатка в 4298.

drkns 09.03.2015 19:35:06 +0200 - build 4298

1. Рефакторинг.

shmuel 09.03.2015 19:09:39 +0200 - build 4297

1. M#2966: Неправильная вставка вертикального блока в конце файла.

drkns 09.03.2015 16:57:18 +0200 - build 4296

1. Уточнение 4294.

shmuel 09.03.2015 00:15:32 +0200 - build 4295

1. M#2965: При вставке вертикального блока усекаются последние символы в каждой строке.

drkns 08.03.2015 19:08:46 +0200 - build 4294

1. Рефакторинг.

drkns 08.03.2015 10:38:08 +0200 - build 4293

1. 0002963: Падение Фара при открытии файла в неверной кодировке

2. Пара "уточнений".

drkns 08.03.2015 03:59:24 +0200 - build 4292

1. В GCC некорректно (точнее, слишком корректно) работали fsf.sprintf/fsf.snprintf.

2. CoUninitialize вызывалась раньше чем нужно.

drkns 05.03.2015 23:52:10 +0200 - build 4291

1. Рефакторинг.

2. В одном из предыдущих билдов отвалился вызов CoInitializeEx.

zg 05.03.2015 12:02:34 +0200 - build 4290

1. всегда грузим плагины через LoadLibrary*, чтобы увеличить счётчик ссылок на длл.

zg 05.03.2015 05:31:29 +0200 - build 4289

1. уточнение 4248: во враппере оставим старое поведение DM_SETTEXT.

zg 05.03.2015 03:31:02 +0200 - build 4288

1. 0002959: FCTL_SETPANELDIRECTORY перерисовывает экран когда не надо.

drkns 04.03.2015 02:57:17 +0200 - build 4287

1. Уточнение 4280.2.

drkns 03.03.2015 22:47:29 +0200 - build 4286

1. 0002957: Undo отменяет добавленную строку, но после сохранения файла она остаётся

2. Раскрываем главное меню в том числе и по стрелке вверх.

drkns 02.03.2015 22:15:32 +0200 - build 4285

1. Уточнение 4280.1.

drkns 01.03.2015 16:17:34 +0200 - build 4284

1. При определённых манипуляциях с QuickView могло происходить странное.

zg 01.03.2015 13:12:22 +0200 - build 4283

1. 0002956: Падение Фара на старте после выхода с панелью быстрого просмотра.

drkns 01.03.2015 02:12:37 +0200 - build 4282

1. Уточнение 4280.2.

drkns 01.03.2015 00:58:19 +0200 - build 4281

1. Уточнение 4280.1.

drkns 28.02.2015 23:56:47 +0200 - build 4280

1. FCTL_SETPANELDIRECTORY теперь возвращает 0 при неудаче и не порождает диалогов в процессе.

2. Рефакторинг. Возможны разнообразные чудеса в редакторе.

w17 27.02.2015 14:35:20 +0300 - build 4279

1. M#2954: Switch to Viewer (F6) loses current position when "Save file position" is OFF

svs 25.02.2015 19:08:58 +0300 - build 4278

1. SQLite 3.8.8.3

drkns 23.02.2015 19:43:02 +0200 - build 4277

1. Уточнение 4275.

2. Продолжение 4276.

drkns 21.02.2015 11:14:06 +0200 - build 4276

1. Некорректно работало разворачивание путей вида C:path.

drkns 21.02.2015 09:54:33 +0200 - build 4275

1. Рефакторинг.

shmuel 21.02.2015 00:52:00 +0200 - build 4274

1. Рефакторинг.

shmuel 20.02.2015 17:58:57 +0200 - build 4273

1. Рефакторинг.

zg 20.02.2015 01:01:34 +0200 - build 4272

1. уточнение 4262: если что-то в VE_READ приводило к перерисовке quickview - фар падал.

shmuel 19.02.2015 16:30:33 +0200 - build 4271

1. M#2950: InputRecordToName возвращает символ с кодом 1: ☺

w17 18.02.2015 23:36:18 +0300 - build 4270

1. M#2949: Проблема HEX поиска -- fix 4208

svs 14.02.2015 10:29:41 +0300 - build 4269

1. SQLite 3.8.8.2

w17 13.02.2015 16:24:23 +0300 - build 4268

1. M#2540: Viewer Search always starts from the beginning of the file

2. Default Viewer.PersistentBlocks = true

zg 09.02.2015 02:06:46 +0200 - build 4267

1. вызов ACTL_WAITKEY возвращает 0 в соответствии с документацией.

w17 08.02.2015 16:36:15 +0300 - build 4266

1. M#2935: <Symlink> to files not showing

2. M#2934: Ошибки c HEX режимом в диалогах поиска

w17 04.02.2015 15:35:47 +0300 - build 4265

1. Уточнение 4262

w17 04.02.2015 14:10:08 +0300 - build 4264

1. Уточнение 4263

w17 03.02.2015 20:32:45 +0300 - build 4263

1. Viewer autoupdate при наличии ACTL_SYNCHRO или far.Timer() (M#2532)

w17 03.02.2015 17:43:09 +0300 - build 4262

1. Некорректное отображение текста изменённого файла при переключении во вьювер.

shmuel 03.02.2015 01:42:54 +0200 - build 4261

1. Plugins API: добавлена стандартная функция FSF.FarClock - то же, что Far.UpTime в макросах,
   но в микросекундах и с микросекундным разрешением. Документация следует.

w17 02.02.2015 13:38:18 +0300 - build 4260

1. Правки просмотрщика:
   -пара мелких багов/опечаток
   -'прелэстный' хак 0x0 <=> 0xffff и последствия его рефакторинга
   Экспериментально - можно выделять произвольный текст Shift+MouseClick начало/конец области
   Продолжение M#2540 - поиск с регулярными выражениями пока не исправлен

drkns 01.02.2015 17:25:54 +0200 - build 4259

1. При замене с регулярными выражениями теперь можно использовать именованные группы.

drkns 30.01.2015 19:26:48 +0200 - build 4258

1. 0002708: Regexp "^(.*?\-\-)" != "^(.*?\-{2})"
   Откат 4257 и исправление 3295.

w17 30.01.2015 19:39:58 +0300 - build 4257

1. M#0002708: Regexp "^(.*?\-\-)" != "^(.*?\-{2})"
   Вернул #define MINSKIP(cmp) - /a*?ca/ "abca" работает

svs 26.01.2015 15:43:08 +0300 - build 4256

1. Падение дебажного FAR при вызове "__FARKEY_ToName(-1)".
   В KeyToTextImpl() "KeyText[0]=(wchar_t)(Key&0xFFFF);" приводило к невалидному символу...

drkns 24.01.2015 09:09:05 +0200 - build 4255

1. Уточнение 4254.2.

drkns 22.01.2015 23:13:47 +0200 - build 4254

1. Показываем метки дисков из реестра при отсутствии физических.

2. "Починим" загрузку плагинов c нетрадиционным расположением зависимых dll.

3. Не закрываем quick search при потере фокуса, если OC новее, чем XP/2k3.

4. Рефакторинг.

shmuel 22.01.2015 13:21:30 +0200 - build 4253

1. Рефакторинг.

shmuel 21.01.2015 23:58:16 +0200 - build 4252

1. Рефакторинг.

shmuel 21.01.2015 16:51:57 +0200 - build 4251

1. Рефакторинг.

zg 20.01.2015 23:11:38 +0200 - build 4250

1. уточнение 4248 для нередактируемых контролов.

svs 20.01.2015 23:19:32 +0300 - build 4249

1. SQLite 3.8.8.1

zg 20.01.2015 03:18:09 +0200 - build 4248

1. 0002912: В диалогах DM_SETTEXT, DM_GETTEXT не позволяют работать со строками содержащими '\0'.

svs 19.01.2015 23:46:37 +0300 - build 4247

1. SQLite 3.8.8

drkns 19.01.2015 20:24:15 +0200 - build 4246

1. Уточнение отображения прогресса при удалении файлов.

shmuel 18.01.2015 20:58:13 +0200 - build 4245

1. Данные одноимённых контент-колонок от разных плагинов конкатенируются.

shmuel 17.01.2015 23:30:07 +0200 - build 4244

1. Рефакторинг.

drkns 17.01.2015 23:10:50 +0200 - build 4243

1. 0002908: Исключение при попытке отображения описания при некорректном Descript.ion

drkns 17.01.2015 16:00:16 +0200 - build 4242

1. Продолжение 4241.

1. Поддержка компиляции в Intel C++ 14.

drkns 17.01.2015 09:38:11 +0200 - build 4241

1. Race condition при far /?

2. Уточнение 4232.

3. Рефакторинг.

zg 16.01.2015 00:46:37 +0200 - build 4240

1. исправление altf9 в быстром поиске.

svs 14.01.2015 12:54:28 +0300 - build 4239

1. F1 в грабере (Alt-Ins) показывает раздел помощи "MiscCmd".
   Выделение области после гашения окна помощи не прерывается.

shmuel 11.01.2015 20:00:05 +0200 - build 4238

1. Рефакторинг.

drkns 09.01.2015 19:25:37 +0200 - build 4237

1. 0002849: ProcessSynchroEventW вызывается при DMODE_NOPLUGINS.

zg 09.01.2015 01:10:36 +0200 - build 4236

1. после закрытия меню фильтров некорректно перерисовывались панели.

zg 09.01.2015 00:44:51 +0200 - build 4235

1. ACTL_REDRAWALL теперь перерисовывает всё.

drkns 08.01.2015 22:22:57 +0200 - build 4234

1. Рефакторинг.

2. VS2015 warnings.

drkns 04.01.2015 19:27:27 +0200 - build 4233

1. Рефакторинг.

drkns 03.01.2015 12:36:25 +0200 - build 4232

1. Рефакторинг.

zg 02.01.2015 13:56:19 +0200 - build 4231

1. 0002896: Присвоить гуид диалогу редактирования фильтра панели.

drkns 30.12.2014 18:01:40 +0200 - build 4230

1. Используем std::regex во внутреннем парсере путей, во избежание.
   Минимальная версия gcc теперь 4.9.

drkns 27.12.2014 15:13:59 +0200 - build 4229

1. 0002845: Wrong Handling of "exclamation marks" in Menu item "!?<title>?<init>!"

zg 26.12.2014 18:50:17 +0200 - build 4228

1. быстрый поиск в панелях не всегда корректно перерисовывался.

drkns 24.12.2014 22:53:03 +0200 - build 4227

1. Продолжение #0002893 - добавлено повышение полномочий.

drkns 22.12.2014 22:53:05 +0200 - build 4226

1. 0002893: Не работает размонтирование iso, vhd, vhdx

svs 22.12.2014 15:31:42 +0300 - build 4225

1. Tree. В диалоге копирования/переноса не работали Shift-F10 и Alt-F10

2. Tree. Видео-артефакты (m_ModalMode с некоторых пор не просто "да/нет", а "0..2").

svs 22.12.2014 13:24:20 +0300 - build 4224

1. Уточнения по TREEFILE_PROJECT (Mantis#0000186)

drkns 21.12.2014 15:02:37 +0200 - build 4223

1. Экспериментально: альтернативное решение проблемы с "open with" в запускателе.

drkns 20.12.2014 14:21:00 +0200 - build 4222

1. Уточнение 4221.

drkns 20.12.2014 14:12:21 +0200 - build 4221

1. Ошибка при импорте настроек.

2. Неудачное сохранение tree3.far при выходе могло приводить к зависанию.

3. Рефакторинг.

zg 18.12.2014 17:04:23 +0200 - build 4220

1. проблемы с файлами, у которых первый символ в имени ゝ.

drkns 16.12.2014 09:27:11 +0200 - build 4219

1. 0002887: Far Manager v3.0 build 4218 x64 (2014-12-16) падает в панелях при нажатии Ctrl-F для получения полного пути

drkns 16.12.2014 00:02:43 +0200 - build 4218

1. И ещё раз.

drkns 15.12.2014 21:16:06 +0200 - build 4217

1. Уточнение 4216.

drkns 15.12.2014 19:31:52 +0200 - build 4216

1. Пара мелочей к 4214.

svs 15.12.2014 13:05:37 +0300 - build 4215

1. Mantis#0002878: Object.CheckHotkey

shmuel 15.12.2014 00:18:36 +0200 - build 4214

1. Экспериментально: колонки C0 больше нет, есть контент-колонки плагинов в любом количестве.
   Типы (они же имена) колонок задаются в режимах панелей в угловых скобках, например: <Foo>,<Bar>.

drkns 14.12.2014 21:32:16 +0200 - build 4213

1. Рефакторинг.

shmuel 13.12.2014 17:58:08 +0200 - build 4212

1. MacroControl(MCTL_ADDMACRO) с заданной функцией Callback неправильно работал в GCC-билде Фара.

svs 09.12.2014 21:54:12 +0300 - build 4211

1. SQLite 3.8.7.4

zg 07.12.2014 17:27:25 +0200 - build 4210

1. уточнение 4208: падали некоторые панельные ansi-плагины.

zg 07.12.2014 15:51:43 +0200 - build 4209

1. уточнение 4208: файлы в кодировке 1200 и 1201 открывались в просмотре в dump режиме.

drkns 06.12.2014 19:29:13 +0200 - build 4208

1. Рефакторинг.

zg 06.12.2014 01:05:54 +0200 - build 4207

1. откат 4203.2, 4204.

shmuel 04.12.2014 20:53:25 +0200 - build 4206

1. Уточнение 3680.

w17 03.12.2014 14:41:20 +0300 - build 4205

1. M#2211: GUI context menu cannot be closed by pressing Esc button
   EMenu вызывается при отпускании кнопки

zg 03.12.2014 03:56:49 +0200 - build 4204

1. экспериментально. продолжение 4203. поддержка колонок C1-C9.

zg 30.11.2014 11:55:22 +0200 - build 4203

1. при переключении из режима без кастом колонки в режим с кастом колонкой в ней ничего не отображалось.

2. экспериментально. постобработка данных, возвращаемых плагинами для кастом колонки, при помощи плагина LuaMacro.

zg 29.11.2014 02:37:27 +0200 - build 4202

1. уточнение 4137.

zg 20.11.2014 16:25:43 +0200 - build 4201

1. фар падал, если плагин в KeyBarLabel.Text возвращал nullptr.

zg 20.11.2014 13:22:03 +0200 - build 4200

1. уточнение 4197.

zg 20.11.2014 04:03:52 +0200 - build 4199

1. уточнение 4197: не обновляем плагиновые панели.

zg 20.11.2014 03:14:13 +0200 - build 4198

1. уточнение 4197.

zg 20.11.2014 03:03:40 +0200 - build 4197

1. иногда панели перечитывались, но не перерисовывались.

drkns 20.11.2014 01:07:04 +0200 - build 4196

1. Измененён способ расчёта цвета текста в панелях, по мотивам http://forum.farmanager.com/viewtopic.php?p=125730.

zg 20.11.2014 00:43:18 +0200 - build 4195

1. поиск в файлах по содержимому искал только в первых 32 килобайтах.

svs 19.11.2014 14:51:39 +0300 - build 4194

1. SQLite 3.8.7.2

drkns 16.11.2014 23:30:38 +0200 - build 4193

1. Пара мелочей.

drkns 16.11.2014 17:10:47 +0200 - build 4192

1. DWORD -> size_t mix.

drkns 16.11.2014 15:04:03 +0200 - build 4191

1. С форума: msgbox('""','""') не выводит кавычки

2. Рефакторинг.

shmuel 14.11.2014 14:32:36 +0200 - build 4190

1. mf.waitkey неправильно работала, будучи вызвана не из макроса.

drkns 12.11.2014 23:34:04 +0200 - build 4189

1. Не скрываем размеры для любых типов reparse point'ов.

w17 12.11.2014 17:19:14 +0300 - build 4188

1. Уточнение 4174.3

drkns 11.11.2014 23:09:00 +0200 - build 4187

1. Опция "Delete symbolic links" переделана в предупреждение в процессе удаления.

w17 11.11.2014 16:30:33 +0300 - build 4186

1. Уточнение 4185

w17 11.11.2014 15:50:30 +0300 - build 4185

1. Quick/Diz Viewer Keybar corrections

drkns 10.11.2014 20:11:52 +0200 - build 4184

1. Опция "Create folders in uppercase" удалена.

drkns 10.11.2014 19:31:00 +0200 - build 4183

1. Еще раз 4180.

zg 10.11.2014 19:23:23 +0200 - build 4182

1. уточнение 4061.1.

zg 10.11.2014 19:00:49 +0200 - build 4181

1. откат 4177.

2. переписан парсер строки перехода по altf8 в редакторе.

3. исправлено позиционирование по altf8 в строках, содержащих табуляции.

drkns 10.11.2014 18:50:48 +0200 - build 4180

1. Не работала опция "System settings/Create folders in uppercase".

w17 10.11.2014 18:14:28 +0300 - build 4179

1. Уточнение 4122.1

w17 10.11.2014 17:24:43 +0300 - build 4178

1. Уточнение 4122.1

zg 10.11.2014 16:08:11 +0200 - build 4177

1. altf8 в редакторе при отмене всё равно переходил на введённую строку.

drkns 09.11.2014 02:12:34 +0200 - build 4176

1. GCC.

drkns 09.11.2014 00:34:51 +0200 - build 4175

1. Уточнение 4174.

drkns 08.11.2014 23:16:10 +0200 - build 4174

1. Рефакторинг.

2. В некоторых случаях не обновлялась линейка клавиш при открытии редактора.

3. Добавим знание о IO_REPARSE_TAG_FILE_PLACEHOLDER (Windows 8.1 OneDrive).

zg 07.11.2014 12:33:42 +0200 - build 4173

1. с форума:
   При вызове из редактора из юзер меню такой команды
   lua: far.Message("from lua")
   во время показанного диалога последняя строка в редакторе закрашивается черным.

zg 07.11.2014 03:22:43 +0200 - build 4172

1. у каждого экранного объекта теперь есть в обязательном порядке родитель - окно.

drkns 06.11.2014 15:56:10 +0200 - build 4171

1. С форума: Excepton occured: bad allocation

zg 05.11.2014 16:44:44 +0200 - build 4170

1. уточнение 4047 для плагииновых панелей:
   Если открыть в панели .7z-файл, содержащий внутри папки, стать на папку и нажать CtrlQ, показывает:
   Folders          0
   Files            0
   Files size       0
   Allocated size   0 (0%)

drkns 02.11.2014 13:15:16 +0200 - build 4169

1. Ещё пара уточнений 4167.

drkns 02.11.2014 11:38:28 +0200 - build 4168

1. Уточнение 4167.

drkns 02.11.2014 00:53:53 +0200 - build 4167

1. Рефакторинг.

drkns 02.11.2014 00:38:57 +0200 - build 4166

1. Уточнение 4164.2.

svs 30.10.2014 09:39:35 +0300 - build 4165

1. SQLite 3.8.7.1

drkns 29.10.2014 21:40:58 +0200 - build 4164

1. Не падаем, если для открытия файла в редакторе не хватило памяти.

2. Пара мелочей.

w17 29.10.2014 18:50:54 +0300 - build 4163

1. Показываем номер кодовой страницы в предупреждении о проблемах перекодирования в редакторе.

w17 28.10.2014 16:39:44 +0300 - build 4162

1. FFILEEDIT_CODEPAGECHANGEDBYUSER/editor, CodePageChangedByUser/viewer - атавизмы.

w17 28.10.2014 10:06:51 +0300 - build 4161

1. Продолжаем 4150.

w17 27.10.2014 12:45:51 +0300 - build 4160

1. Продолжаем 4150.

zg 26.10.2014 16:39:00 +0200 - build 4159

1. убран оригинальный подход к перерисовке окна посылкой ему gotfocus.

zg 25.10.2014 21:39:01 +0200 - build 4158

1. оптимизация отрисовки редактора.

w17 25.10.2014 21:18:26 +0400 - build 4157

1. Снова 4150.

zg 25.10.2014 18:45:48 +0200 - build 4156

1. убрана лишняя перерисовка edit-control'ов.

w17 22.10.2014 17:54:51 +0400 - build 4155

1. Ещё одно уточнение 4150.

2. Можно задавать список кодовых страниц при переключении по F8 в редакторе/просмотрщике.
   far:config Editor.F8CPs
   far:config Viewer.F8CPs
   Умолчание пустая строка - оставляет старое поведение ANSI/OEM.

drkns 22.10.2014 00:04:44 +0200 - build 4154

1. Уточнение 4145.

w17 21.10.2014 15:02:24 +0400 - build 4153

1. Уточнение уточнения 4150.

w17 21.10.2014 14:25:48 +0400 - build 4152

1. Уточнение 4150.

drkns 20.10.2014 21:17:09 +0200 - build 4151

1. #0002841: Зависание FAR

w17 20.10.2014 14:12:09 +0400 - build 4150

1. Смена кодировки файла с перечитыванием в редакторе должна работать через API.

2. При автоопределениии кодировки файла в редакторе (ShiftF8)
   если файл содержит только ASCII коды, подставляется умолчательная кодировка
   (или ACP, если умолчательная - юникод).

shmuel 20.10.2014 00:54:08 +0200 - build 4149

1. M#2838: Артефакт на экране по окончании выполнения макроса.

drkns 19.10.2014 08:47:14 +0200 - build 4148

1. Уточнение 4145.

zg 19.10.2014 03:03:18 +0200 - build 4147

1. убран ненужный код.

zg 19.10.2014 02:28:21 +0200 - build 4146

1. очередные проблемы с табами и раскраской в редакторе.

drkns 19.10.2014 00:25:12 +0200 - build 4145

1. Рефакторинг.

zg 19.10.2014 00:10:02 +0200 - build 4144

1. уточнение 4141.

2. древний баг, когда ECTL_GETINFO, вызванная из EE_REDRAW, возвращало некорректную LeftPos.

svs 18.10.2014 11:00:19 +0400 - build 4143

1. SQLite 3.8.7

w17 18.10.2014 06:15:54 +0300 - build 4142

1. уточнение 4135

zg 18.10.2014 02:39:46 +0200 - build 4141

1. 0002835: Цветомузыка при сдвиге содержимого редактора влево.

drkns 17.10.2014 23:22:14 +0200 - build 4140

1. #0002839: Неправильно ассоциированы названия атрибутов

zg 17.10.2014 14:01:23 +0200 - build 4139

1. уточнение 4137.

zg 17.10.2014 04:06:40 +0200 - build 4138

1. ACTL_GETWINDOWINFO возвращает все окна в порядке текущего z-order'а.

zg 17.10.2014 03:27:45 +0200 - build 4137

1. уточнение 4134: убрана копипаста и удаляются реально все цветовые области.

zg 17.10.2014 01:30:31 +0200 - build 4136

1. при открытии уже открытого файла в редакторе из поиска запрос выводился некорректно.

2. gcc warning.

w17 16.10.2014 02:20:55 +0300 - build 4135

1. M#2829: Пустой экран в вьювере при перезаписи файла

shmuel 16.10.2014 00:05:23 +0200 - build 4134

1. Добавлен флаг ECF_AUTODELETE. Если функция EditorControl(ECTL_ADDCOLOR) выставила данный флаг,
   то добавляемая цветовая область будет автоматически удалена Фаром непосредственно перед очередной
   посылкой плагинам события EE_REDRAW.

drkns 14.10.2014 22:24:10 +0200 - build 4133

1. При неудаче записи в tree3.far показывался некорректный код ошибки.

drkns 13.10.2014 19:25:09 +0200 - build 4132

1. С форума: "Начиная с билда 4062 скорость исполнения регулярок заметно упала."

drkns 11.10.2014 19:53:46 +0200 - build 4131

1. #0002827: При удалении групп раскраски файлов размер списка групп не уменьшается

2. Атрибуты в панелях, диалогах, результатах поиска и меню фильтров теперь в одном и том же порядке.

3. Неадекватно работала настройка колонок в результатах поиска.

4. Рефакторинг.

drkns 09.10.2014 01:53:12 +0200 - build 4130

1. Уточнение 4129.

2. Удалён неиспользуемый код.

drkns 08.10.2014 19:55:41 +0200 - build 4129

1. #0002781: Exception при работе под отладчиком VS2013

2. GCC warnings.

drkns 08.10.2014 09:50:10 +0200 - build 4128

1. #0002824: Assertion: list iterator not decrementable

drkns 01.10.2014 20:07:16 +0200 - build 4127

1. Еще пара исправлений в Message.

2. Рефакторинг.

drkns 30.09.2014 23:55:34 +0200 - build 4126

1. Продолжение 4125.

2. Уточнение 4122.1.

drkns 30.09.2014 21:08:57 +0200 - build 4125

1. 0002811: Сломали Message с флагом FMSG_ALLINONE

drkns 29.09.2014 21:27:31 +0200 - build 4124

1. Уточнение 4122.1

drkns 29.09.2014 14:09:13 +0200 - build 4123

1. Во внешний DialogBuilder добавлена поддержка флагов.

drkns 27.09.2014 15:33:27 +0200 - build 4122

1. Во внешний DialogBuilder добавлена поддержка дополнительных кнопок.

2. Во внутренний DialogBuilder добавлена поддержка списков.

drkns 27.09.2014 14:25:43 +0200 - build 4121

1. Продолжение 4120.

drkns 26.09.2014 19:23:14 +0200 - build 4120

1. Рефакторинг Message: строки отдельно, кнопки отдельно.

drkns 22.09.2014 19:59:11 +0200 - build 4119

1. С форума: Отвалилось добавление файла из панели в командную строку при открытом автодополнении в командной строке.

drkns 22.09.2014 19:21:31 +0200 - build 4118

1. #0002804: PN_CHECKMASK не распознает неправильные регексы в 3.0.4117

drkns 21.09.2014 15:58:34 +0200 - build 4117

1. Оптимизация make_vector.

zg 21.09.2014 13:35:14 +0200 - build 4116

1. уточнение 4109.2: открытие просмотра падало, если в панелях была открыта информационная панель
   в папке без описания или быстрый просмотр для папки.

drkns 21.09.2014 11:46:25 +0200 - build 4115

1. Макросы для эмуляции variadic templates вынесены отдельно, улучшены и использованы вместо ручной копипасты везде, где нужно.

drkns 20.09.2014 21:26:14 +0200 - build 4114

1. Продолжение 4112.

drkns 20.09.2014 17:53:05 +0200 - build 4113

1. VC10 fix.

drkns 20.09.2014 17:14:32 +0200 - build 4112

1. Уточнение 4111.

2. Неправильно определялась позиция ошибки при компиляции регулярного выражения.

3. Показываем текст и позицию при ошибке компиляции регулярного выражения или работы с ним.

drkns 20.09.2014 17:00:20 +0200 - build 4111

1. Именованные группы в регулярных выражениях. Пока только на уровне библиотеки.

drkns 19.09.2014 23:47:55 +0200 - build 4110

1. Разделим common.hpp на компоненты, а то совсем тёмный лес уже.

2. Не собиралось в gcc 4.8.1.

zg 19.09.2014 02:15:54 +0200 - build 4109

1. VE_CLOSE приходит в быстрый просмотр и информационную панель до удаления просмотра.

2. просмотр и редактор не удаляются во время обработки любых событий.

3. события от неактивных редакторов и просмотров могли не доходить до плагинов.

drkns 19.09.2014 01:29:27 +0200 - build 4108

1. Где-то между 4008 и 4012 немного погнулись регексы.

drkns 16.09.2014 23:49:54 +0200 - build 4107

1. Рефакторинг.

drkns 14.09.2014 18:38:33 +0200 - build 4106

1. Хендлы потоков асинхронной работы с БД закрывались не вовремя и могли накапливаться в неограниченном количестве.

drkns 14.09.2014 14:42:05 +0200 - build 4105

1. Рефакторинг.

drkns 14.09.2014 10:47:27 +0200 - build 4104

1. Уточнение 4100.

drkns 14.09.2014 02:11:01 +0200 - build 4103

1. Уточнение 4101.

zg 14.09.2014 01:46:47 +0200 - build 4102

1. уточнение 4100: повторный вызов DialogRun.

2. при переоткрытии файла в редакторе, из менеджера окон удалялось окно, которое не было предварительно туда добавлено.

drkns 14.09.2014 00:44:51 +0200 - build 4101

1. Уточнение 4100.

drkns 13.09.2014 22:50:49 +0200 - build 4100

1. При неудачном переключении из редактора в просмотр не освобождалась память.
   Добавлять очередной костыль бессмысленно, поэтому логика владения окнами переделана.
   Теперь нет окон на стеке, окон, удаляемых менеджером, ручного задавания способа удаления,
   ручной проверки успешности создания, ручного удаления при неудачах и прочего цирка.
   Каждое окно - это умный указатель и живёт столько, сколько нужно.
   Возможны причудливые баги, как обычно.

drkns 12.09.2014 00:57:26 +0200 - build 4099

1. 1. Добавлена поддержка атрибутов FILE_ATTRIBUTE_INTEGRITY_STREAM и FILE_ATTRIBUTE_NO_SCRUB_DATA.

zg 11.09.2014 00:27:32 +0200 - build 4098

1. ViewerControl при указании реального ViewerID не работал для QuickView и Info панелей.

2. уточнение в работе VCTL_REDRAW и ECTL_REDRAW.

drkns 11.09.2014 00:07:10 +0200 - build 4097

1. Все предоставляемые плагинам функции помечены как noexcept и обернуты в try/catch,
   т. к. выбрасывание наружу исключений всё равно ни к чему хорошему привести не может.

2. Пара мелочей там же.

drkns 09.09.2014 21:16:03 +0200 - build 4096

1. Уточнение 4096.

drkns 09.09.2014 18:04:46 +0200 - build 4095

1. Уточнение 4072.1.

zg 09.09.2014 00:56:39 +0200 - build 4094

1. исправлены проблемы раскраски редактора, если левая координата отлична от нуля.

zg 08.09.2014 19:55:01 +0200 - build 4093

1. уточнение 4090.

2. убрана двойная проверка на модальность.

zg 08.09.2014 15:12:38 +0200 - build 4092

1. с форума: В редакторе после нажатия F6 не приходит EE_CLOSE.

2. уточнение 4091 для часов.

3. рефакторинг.

zg 08.09.2014 13:10:44 +0200 - build 4091

1. при перерисовке окна перерисовывается не только оно, но и все окна, расположенные над ним.

zg 07.09.2014 23:51:48 +0200 - build 4090

1. при вызове ACTL_SETCURRENTWINDOW из меню плагинов в редакторе без последующего ACTL_COMMIT фар падал.

zg 07.09.2014 22:53:05 +0200 - build 4089

1. запрет на запуск немодального редактора/просмотра распространяется не только на модальный редактор/просмотр,
   но и на любое модальное окно.

zg 05.09.2014 12:17:12 +0200 - build 4088

1. уточнение 4083 для ACTL_GETWINDOWINFO.

zg 05.09.2014 01:51:10 +0200 - build 4087

1. проверка на повторное добавление окна в оконный менеджер.

zg 04.09.2014 23:56:47 +0200 - build 4086

1. уточнение 4083: некорректно работала f6 в редакторе/просмотре.

zg 04.09.2014 23:49:46 +0200 - build 4085

1. текущий редактор/просмотр определяются динамически.

zg 04.09.2014 12:52:38 +0200 - build 4084

1. все чисто модальные окна теперь должны наследоваться от класса Modal.

2. уточнение z-order для модальных окон.

3. опечатка.

zg 04.09.2014 04:07:18 +0200 - build 4083

1. немодальные окна имеют теперь z-order.

zg 03.09.2014 23:18:26 +0200 - build 4082

1. уточнение 4061.1.

drkns 03.09.2014 21:57:15 +0200 - build 4081

1. Пара мелочей.

shmuel 03.09.2014 16:14:57 +0200 - build 4080

1. Продолжение 4077.

shmuel 03.09.2014 12:14:17 +0200 - build 4079

1. Рефакторинг 4077.

drkns 03.09.2014 09:45:11 +0200 - build 4078

1. Уточнение 4076.

shmuel 03.09.2014 01:22:09 +0200 - build 4077

1. M#2705: Far.GetConfig (на замену Far.Cfg_Get).

drkns 03.09.2014 00:57:03 +0200 - build 4076

1. Выкинуты проверки на копирование выше корня. Теперь подобная ситуация считается копированием в корень. Как следствие:

2. 0002784: Падение при ручном вводе адреса сетевой папки для копирования.

3. Уточнения логики извлечения корня пути. Вроде бы уточнил везде, но возможны неожиданности.

drkns 02.09.2014 09:20:13 +0200 - build 4075

1. Уточнение 4072.1.

zg 01.09.2014 15:56:02 +0200 - build 4074

1. 0002786: Мёртвое зависание при закрытии Far Manager если не были закрыты все редактируемые файлы.

2. убран ненужный volatile.

drkns 31.08.2014 17:22:50 +0200 - build 4073

1. 0002785: Падение при попытке вызвать диалог создания архива (shift+F1)

2. Рефакторинг.

drkns 30.08.2014 20:27:40 +0200 - build 4072

1. Рефакторинг.

2. С форума: в строке-заголовке вьювера имя файла отображается без полного пути.

3. С форума: по Ctrl-Shift-Tab нельзя вернуться в конец списка.

4. Дерево папок неадекватно реагировано на клавишу F5.

drkns 30.08.2014 14:02:22 +0200 - build 4071

1. Продолжаем переименования: Frame теперь window, т. к. именно этим оно и является.

2. Рефакторинг.

3. 0002781: Exception при работе под отладчиком VS2013

drkns 27.08.2014 22:20:03 +0200 - build 4070

1. Ошибки получения/установки прав доступа при копировании теперь можно пропускать.

2. При ошибках перекодирования редактор пытался перезагружать ещё не существующий файл.

3. Рефакторинг.

shmuel 27.08.2014 21:21:19 +0200 - build 4069

1. Продолжение 4068.

shmuel 26.08.2014 21:08:48 +0200 - build 4068

1. MCTL_LOADALL поддерживает явное указание путей, с которых будут грузиться макрофайлы.

drkns 25.08.2014 00:30:14 +0200 - build 4067

1. Уточнение 4064.

drkns 24.08.2014 18:51:17 +0200 - build 4066

1. Рефакторинг.

drkns 23.08.2014 22:57:24 +0200 - build 4065

1. Опечатка в 3542, приводившая к невидимости каталогов вида ".?" при определённых обстоятельствах.

2. clang warning.

drkns 23.08.2014 17:09:59 +0200 - build 4064

1. Большая пачка переименований: ибавляемся от перекрытий имён и связанных с этим предупреждений анализаторов и VS 14.

svs 21.08.2014 15:07:45 +0400 - build 4063

1. SQLite 3.8.6

drkns 21.08.2014 02:09:09 +0200 - build 4062

1. Как выяснилось, используемая реализация regex'ов не очень thread safe.
   Как следствие, всё могло причудливо падать, если во время поиска не ограничиваться созерцанием экрана. Особенно в дебаге.
   Попробуем исправить.

zg 21.08.2014 01:26:03 +0200 - build 4061

1. переделан запуск модальных окон.

2. просмотр не удаляется во время обработки VE_GOTFOCUS/VE_KILLFOCUS.

drkns 21.08.2014 00:45:30 +0200 - build 4060

1. Выкинем немного недоразумений из help.?pp.

2. Добавим ассертов и константности.

2. Прочий рефакторинг.

zg 19.08.2014 22:40:41 +0200 - build 4059

1. упрощение установки текущей макрообласти.

zg 18.08.2014 20:22:56 +0200 - build 4058

1. уточнение 4011: падал поиск регэкспов с (?=pattern) и (?!pattern).

zg 18.08.2014 19:26:05 +0200 - build 4057

1. уточнение 4053: если после нескольких правильно набранных символов набрать один неправильный
   (отсутствующий в имени) - строка быстрого поиска очищается.

zg 17.08.2014 23:36:15 +0200 - build 4056

1. падение при отрисовки тени диалога за пределами экрана.

drkns 17.08.2014 21:15:50 +0200 - build 4055

1. Поддержка elevation при получении полного/свободного размера диска.

drkns 17.08.2014 00:53:51 +0200 - build 4054

1. Уточнение 4052.

zg 16.08.2014 22:08:40 +0200 - build 4053

1. быстрый поиск в панелях - честное окно.

drkns 16.08.2014 20:39:09 +0200 - build 4052

1. Вынесем из оконного менеджера обработку тех клавиш, которых там не должно быть по определению.

drkns 16.08.2014 15:31:44 +0200 - build 4051

1. 0002763: Функция прокрутки буфера не работает с клавишами Numpad

drkns 16.08.2014 15:25:55 +0200 - build 4050

1. 0002765: В панелях "functional key bar" скрыт, но по нажатию Ctrl-Alt-Shift проявляется.

drkns 16.08.2014 15:16:54 +0200 - build 4049

1. 0002766: не работает поиск, если в имени папки встречается запятая.

drkns 16.08.2014 15:00:36 +0200 - build 4048

1. С форума: плагин по F4 экспортирует файл по GetFiles, а после сохранения и выхода из редактора обратно файл не импортируется.

drkns 16.08.2014 14:49:31 +0200 - build 4047

1. 0002768: Быстрый просмотр – не та область плагинов

drkns 16.08.2014 01:21:40 +0200 - build 4046

1. Рефакторинг.

zg 12.08.2014 01:30:09 +0200 - build 4045

1. с форума: MCTL_GETAREA в горизонтальном меню теперь возвращает MACROAREA_OTHER (вместо MACROAREA_MAINMENU).

2. рефакторинг.

drkns 11.08.2014 23:51:38 +0200 - build 4044

1. В режиме /e и /v плагины получали управление ещё до полной инициализации менеджера.

drkns 11.08.2014 20:24:09 +0200 - build 4043

1. Продолжение 4039.

drkns 10.08.2014 19:54:12 +0200 - build 4042

1. Продолжение 4040.

drkns 10.08.2014 11:18:55 +0200 - build 4041

1. Продолжение 4039 и 4040.

drkns 10.08.2014 00:47:12 +0200 - build 4040

1. Рефакторинг.

drkns 09.08.2014 17:31:49 +0200 - build 4039

1. Продолжаем трясти оконную систему.
   Теперь то, что видно под панелями (userscreen) - это отдельное окно.

2. Рефакторинг.

drkns 06.08.2014 18:59:06 +0200 - build 4038

1. Уточнение 4036.

drkns 06.08.2014 09:01:30 +0200 - build 4037

1. С форума: В 4036 с экрана пропали комманды, запускаемые из ком. строки

drkns 05.08.2014 22:59:59 +0200 - build 4036

1. Рефакторинг.

drkns 04.08.2014 19:57:16 +0200 - build 4035

1. Более тщательная обработка ошибок при запуске вспомогательного процесса в Elevation.

2. Если диалог атрибутов вызван для буквы диска, покажем имя соответствующего тома.

drkns 02.08.2014 14:47:23 +0200 - build 4034

1. В диалоге атрибутов не всегда отображалась информация для DFS-ресурсов.

drkns 01.08.2014 21:36:24 +0200 - build 4033

1. 0002445: Копирование зашифрованных (EFS) файлов

drkns 31.07.2014 22:45:46 +0200 - build 4032

1. Cppcheck warnings.

drkns 31.07.2014 00:18:41 +0200 - build 4031

1. Ещё немного Clang.

drkns 30.07.2014 21:07:46 +0200 - build 4030

1. Уточнение 4018.2.

drkns 29.07.2014 21:22:25 +0200 - build 4029

1. Первая попытка компиляции в Clang. Естественно, не взлетело, но кое-что всплыло:
   - пара глупых багов в редакторе;
   - неиспользуемые переменные;
   - поиск во вьювере зачем-то пытался заменить в искомом \xffff на \0. Мало того, что сие прелэстно само по себе, так при этом ещё и падало.

2. Пара мелочей.

drkns 26.07.2014 15:29:52 +0200 - build 4028

1. Из соображений абстрактного совершенства компилим hook_wow64 как C++.

drkns 25.07.2014 23:09:46 +0200 - build 4027

1. Рефакторинг.

zg 25.07.2014 13:55:39 +0200 - build 4026

1. уточнение 4025 для ACTL_GETWINDOWTYPE.

2. уточнение 4025 для редактора.

zg 25.07.2014 12:40:09 +0200 - build 4025

1. уточнение 3981.

drkns 24.07.2014 23:19:41 +0200 - build 4024

1. При определении кодовой страницы юникод выбирается только в том случае, если текст явно не похож на ASCII.
   Должно уменьшиться количество ложных определений юникода (а количество ложных определений ASCII, соответственно, вырасти).

zg 24.07.2014 12:53:54 +0200 - build 4023

1. уточнение 4020: в горизонтальном меню не работала активация последнего пункта по shift-f10 и активация меню мышью.

zg 24.07.2014 01:40:17 +0200 - build 4022

1. уточнение 4020: не показываем список окон в горизонтальном меню и граббере.

zg 24.07.2014 00:20:25 +0200 - build 4021

1. удалён неиспользуемый код в оконном менеджере.

zg 23.07.2014 23:11:32 +0200 - build 4020

1. горизонтальное меню и граббер - честные окна.

2. при изменении размеров консоли граббер закрывается. раньше падал.

3. gcc warning.

drkns 23.07.2014 19:55:47 +0200 - build 4019

1. Размер буфера для встроенной функции копирования теперь 32 К, а не 64.

drkns 23.07.2014 03:30:09 +0200 - build 4018

1. Уточнение 3978.

2. В автоназначении горячих клавиш в меню творилась какая-то дичь. Не факт, что поправлено везде.

drkns 22.07.2014 23:18:52 +0200 - build 4017

1. Продолжение 4015:
   - восстановим попытки обработать переполнение стека.

drkns 22.07.2014 20:15:47 +0200 - build 4016

1. 0002741: ECTL_CLEARSESSIONBOOKMARKS приводит к падению

drkns 22.07.2014 01:04:14 +0200 - build 4015

1. Exception mix:
   - обрабатываем std::exception при вызове плагинов
   - неправильно работал вызов отладчика
   - рефакторинг

drkns 21.07.2014 21:28:10 +0200 - build 4014

1. Минус ещё один самодельный список.

svs 21.07.2014 11:49:01 +0400 - build 4013

1. Mantis#0002743: Не хватает ECTL_GETTITLE в дополнение к ECTL_SETTITLE
     ECTL_GETTITLE
     Получить заголовок редактора.
     Param1 - размер буфера в символах, который выделил плагин для данных.
     Param2 указывает на буфер, выделенный плагином, куда будет помещен заголовок редактора.
     Функция возвращает требуемый размер буфера в символах, с учетом завершающего нуля.
     Если Param2 = NULL или Param1 меньше требуемого размера, функция просто вернет необходимый размер буфера.

zg 20.07.2014 23:32:48 +0200 - build 4012

1. уточнение 4003.

drkns 20.07.2014 21:59:46 +0200 - build 4011

1. Рефакторинг.

drkns 19.07.2014 20:04:59 +0200 - build 4010

1. Рефакторинг.

drkns 19.07.2014 13:01:14 +0200 - build 4009

1. Уточнение эмуляции std::make_unique: параметры передавались по значению.

zg 18.07.2014 01:59:14 +0200 - build 4008

1. уточнение 4006.

drkns 18.07.2014 01:49:25 +0200 - build 4007

1. Не работало получение закладок в редакторе. И уже давно.

zg 18.07.2014 01:06:52 +0200 - build 4006

1. при удалении редактора внутри события EE_READ, редактор удаляется только после окончания обработки этого события.

2. при удалении просмотра внутри события VE_READ, просмотр удаляется только после окончания обработки этого события.

zg 17.07.2014 02:44:33 +0200 - build 4005

1. 0002734: Сломали диалоги.
   вылез древний баг: при удалении неактивного окна, активное окно исчезает.

2. редактор и просмотр при определённых условиях могли портить память.

shmuel 16.07.2014 18:15:38 +0200 - build 4004

1. Дополнение доступа плагина LuaMacro к буферу экрана.

zg 16.07.2014 01:13:27 +0200 - build 4003

1. с форума: некоректный заголовок консоли при вызове macrobrowser'а через Plugin.Menu.

zg 15.07.2014 21:39:44 +0200 - build 4002

1. с форума: падние в ACTL_GETWINDOWINFO.

shmuel 14.07.2014 20:56:15 +0200 - build 4001

1. Plugin.Menu(), Plugin.Config() и Plugin.Command() возвращают false при неудаче.

drkns 14.07.2014 14:39:33 +0200 - build 4000

1. 0002709: Запрос привилегий администратора может быть невидим если вызван макросом

zg 13.07.2014 14:50:01 +0200 - build 3999

1. уточнение 3992: диалоги показывались только один раз после создания.

drkns 13.07.2014 14:24:22 +0200 - build 3998

1. Опция Interface.FormatNumberSeparators теперь имеет строковый тип.

2. В отладочном билде включен SmallerTypeCheck.

3. Рефакторинг.

drkns 12.07.2014 20:33:45 +0200 - build 3997

1. Уточнение 3996 и ещё пара мелочей.

drkns 12.07.2014 14:18:49 +0200 - build 3996

1. Добавлена опция /set:<parameter>=<value>, позволяющая переопределять основные настройки (см. far:config).

drkns 12.07.2014 09:45:28 +0200

1. Во внешний DialogBuilder добавлена поддержка списков.

zg 11.07.2014 22:11:38 +0200 - build 3995

1. уточнение 3993: при переходе по +/- в просмотре не вызывался EE_READ.

zg 11.07.2014 19:21:21 +0200 - build 3994

1. уточнение 3981 для горизонтального меню.

zg 10.07.2014 22:54:11 +0200 - build 3993

1. VE_READ вызывается, когда окно просмотра полностью сконструировано.

zg 10.07.2014 20:54:25 +0200 - build 3992

1. уточнение 3981.

zg 10.07.2014 15:49:53 +0200 - build 3991

1. уточнение 3985: в EE_CLOSE не работали ECTL_GETINFO и ECTL_GETBOOKMARKS.

zg 10.07.2014 13:54:25 +0200 - build 3990

1. при переоткрытии файла в редакторе мог удалятся не тот фрейм. вплоть до панелей.

drkns 10.07.2014 09:14:35 +0200 - build 3989

1. Древний баг, но начал проявляться только при недавних падениях при выходе:
   - нельзя закрывать хендлы, которые кто-то ещё ждёт по WaitForMultipleObjects.

zg 10.07.2014 03:05:00 +0200 - build 3988

1. уточнение 3981: не работал ключ /v.

2. уточнение 3986: падение при выходе.

drkns 09.07.2014 22:10:05 +0200 - build 3987

1. Рефакторинг.

zg 09.07.2014 21:38:08 +0200 - build 3986

1. редкое падение при переоткрытии файла в редакторе.

2. зависание при последовательном открытии/закрытии редактора через апи.

3. уточнение 3981.

zg 09.07.2014 15:36:33 +0200 - build 3985

1. с форума "ACTL_GETWINDOWTYPE и ACTL_GETWINDOWINFO не работают, будучи вызваны из EE_CLOSE/VE_CLOSE".

zg 09.07.2014 12:47:11 +0200 - build 3984

1. уточнение 3981: иногда при закрытии одних окон активировались не те окна, которые ожидались.

drkns 09.07.2014 00:54:24 +0200 - build 3983

1. Рефакторинг.

zg 08.07.2014 21:06:45 +0200 - build 3982

1. уточнение 3981.

zg 08.07.2014 13:53:39 +0200 - build 3981

1. рефакторинг оконного менеджера. теперь есть общая очередь сообщений.
   используя очередь сообщений теперь можно выполнять любой код асинхронно.
   пример - в реализации EE_READ.

svs 07.07.2014 13:58:08 +0400 - build 3980

1. EMenu всегда вызывался с OPEN_LEFTDISKMENU

drkns 06.07.2014 15:24:29 +0200 - build 3979

1. Рефакторинг.

drkns 04.07.2014 22:46:04 +0200 - build 3978

1. Внутренний конвертер utf8 -> utf16 некорректно преобразовывал 4-байтные символы.

drkns 03.07.2014 19:16:23 +0200 - build 3977

1. Уточнение 3869.

drkns 03.07.2014 00:19:44 +0200 - build 3976

1. Во внешний DialogBuilder добавлена поддержка комбинированных списков.

drkns 02.07.2014 23:55:43 +0200 - build 3975

1. Интерфейс класса Thread немного приближен к стандартному: теперь туда можно пихать что угодно, а не только uint(void*).

drkns 01.07.2014 19:49:09 +0200 - build 3974

1. Продолжение 3970, ещё пара мелочей.

drkns 01.07.2014 15:43:01 +0200 - build 3973

1. Продолжение 3970. Инициализируем импорты не сразу, а когда надо.

drkns 01.07.2014 12:29:19 +0200 - build 3972

1. Продолжение 3970.

drkns 01.07.2014 00:43:59 +0200 - build 3971

1. VS14 по умолчанию считает, что %s - это char*, что, в принципе, правильно, но всё ломает.
   Хороший повод окончательно вычистить *printf, а пока определим _CRT_STDIO_LEGACY_WIDE_SPECIFIERS.

drkns 30.06.2014 19:07:38 +0200 - build 3970

1. Рефакторинг.

drkns 29.06.2014 19:09:47 +0200 - build 3969

1. Рефакторинг.

2. Уделён неипользуемый код в tvar.?pp.

zg 29.06.2014 16:27:02 +0200 - build 3968

1. 0002723: ECTL_GETINFO не работает при вызове редактора из редактора

drkns 28.06.2014 02:43:22 +0200 - build 3967

1. Рефакторинг.

drkns 27.06.2014 19:53:08 +0200 - build 3966

1. Восстановим поломанный GCC билд.

2. GCC warning.

3. Рефакторинг.

svs 26.06.2014 14:23:24 +0400 - build 3965

1. Mantis#0002692: Невозможно прервать операцию, если она запущена из макроса
   Откат build 3963 до лучших времен. Жуки вылезли.

w17 26.06.2014 00:16:21 +0400 - build 3964

1. Ещё уточнение 3956.
   Через Plugin API пока не работает.

2. M#2540: Viewer Search always starts from the beginning of the file
   НЕЗАВЕРШЕНО!

svs 25.06.2014 11:17:19 +0400 - build 3963

1. Mantis#0002692: Невозможно прервать операцию, если она запущена из макроса
   Закомметим и посмотрим.

w17 25.06.2014 00:16:56 +0400 - build 3962

1. Уточнение 3960.

drkns 24.06.2014 19:41:46 +0200 - build 3961

1. Уточнение 3958.

w17 24.06.2014 20:02:53 +0400 - build 3960

1. M#2706: При конвертировании в UTF-7 не обрабатываются ошибки

w17 23.06.2014 14:41:05 +0400 - build 3959

1. Уточнение 3956.

drkns 21.06.2014 15:51:25 +0200 - build 3958

1. При запуске по Far.exe /p%FARPROFILE%\Plugins не загружались плагины.

drkns 20.06.2014 20:12:27 +0200 - build 3957

1. Если плагин содержит на своей панели объекты с атрибутом FILE_ATTRIBUTE_REPARSE_POINT - считаем, что это симлинки.

w17 20.06.2014 13:46:02 +0400 - build 3956

1. Experimental. M#2684: Возможность смены кодировки путём перечитывания файла

drkns 19.06.2014 09:33:50 +0200 - build 3955

1. Потенциальная проблема в SyncedQueue и пара мелочей в Thread и MultiWaiter для улучшения читаемости.

drkns 19.06.2014 08:46:39 +0200 - build 3954

1. В 3842 погнулся запускатель в некоторых хитрых случаях.

zg 18.06.2014 10:56:30 +0200 - build 3953

1. после 3895 не работало alt-d в редакторе.

w17 16.06.2014 23:43:57 +0400 - build 3952

1. M#2708: Regexp "^(.*?\-\-)" != "^(.*?\-{2})"

shmuel 10.06.2014 11:38:11 +0200 - build 3951

1. Уточнение 3949.

shmuel 10.06.2014 00:45:54 +0200 - build 3950

1. При выгрузке плагина LuaMacro в результате exception ручная запись макросов запрещалась не сразу.

drkns 09.06.2014 22:12:24 +0200 - build 3949

1. Поддежка VS 14 (CTP), пока с варнингами.

shmuel 08.06.2014 22:47:12 +0200 - build 3948

1. Мелкий рефакторинг.

svs 07.06.2014 11:16:01 +0400 - build 3947

1. SQLite 3.8.5

shmuel 06.06.2014 21:35:19 +0200 - build 3946

1. Мелкий рефакторинг.

drkns 06.06.2014 19:00:44 +0200 - build 3945

1. far:ver -> far:about

shmuel 06.06.2014 16:21:30 +0200 - build 3944

1. Запуск Фара far /m запрещает только начальную загрузку макросов, в дальнейшем макросы могут быть
   загружены любым из известных способов.

w17 06.06.2014 12:37:17 +0400 - build 3943

1. ver -> far:ver

drkns 05.06.2014 20:51:49 +0200 - build 3942

1. С форума: ошибка создания автофильтра, если в имени файла присутствовали символы ,;

w17 05.06.2014 16:23:29 +0400 - build 3941

1. M#2250: Непоказ текста в 1251 внутри файла в UTF8
   Можно сменить кодировку при открытии файла, если в текущей файл не может быть открыт без потерь.

drkns 05.06.2014 01:06:34 +0200 - build 3940

1. Падение фара при удалении кастомного panel view mode, если он был установлен на пассивной панели.

2. Туда же добавлено конпкосочетание CtrlShiftEnter - установить режим на пассивной панели.

drkns 04.06.2014 20:11:04 +0200 - build 3939

1. И ещё.

shmuel 04.06.2014 13:52:16 +0200 - build 3938

1. Уточнение 3925.

drkns 03.06.2014 17:35:54 +0200 - build 3937

1. Ещё пара багов в 3934.

drkns 03.06.2014 09:15:51 +0200 - build 3936

1. Пара багов в 3934.

drkns 03.06.2014 03:21:08 +0200 - build 3935

1. GCC.

drkns 03.06.2014 02:42:03 +0200 - build 3934

1. Рандомный рефакторинг.

2. Far обрабатывает команду 'ver', отображая свою версию, версии используемых библиотек и установленных плагинов.

drkns 03.06.2014 02:16:43 +0200 - build 3933

1. 0002687: Меню кодировок: пропадает сепаратор --Other--

shmuel 02.06.2014 18:15:07 +0200 - build 3932

1. Рефакторинг.

shmuel 02.06.2014 00:17:53 +0200 - build 3931

1. Рефакторинг.

shmuel 31.05.2014 17:30:49 +0200 - build 3930

1. Рефакторинг.

shmuel 30.05.2014 23:19:36 +0200 - build 3929

1. Уточнение 3925.

shmuel 30.05.2014 21:32:26 +0200 - build 3928

1. Уточнение 3925 (была утечка памяти).

shmuel 29.05.2014 13:38:28 +0200 - build 3927

1. Уточнение 3825 (DI_FIXEDIT).

shmuel 28.05.2014 16:10:23 +0200 - build 3926

1. Уточнение 3925.

shmuel 28.05.2014 13:00:02 +0200 - build 3925

1. Экспериментально: M#2674: Возврат хэндла панели при работе из макроса.

shmuel 26.05.2014 20:22:56 +0200 - build 3924

1. Завершение рефакторинга, начатого в 3896.

shmuel 26.05.2014 18:44:24 +0200 - build 3923

1. Продолжение 3896.

shmuel 25.05.2014 21:13:55 +0200 - build 3922

1. Продолжение 3896.

shmuel 25.05.2014 18:15:52 +0200 - build 3921

1. Продолжение 3896.

w17 25.05.2014 10:20:35 +0400 - build 3920

1. Ещё уточнение 3913
   Добавлен флаг MLF_HOLDTARGET в plugin.h

shmuel 24.05.2014 20:04:56 +0200 - build 3919

1. Починим вложенные макросы.

shmuel 24.05.2014 17:25:47 +0200 - build 3918

1. Продолжение 3896.

w17 24.05.2014 14:16:12 +0400 - build 3917

1. Уточнение 3913

drkns 24.05.2014 12:11:56 +0200 - build 3916

1. "Починим" пока симлинки как было.

drkns 24.05.2014 10:03:45 +0200 - build 3915

1. 0002686: Debug build crashes in editor

shmuel 23.05.2014 19:52:03 +0200 - build 3914

1. Продолжение 3896.

w17 23.05.2014 15:50:39 +0400 - build 3913

1. M#2675: Symlink создается только с абсолютным путем. Нет возможности задать относительный путь

shmuel 23.05.2014 01:44:13 +0200 - build 3912

1. Продолжение 3896.

shmuel 21.05.2014 23:35:44 +0200 - build 3911

1. Продолжение 3896.

shmuel 21.05.2014 18:07:34 +0200 - build 3910

1. Продолжение 3896.

drkns 18.05.2014 17:19:57 +0200 - build 3909

1. Откат 3908.1 до лучших времён.

drkns 18.05.2014 16:22:09 +0200 - build 3908

1. Рефакторинг. Вынесем из macro.hpp всё, без чего там можно обойтись.

2. GCC warning.

shmuel 17.05.2014 23:58:06 +0200 - build 3907

1. Продолжение 3896.

drkns 17.05.2014 14:43:09 +0200 - build 3906

1. Падение при ввыборе черно-белой цветовой схемы.

zg 16.05.2014 14:27:13 +0200 - build 3905

1. после 3895 не работали клавиши выделения в комстроке.

drkns 15.05.2014 23:57:23 +0200 - build 3904

1. Поиcк теперь умеет сам решать, в какой кодировке надо искать текст. Слава роботам!

drkns 15.05.2014 01:45:08 +0200 - build 3903

1. Уточнение детектирования юникодного текста.

shmuel 15.05.2014 00:13:09 +0200 - build 3902

1. Продолжение 3896.

shmuel 14.05.2014 01:10:59 +0200 - build 3901

1. Уточнение 3896 (Фар падал при определённых обстоятельствах).

shmuel 13.05.2014 17:28:47 +0200 - build 3900

1. В 3896 сломалось возвращаемое значение Plugin.Call.

shmuel 13.05.2014 00:33:38 +0200 - build 3899

1. Продолжение 3896.

shmuel 12.05.2014 16:14:04 +0200 - build 3898

1. В 3896 сломалось возвращаемое значение Plugin.Menu.

zg 12.05.2014 13:39:44 +0200 - build 3897

1. 0002672: Неправильное поведение при работе с буфером обмена.
   при вставке пустой строки устанавливался признак наличия выделения, а само выделение - нет.

shmuel 12.05.2014 13:05:51 +0200 - build 3896

1. Рефакторинг в системе макросов.

zg 09.05.2014 00:19:23 +0200 - build 3895

1. рефакторинг ProcessKey.

svs 08.05.2014 20:34:04 +0400 - build 3894

1. Mantis#0002669: Гуид для меню с результатами поиска всех вхождений

    EditorFindAllListId         = {9BD3E306-EFB8-4113-8405-E7BADE8F0A59}  --> Menu.Id
    Редактор. Список всех найденных вхождений (F7 <All>).

w17 08.05.2014 16:17:06 +0400 - build 3893

1. M#2667: Вылет FAR при использовании регэкспа "[A-Z\\]+"

drkns 07.05.2014 00:00:37 +0200 - build 3892

1. Неправильно работала сортировка по расширению файлов с ':' в имени (да, и такое бывает).

drkns 05.05.2014 19:03:55 +0200 - build 3891

1. Уточнение 3890.

drkns 05.05.2014 18:52:24 +0200 - build 3890

1. Команда "title" добавляла лишний пробел в заголовок.

svs 05.05.2014 16:48:11 +0400 - build 3889

1. Уточнение build 3888
   1. Выключаем панели.
   2. title[Enter] --> в заголовке видим " - Far 3.0.3888 x86 Administrator", то-есть отсутствует показ папки панели.

svs 05.05.2014 12:38:16 +0400 - build 3888

1. Mantis#0002523: Команда title не отрабатывает при погашенных панелях

shmuel 04.05.2014 02:08:54 +0200 - build 3887

1. Откат 3885.

drkns 03.05.2014 19:13:31 +0200 - build 3886

1. Поиск по всем кодовым страницам не работал в x64.

2. Для поиска можно выбирать страницы из всего списка.

3. В поиск добавлена возможность поиска файлов, НЕ содержащих искомый текст.

4. Опция поиска в ADS перенесена в основной диалог.

5. Скрытая опция CollectFiles удалена.

6. Рефакторинг.

shmuel 03.05.2014 17:51:18 +0200 - build 3885

1. Экспериментально:
   Перед обработкой комстроки Фар передаёт её плагину LuaMacro, который вызывает глобальную функцию
   ProcessFarCommandLine(CmdLine), если таковая существует. Если функция не существует, либо возвращает
   false/nil/ничего, Фар продолжает обработку комстроки. Если возвращает стринг, то Фар обрабатывает
   его как новое значение комстроки. Если возвращает true, дальнейшая обработка комстроки Фаром не
   производится.

zg 02.05.2014 03:16:49 +0200 - build 3884

1. откат 3883.

zg 01.05.2014 12:28:01 +0200 - build 3883

1. 0002657: Некорректная работа при изменении последней строки файла из плагина.

svs 28.04.2014 16:43:42 +0400 - build 3882

1. По мотивам Mantis#2562.
   - убрана помесь из ECC_* и XC_*
   - добавлены XC_ALREADY_EXISTS, XC_OPEN_NEWINSTANCE и XC_RELOAD.
   - в FileEditor уточнение по кодам возврата в зависимости от EF_OPENMODE_*
   - в API::Editor новые коды возврата пока не позиционируются (ограничены макросом MANTIS_0002562);
     есть вероятность поломки плагинов ("архивных"), которые ожидают только EEC_OPEN_ERROR, EEC_MODIFIED и EEC_NOT_MODIFIED.
     (хотя... EEC_LOADING_INTERRUPTED уже "в строю" :-))

svs 28.04.2014 15:11:54 +0400 - build 3881

1. Mantis#0002663: Far падает, если показать модальный диалог из обработчика события viewer'а VE_Read
     FileViewer::Init(...NamesList *ViewNamesList,..)
     {
     ...
     (1) if (!View.OpenFile(strName,TRUE))
     ...
         if (ViewNamesList)
     (2)    View.SetNamesList(*ViewNamesList);

     В (1) ViewNamesList еще живой. В (2) уже мертвяк.
     После чего идет трап (что естественно, т.к. объект "Редактор" уже убит)

2. Трап, если в DI_*BOX указан X1==X2==0 и есть заголовок.
   Информация для заголовка консоли берется как обычно из соответствующего элементов диалога,
   но текст для такого элемента показан не будет.

shmuel 28.04.2014 00:58:52 +0200 - build 3880

1. Уточнение build 3770:
   lua:far.Show(...) показывал один аргумент (nil), а должен показывать отсутствие аргументов.

shmuel 26.04.2014 17:43:33 +0200 - build 3879

1. Продолжение 3878, документация обновлена:
   -- "языковые" флаги в FARKEYMACROFLAGS (структуры MacroSendMacroText, MacroAddMacro, MacroExecuteString).
   -- команды lm:post2 и lm:check2 в плагине LuaMacro.

shmuel 25.04.2014 21:32:52 +0200 - build 3878

1. Поддержка MoonScript в API плагинов (документация ещё не обновлена).

svs 23.04.2014 14:14:46 +0400 - build 3877

1. При попытке выйти через .. из сетевой шары на уровень сервера получаю контекстное меню из Emenu.
   http://forum.farmanager.com/viewtopic.php?p=118299#p118299

drkns 22.04.2014 22:16:51 +0200 - build 3876

1. Параметр Editor.FileSizeLimitHi удалён.

2. GUID'ы luamacro, arclite, netbox вынесены в конфиг.

svs 22.04.2014 18:52:29 +0400 - build 3875

1. Mantis#0002651: TechInfo #52: Saved???/HistoryCount

2. Падение, если размер строки настройки System.ShowStatusInfo был меньше числа секций в InfoPanel

drkns 20.04.2014 17:14:22 +0200 - build 3874

1. Рефакторинг.

w17 19.04.2014 22:47:13 +0400 - build 3873

1. Немного более постоянные постоянные блоки в комстроке и полях ввода диалогов.

w17 18.04.2014 13:07:22 +0400 - build 3872

1. M#1465: Редакторы комстроки/диалога не учитывают выделение, установленное плагином

drkns 18.04.2014 10:43:09 +0200 - build 3871

1. "Любимые кодовые страницы" -> "Избранные кодовые страницы".

drkns 17.04.2014 20:06:46 +0200 - build 3870

1. В 3868 погнулись подтверждения отключения виртуальных и subst дисков.

drkns 17.04.2014 19:24:04 +0200 - build 3869

1. Более корректное определение UTF8 / UTF16LE / UTF16BE.

svs 17.04.2014 11:00:21 +0400 - build 3868

1. GUID`ы

    DisconnectDriveId           = {A1BDBEB1-2911-41FF-BC08-EEBC44040B50}  --> Dlg.Id
    Диалог "Отключение сетевого устройства" (Del на сетевом диске в мен выбора дисков).

    SUBSTDisconnectDriveId      = {75554EEB-A3A7-45FD-9795-4A85887A75A0}  --> Dlg.Id
    Диалог "Отключение SUBST-диска"

    VHDDisconnectDriveId        = {629A8CA6-25C6-498C-B3DD-0E18D1CC0BCD}  --> Dlg.Id
    Диалог "Отключение VHD-диска"

    ChangeDriveModeId           = {F87F9351-6A80-4872-BEEE-96EF80C809FB}  --> Dlg.Id
    Диалог "Настройка меню выбора диска"


drkns 15.04.2014 22:31:59 +0200 - build 3867

1. В 3857 немного погнулся переход по +/- во вьювере.

svs 15.04.2014 12:37:20 +0400 - build 3866

1. Mantis#0002647: DM_SETFOCUS работает неправильно в присутствии элемента с DIF_NOFOCUS
    Перед сменой фокуса принудительно очистим флаг DIF_FOCUS у всех элементов.

2. Mantis#0002608: функция Editor: не всегда учитывается что заданный файл уже может быть загружен

    Если файл уже открыт, то повторное открытие в модальном режиме сопровождается сообщением
    "already loaded. How to open this file?" и две кнопки "{ New instance }" и "[ Cancel ]".
    В АПИ: из режимов EF_OPENMODE_* поддерживать только EF_OPENMODE_QUERY, EF_OPENMODE_NEWIFOPEN и
    EF_OPENMODE_BREAKIFOPEN (т.е. те самые кнопки "New instance" и "Cancel").

    (пока частичное решение)

3. GUID`ы
    EditorReloadModalId         = {D6F557E8-7E89-4895-BD75-4D3F2C30E382}  --> Dlg.Id
    Редактор. Диалог-предупреждение переоткрытия открытого файла в модальном редакторе
    (у не модальных - GUID==EditorReloadId)

    EditorCanNotEditDirectoryId = {CCA2C4D0-8705-4FA1-9B10-C9E3C8F37A65}  --> Dlg.Id
    Редактор. Предупреждение о попытке редактировать каталог

    EditorFileLongId            = {E3AFCD2D-BDE5-4E92-82B6-87C6A7B78FB6}  --> Dlg.Id
    Редактор. Предупреждение о превышении размера редактируемого файла (см. настройку Editor.FileSizeLimit и Editor.FileSizeLimitHi)

    EditorFileGetSizeErrorId    = {6AD4B317-C1ED-44C8-A76A-9146CA8AF984}  --> Dlg.Id
    Редактор. Невозможно получить размер редактируемого файла (если заданы Editor.FileSizeLimit и Editor.FileSizeLimitHi)


drkns 13.04.2014 12:41:13 +0200 - build 3865

1. Продолжение 0002645.

drkns 12.04.2014 19:15:45 +0200 - build 3864

1. Продолжение 0002645.

2. Опция EditorF7Rules удалена во имя консистентности.

drkns 12.04.2014 14:26:37 +0200 - build 3863

1. 0002591: Не устанавливается время в диалоге атрибутов файла.

drkns 12.04.2014 13:29:05 +0200 - build 3862

1. 0002645: Повторный поиск (ShiftF7) работает неправильно с опцией "Cursor at end"

2. 0002646: Повторный поиск (ShiftF7), если ничего не найдено, сдвигает курсор

zg 11.04.2014 16:02:53 +0200 - build 3861

1. gcc warnings.

drkns 11.04.2014 08:32:40 +0200 - build 3860

1. Уточнение 3859.1.

drkns 10.04.2014 22:20:10 +0200 - build 3859

1. Количество конструкций !?<title>?<init>! в user menu теперь не ограничено.

2. Туда же добавлены кнопки Ok и Cancel.

3. В некоторых случаях в полях ввода производилась запись за границей буфера.

drkns 10.04.2014 09:18:34 +0200 - build 3858

1. Опечатка в 3857.

drkns 09.04.2014 22:19:59 +0200 - build 3857

1. Если в процессе удаления файла/каталога кто-то удалил его раньше нас - не показываем ошибки типа "файл не найден", считаем работу выполненной.

2. Во вьювере, открытом из диалога перезаписи, работает переход по Add/Subtract.

3. В редакторе при "Cursor at end" не работал обратный поиск.

4. Не собиралась отладочная версия - в 3856 не до конца был вычищен DN_ACTIVATEAPP.

5. Рефакторинг.

zg 09.04.2014 17:49:08 +0200 - build 3856

1. DN_ACTIVATEAPP убрана. вместо неё давно есть DN_INPUT+FOCUS_EVENT.

svs 09.04.2014 09:11:50 +0400 - build 3855

1. Mantis#0001722: DN_EDITCHANGE приходит лишний раз и с ложной информацией

   Подробности:

   1. При старте диалога у "этой" строки редактирования выставлен флаг FEDITLINE_CLEARFLAG (серые буковки).
      В момент ввода символа (вставка или очистка поля ввода) идет сброс флага FEDITLINE_CLEARFLAG и
      очистка содержимого строки. Диалоговая процедура видит это как "PtrData указывает на пустую строку".
      Следом приходит второй DN_EDITCHANGE с теми данными, которые ввели.


   2. unchanged _технически_ похож на выбранный текст с той разницей, что информация (DN_EDITCHANGE)
      для выбранного текста  об удаленном блоке не поступает в диалоговую процедуру.


svs 07.04.2014 16:26:57 +0400 - build 3854

1. Mantis#0001470: Edit-box: состояние "Unchanged" появляется уже после того, как было сброшено

2. Mantis#0001464: Едит-контролы - сбрасывать unchanged, если плагин меняет позицию курсора
   Unchanged-состояние теперь сбрасывается так же для DM_SETSELECTION и DM_SETCURSORPOS.

3. DN_ACTIVATEAPP "публикуем".
   Событие DN_ACTIVATEAPP (0x3FFF/16383) приходит в диалоговую процедуру, когда консольное окно Far Manager становится активным или пассивным.
   Param1 = 1 - окно получило фокус ввода
            0 - окно стало пассивным
   Param2 = 0
   Return = 0

4. Публикуем некоторые "древние" флаги из EDITOR_FLAGS (EF_OPENMODE_*)
    EF_OPENMODE_MASK         = 0x00000000F0000000ULL,
      Маска для EF_OPENMODE_*
    EF_OPENMODE_QUERY        = 0x0000000000000000ULL,
      Запрашивать пользователя в случае если файл открыт в редакторе
    EF_OPENMODE_NEWIFOPEN    = 0x0000000010000000ULL,
      Открыть файл в новом редакторе, если он уже открыт
    EF_OPENMODE_USEEXISTING  = 0x0000000020000000ULL,
      Переключиться на открытый в редакторе файл
    EF_OPENMODE_BREAKIFOPEN  = 0x0000000030000000ULL,
      Прервать операцию открытия файла, если он открыт в редакторе
    EF_OPENMODE_RELOADIFOPEN = 0x0000000040000000ULL,
      Переоткрыть, если файл уже открыт в редакторе.

   fileedit.hpp::FEOPMODEEXISTFILE удалены, вместо этих флагов использованы EDITOR_FLAGS.


svs 07.04.2014 11:56:50 +0400 - build 3853

1. Mantis#0002641: Не обновляется панель с кнопками во время поиска
   Добавлен флаг DMODE_NEEDUPDATE - "при случае обновить не конкретный элемент, а весь диалог".

   Решение закрывает репорт.
   Для избавления от костыля необходимо "немного" изменять ядро...
   ...вводить очередь сообщений (например, Frame: std::vector<Message*> MsgQueue) с последствиями.

2. Bug: Некорректная отрисовка в диалоге результатов поиска (Alt-F7) при изменении размеров консоли.
   Не изменялась координата Bottom у элементов диалога.

drkns 05.04.2014 12:56:05 +0200 - build 3852

1. M#2639: При запуске из панели (с пустой ком.строкой) не должны применяться командные алиасы

2. В 3819 погнулось перемещение курсора в панелях колесом мыши.

svs 04.04.2014 16:50:40 +0400 - build 3851

1. Mantis#0002615: Нужен способ идентификации выпадающих историй

   Один GUID для всех историй в полях ввода:

    SelectFromEditHistoryId  = {4406C688-209F-4378-8B7B-465BF16205FF}  --> Dlg.Id

w17 04.04.2014 16:07:24 +0400 - build 3850

1. M#2637: перестала работать в панелях сортировка по дате создания файла

svs 04.04.2014 11:39:31 +0400 - build 3849

1. SQLite 3.8.4.3

drkns 04.04.2014 00:30:15 +0200 - build 3848

1. Рефакторинг.

svs 03.04.2014 21:49:06 +0400 - build 3847

1. Mantis#0001301: Ошибки при выполнении DM_LISTUPDATE, DN_LISTCHANGE

   Обработка изменения позиций в листах вынесена в класс VMenu (DN_LISTHOTKEY и DN_LISTCHANGE)

   Для хоткеев теперь так:
   if(DN_LISTHOTKEY)
    if(DN_LISTCHANGE)
      изменяем позицию

   Ловим баги :-)

drkns 30.03.2014 12:21:55 +0200 - build 3846

1. 0002628: Предупреждение с непонятными следствиями выбора

2. В 3843 отвалилось управление комбобоксом с клавиатуры.

drkns 29.03.2014 20:20:06 +0200 - build 3845

1. M#0002631: Переполнение буфера при просмотре файлов с шириной окна и строки > 512 символов.

2. Новая версия universal charset detector'а.

3. Рефакторинг.

svs 27.03.2014 10:14:07 +0400 - build 3844

1. SQLite 3.8.4.2

svs 27.03.2014 09:09:23 +0400 - build 3843

1. Mantis#0001301: Ошибки при выполнении DM_LISTUPDATE, DN_LISTCHANGE

   DN_LISTCHANGE - в документации было неверное описание работы события (копи-паст из DN_EDITCHANGE).
   В DI_LISTBOX отсутствовал возврат позиционирования курсора в предыдущее состояние, если диалоговая процедура возвращала 0.
   В DI_COMBOBOX - обработка самостоятельная (vmenu.cpp), посыл сообщения DN_LISTCHANGE (и реакция на него) после визуального отображения;
     в классе VMenu при отображении не учитывалось наличие "хозяина" (диалог) и признака комбинированного списка (VMENU_COMBOBOX).

drkns 23.03.2014 21:51:18 +0200 - build 3842

1. Рефакторинг.

shmuel 22.03.2014 21:27:21 +0200 - build 3841

1. Уточнение 3838 (DM_GETDIALOGTITLE).

drkns 21.03.2014 20:28:49 +0200 - build 3840

1. Передвинем DN_DRAWDLGITEMDONE в правильное место.

svs 21.03.2014 16:28:10 +0400 - build 3839

1. Уточнение относительно DN_DRAWDLGITEMDONE
   Схема следующая:
      1. Отрисовка всего диалога:
          DN_DRAWDIALOG
          DN_CTLCOLORDIALOG
          CountItem раз {
            DN_DRAWDLGITEM
            DN_CTLCOLORDLGLIST
            DN_DRAWDLGITEMDONE
          }
          DN_DRAWDIALOGDONE

      2. Отрисовка одного элемента:
          DN_DRAWDLGITEM
          DN_CTLCOLORDLGLIST
          DN_DRAWDLGITEMDONE

2. Mantis#2511: ACTL_GETWINDOWINFO зависает при вызове для диалога при недавнем наличии другого диалога
   (from NightRoman)

svs 21.03.2014 13:59:21 +0400 - build 3838

1. Dialog API. Добавка:

    Сообщение DM_GETDIALOGTITLE (67) позволяет получить заголовок диалога.
      Param1 = 0
      Param2 = Указатель на структуру FarDialogItemData
      Return = Размер заголовка в символах, без завершающего символа конца строки '\0'

    Far для заголовка диалога (в т.ч. для заголовка консольного окна) берёт данные
    из первого попавшегося "текста" (элементы типа DI_TEXT, DI_DOUBLEBOX, DI_SINGLEBOX)
    или "списка" (элемент типа DI_LISTBOX).
    Если в массиве элементов диалога отсутствует хотя бы один из перечисленных
    элементов, то заголовок пустой.


2. Dialog API. Добавка:

    Событие DN_DRAWDLGITEMDONE (68) посылается в конце отрисовки элемента диалога (парный DN_DRAWDLGITEM).
      Param1 = ID
      Param2 = 0
      Return = 0

    Ранее для сигнала конца отрисовки одного элемента всегда приходил DN_DRAWDIALOGDONE
    (так же как и для отрисовки всего диалога).

    Сейчас
      1. Отрисовка всего диалога:
          DN_DRAWDIALOG
          DN_CTLCOLORDIALOG
          CountItem раз {
            DN_DRAWDLGITEM
            DN_CTLCOLORDLGLIST
          }
          DN_DRAWDIALOGDONE

      2. Отрисовка одного элемента:
          DN_DRAWDLGITEM
          DN_CTLCOLORDLGLIST
          DN_DRAWDLGITEMDONE


3. Mantis#0002586: События: нет возможности отследить открытие комбобокса

   Dialog API. Добавка:

   Событие DN_DROPDOWNOPENED (4119) посылается перед открытием Combobox или History и после закрытия.
      Param1 = ID
      Param2 = 1 - открыт, 0 - закрыт
      Return = 0

   Здесь возможно необходимо уточнение места вызова.


svs 19.03.2014 16:17:34 +0400 - build 3837

1. Mantis#0000327: [X] Save bookmarks не работает без [X] Save file position

   Опции стали независимы, но!

   Вариант без переделки структуры history.db.
   Сейчас таблицы editorposition_history/viewerbookmarks_history зависят от
   editorposition_history/viewerposition_history (в последних храниться имя файла).

   В editorposition_history/viewerposition_history делается запись если
   "запоминать позицию" ИЛИ "запоминать букмарк" выставлены.
   Если есть "запоминать букмарк", но нет "запоминать позицию", то в таблицы
   editorposition_history/viewerposition_history информация о положении записывается нулями.

2. Косметика (UCase) для GUID

svs 18.03.2014 15:20:34 +0400 - build 3836

1. GUID для диалога запроса логина и пароля.

    GetNameAndPasswordId  = {CD2AC546-9E4F-4445-A258-AB5F7A7800E0}  --> Dlg.Id

    Появляется (опционально) при переходе на примапленный диск из меню выбора дисков.

2. Уточнения в SysLog и немного логирования в диалогах.

3. <АХТУНГ!>

   Флаг диалога DMODE_DRAWING очищался перед посылкой DN_DRAWDIALOGDONE, что в некоторых
   случаях приводило к зацикливанию операции отрисовки диалога (с переполнением стека и
   последующим вылетом Far).

   Очистка флага DMODE_DRAWING перенесена в конец DMODE_DRAWING Dialog::ShowDialog().

   </АХТУНГ!>


svs 14.03.2014 12:20:09 +0400 - build 3835

1. Mantis#0002613: Требуются гуиды для меню дисков, меню ассоциаций

    EditorSwitchUnicodeCPDisabledId = {15568DC5-4D6B-4C60-B43D-2040EE39871A} --> Dlg.Id
       Сообщение "Нельзя изменить юникодную кодовую страницу"
       Появляется, когда при редактировании файла в Unicode-кодировке (например, 1200) пытаемся поменять кодовую страницу.

2. Mantis#0002570: Обработка некорректного значения в диалоге настроек
   В DlgBuilder добавлен функционал работы с unsigned int значениями.

svs 13.03.2014 20:13:49 +0400 - build 3834

1. Mantis#0002613: Требуются гуиды для меню дисков, меню ассоциаций

    ChangeDiskMenuId      = {252CE4A3-C415-4B19-956B-83E2FDD85960}  --> Menu.Id
       Меню выбора диска

    FileAssocMenuId       = {F6D2437C-FEDC-4075-AA56-275666FC8979}  --> Menu.Id
       Меню редактирования ассоциаций
    SelectAssocMenuId     = {D2BCB5A5-6B82-4EB5-B321-1AE7607A6236}  --> Menu.Id
       Меню выбора из списка ассоциаций
    FileAssocModifyId     = {6F245B1A-47D9-41A6-AF3F-FA2C8DBEEBD0}  --> Dlg.Id
       Диалог редактирования очередной ассоциации

drkns 13.03.2014 11:55:36 +0200 - build 3833

1. После 3819 не работало логическое связывание элементов диалога.

zg 13.03.2014 02:20:45 +0200 - build 3832

1. 0002620: Залипшая клавиша Shift при посылке ECTL_PROCESSINPUT.

svs 12.03.2014 16:03:57 +0400 - build 3831

1. SQLite 3.8.4.1

2. Mantis#0002619: Не хватает горизонтальной линии в хелпе
   В разметку хелпа добавлена конструкция:
     @=[Символ] (в начале строки)
     Рисует горизонтальную линию из символов "Символ" цветом обычного текста.
     Линия рисуется на всю ширину окна Помощи с отсупами по одному символу слева и справа.
     Если "Символ" не указан, будет отрисована горизонтальная одинарная линия (символом 0x2500).
     Остаток строки игнорируется.

3. Не работал DIF_SEPARATORUSER (по крайней мере для горизонтального сепаратора)

svs 11.03.2014 10:24:41 +0400 - build 3830

1. Bug: Некорректно отрабатывает запуск с панелей файлов, содержащих в начале имени символ '@'.
   Например, "@@@@howl_by_tomape.jpg" в процессе прохода по внутренним функциям превращается в "@@@howl_by_tomape.jpg"
   Т.е. символ "@" в начале строки воспринимается как признак тихого режима, потом усекается на -1 символ.

   Ныне: Enter на элементе файловой панели пропускает механизм определения символа '@' в начале имени.
         Если в ком.строке '@@@@howl_by_tomape.jpg' - будет выдано предупреждение, что файла "@@@howl_by_tomape.jpg" нет.
         Если в ком.строке '"@@@@howl_by_tomape.jpg"' (имя в кавычках) - будет запущен файл '@@@@howl_by_tomape.jpg'.


svs 10.03.2014 22:56:53 +0400 - build 3829

1. SQLite 3.8.4

drkns 10.03.2014 19:37:56 +0200 - build 3828

1. Ключ "/rw" переименован в "/ro-".

2. После 3821 debug build детектировал ложную утечку памяти. Лучше избегать глобальных std-объектов.

3. Расставляем NonCopyable, избавляемся от некоторых глобальных объектов и прочий рефакторинг.

drkns 10.03.2014 01:28:52 +0200 - build 3827

1. Ещё пара оптимизаций отрисовки.

drkns 10.03.2014 01:08:07 +0200 - build 3826

1. Очень старый баг, внесённый ещё в 2.0.1077.
   В некоторых случаях оптимизация работала не так, как ожидалось, и становилось в разы медленнее.

shmuel 09.03.2014 15:08:27 +0200 - build 3825

1. Из форума: DI_FIXEDIT + DIF_HISTORY для строк больше двух символов.
   (Наличие флага DIF_HISTORY позволяло ввести на 1 символ больше, чем длина поля ввода).

shmuel 08.03.2014 23:07:41 +0200 - build 3824

1. Из форума: Неверный результат работы FSF.TruncStr().

zg 08.03.2014 18:40:47 +0200 - build 3823

1. уточнение 3821. для DM_GETFOCUS и DM_LISTADDSTR в случае отсутствия диалога возвращается -1.

drkns 07.03.2014 02:38:36 +0200 - build 3822

1. VC10 fix.

2. Warning.

zg 07.03.2014 02:13:56 +0200 - build 3821

1. 0002614: SendDlgMessage: не падать при невалидном hDlg.

drkns 05.03.2014 22:41:01 +0200 - build 3820

1. 0002604: Translate in file menu Add, Subtract, Multiply...

drkns 04.03.2014 01:22:32 +0200 - build 3819

1. С форума: преобразование длинных имен в короткие не работало для имен длиннее 255 символов.

2. Рефакторинг.

shmuel 02.03.2014 09:53:50 +0200 - build 3818

1. Кастомная сортировка в панелях: индикатор сортировки в некоторых ситуациях не устанавливался на пустой панели.

shmuel 21.02.2014 18:11:56 +0200 - build 3817

1. M#0002607. Ещё одно уточнение.

svs 21.02.2014 08:05:46 +0400 - build 3816

1. Mantis#0002607. Уточнение.
   DM_SETITEMPOSITION вернёт false, если координаты заданы неверно.

svs 20.02.2014 21:33:03 +0400 - build 3815

1. Mantis#0002607: DM_SETITEMPOSITION вызывает падение Фара, если Right < Left - 1

w17 19.02.2014 16:59:31 +0400 - build 3814

1. M#2605: Освобождение памяти после редактирования

w17 18.02.2014 18:54:03 +0400 - build 3813

1. fix $#nn (с форума)

drkns 17.02.2014 22:47:09 +0200 - build 3812

1. 0002603: Падение по вызове FCTL_GETCURRENTPANELITEM на PTYPE_QVIEWPANEL и PTYPE_INFOPANEL

2. Рефакторинг.

drkns 17.02.2014 00:03:05 +0200 - build 3811

1. Уточнение 3810.

drkns 16.02.2014 19:18:25 +0200 - build 3810

1. Некорректно устанавливались флаги 0x10 и 0x20 в Editor.State.

2. Некорректно переключался язык интерфейса.

3. Рефакторинг.

drkns 15.02.2014 13:30:44 +0200 - build 3809

1. Сторонние библиотеки (UCD, sqlite, tinyxml) переехали в thirdparty.

drkns 14.02.2014 19:33:07 +0200 - build 3808

1. 0002600: Far doesn't load plugins with the same dll-name

svs 14.02.2014 09:40:25 +0400 - build 3807

1. SQLite 3.8.3.1

drkns 13.02.2014 20:56:37 +0200 - build 3806

1. Размер буфера копирования не мог быть меньше 64 К.

2. Копированиие в nul не использовало системную функцию.

drkns 13.02.2014 00:23:02 +0200 - build 3805

1. VC10.

drkns 13.02.2014 00:10:00 +0200 - build 3804

1. GCC-билд мог причудливо падать при создании плагином диалога с обработчиком.

2. Теперь ошибка переключения языка не приводит к завершению процессса.

3. Рефакторинг.

shmuel 12.02.2014 18:00:50 +0200 - build 3803

1. Не инициализировалось состояние чекбокса "Size" в диалоге создания фильтра файлов.

w17 11.02.2014 17:41:29 +0400 - build 3802

1. Уточнение 3801

w17 11.02.2014 13:59:15 +0400 - build 3801

1. Длинные имена в диалоге удаления (с форума)

drkns 08.02.2014 12:39:25 +0200 - build 3800

1. 0002577: Не работает сдвиг блока для строки с одним символом

zg 08.02.2014 03:38:56 +0200 - build 3799

1. уточнение 3794:
   при смене кодировки в редакторе любая пустая строка вызывает сообщение:
   "Редактор содержит символы, которые невозможно корректно преобразовать, используя выбранную кодовую страницу."

zg 06.02.2014 23:38:11 +0200 - build 3798

1. DM_GETDLGITEM для элементов DI_LISTBOX и DI_COMBOBOX возвращает текущий список, а не список,
   которым они инициализировались при создании.

w17 06.02.2014 01:14:29 +0400 - build 3797

1. vc++ 2010 fix

drkns 05.02.2014 20:45:24 +0200 - build 3796

1. Уточнение 3794.

svs 05.02.2014 12:25:36 +0400 - build 3795

1. SQLite 3.8.3

drkns 05.02.2014 09:43:50 +0200 - build 3794

1. Analyzer warnings.

2. Рефакторинг.

drkns 03.02.2014 20:20:22 +0200 - build 3793

1. 0002593: Far Manager v3.0 build 3791 x86 (3792) некорректно работает выделение блока.

drkns 03.02.2014 08:35:23 +0200 - build 3792

1. Уточнение 3791.

drkns 02.02.2014 17:48:43 +0200 - build 3791

1. Рефакторинг.

3. Убрана перегрузка new/delete в Release, уточнена в Debug.

3. PVS & cppcheck warnings.

drkns 31.01.2014 08:42:27 +0200 - build 3790

1. 0002588: При изменении каталога в диалоге и нажатии Enter переходим в прежний каталог

drkns 29.01.2014 23:43:43 +0200 - build 3789

1. Во имя перфекционизма не запрашиваем информацию о кодовых страницах до тех пор, пока она не понадобится.

shmuel 29.01.2014 18:45:16 +0200 - build 3788

1. Рефакторинг в системе макросов.

zg 27.01.2014 21:37:49 +0200 - build 3787

1. 0002579: DM_GETTEXT в некоторых случаях возвращает мусор (LuaFAR)

drkns 27.01.2014 21:09:26 +0200 - build 3786

1. 0002578: Проблема выделения памяти при поиске с фильтром

zg 25.01.2014 04:09:09 +0200 - build 3785

1. 0002567: навигация по архиву после поиска
   в SetDirectoryW передавался путь со слешем на конце.

drkns 21.01.2014 22:47:59 +0200 - build 3784

1. 0002568: Exception при попытке ввода строки в поля рассчитанные на числовые значения

w17 21.01.2014 23:14:25 +0400 - build 3783

1. M#2569: В диалоге настроек Viewer неверно работает шорткат AltM

shmuel 21.01.2014 19:26:55 +0200 - build 3782

1. Рефакторинг в системе макросов.

drkns 19.01.2014 23:03:16 +0200 - build 3781

1. #0002294: Удален неиспользуемый код.

drkns 19.01.2014 21:18:14 +0200 - build 3780

1. Уточнение 3779.

drkns 19.01.2014 19:58:42 +0200 - build 3779

1. PVS & cppcheck warnings.

2. Рефакторинг.

drkns 19.01.2014 02:39:29 +0200 - build 3778

1. Рефакторинг.

shmuel 18.01.2014 20:50:43 +0200 - build 3777

1. Рефакторинг в системе макросов.

w17 17.01.2014 14:12:54 +0400 - build 3776

1. M#2557: Подверждение удаления нескольких файлов

   Добавлены 2 настройки (far:config):

   a) Interface.DelHighlightSelected -- bool, default = true
   true -- выделяем случай, когда список удаляемых объектов отличаеся от объекта под курсором.

   b) Interface.DelShowSelected -- int, default = 10
   При множественном удалении показываем имена. Не более чем заданное число,
   приведённое к диапазону 1..высота_экрана/2

   Старое поведение = (false, 1)

drkns 17.01.2014 09:50:47 +0200 - build 3775

1. Уточнение 3774.

drkns 16.01.2014 22:11:50 +0200 - build 3774

1. 0002565: Регрессия с повышением доступа и чтением папок

2. Рефакторинг.

w17 15.01.2014 16:38:20 +0400 - build 3773

1. Продолжение b3771

shmuel 14.01.2014 19:24:08 +0200 - build 3772

1. Рефакторинг в системе макросов.

w17 14.01.2014 16:58:53 +0400 - build 3771

1. M#2556: Crash in Help if macro has lots of keys assigned

shmuel 14.01.2014 11:15:34 +0200 - build 3770

1. Рефакторинг в системе макросов.

w17 13.01.2014 00:08:49 +0400 - build 3769

1. M#2558: Слияние блок Undo не учитывает сохранение файла (from CyberShadow)

drkns 12.01.2014 13:24:37 +0200 - build 3768

1. Уточнение 3767.

drkns 12.01.2014 00:21:01 +0200 - build 3767

1. Падение при отсутствии прав на запись в профиль.

2. "Правильными" плагинами могли считаться и неподдерживаемые, например от Far 2.

3. Рефакторинг.

shmuel 11.01.2014 23:43:43 +0200 - build 3766

1. M#2551: Object.Height/Width не работают в меню.

drkns 09.01.2014 00:20:44 +0200 - build 3765

1. Уточнение 3752 для плагиновых панелей.

drkns 08.01.2014 19:43:29 +0200 - build 3764

1. После 3751 некоррекно отображались скрытые файлы на панели плагина.

drkns 06.01.2014 17:13:09 +0200 - build 3763

1. Используем рекомендуемые MS проверки версии ОС вместо deprecated GetVersionEx.

2. Используем нативный thread_local в gcc.

drkns 05.01.2014 22:55:23 +0200 - build 3762

1. VC10.

drkns 05.01.2014 19:39:38 +0200 - build 3761

1. 0002553: Ненужные хоткеи F3/F4 в история команд (Alt-F8)

shmuel 05.01.2014 19:22:10 +0200 - build 3760

1. Рефакторинг кастомной сортировки.

drkns 03.01.2014 13:37:10 +0200 - build 3759

1. Продолжение 3756: убраны аллокации и немного упрощен код.

drkns 03.01.2014 11:23:21 +0200 - build 3758

1. Уточнение 3752.

t-rex 03.01.2014 11:08:14 +0200 - build 3757

1. мемори лик в 3756.

t-rex 03.01.2014 04:59:02 +0200 - build 3756

1. Фикс кастомной сортировки, уродливо но чтоб намёк был понят.

drkns 03.01.2014 04:00:21 +0200 - build 3755

1. "Восстановим" кастомные режимы сортировки.

drkns 02.01.2014 18:06:05 +0200 - build 3754

1. Оптимизация перемещения внутренних классов.

drkns 02.01.2014 04:33:52 +0200 - build 3753

1. Продолжение 3752.

drkns 02.01.2014 02:55:55 +0200 - build 3752

1. Оптимизация, аналогичная 3401: каждый элемент файловой панели занимает примерно на 200 байт меньше памяти.

drkns 31.12.2013 16:06:31 +0200 - build 3751

1. Рефакторинг.

2. Уточнение 3749.

3. Нажатие ShiftF9 всегда принудительно сохраняет настройки, "не занимаясь эвристикой и оптимизацией".

drkns 31.12.2013 03:05:45 +0200 - build 3750

1. Нажатие F4 в меню групп масок приводило к падению.

drkns 31.12.2013 00:38:12 +0200 - build 3749

1. Рефакторинг.

drkns 30.12.2013 21:25:21 +0200 - build 3748

1. Рефакторинг.

drkns 26.12.2013 19:36:19 +0200 - build 3747

1. Уточнение 3746.

drkns 26.12.2013 01:21:42 +0200 - build 3746

1. Рефакторинг.

drkns 21.12.2013 22:00:20 +0200 - build 3745

1. Уточнение 3744.1.

drkns 21.12.2013 21:20:13 +0200 - build 3744

1. Рефакторинг.

2. Утечки памяти при запуске с ключом /v или /e.

drkns 15.12.2013 04:54:32 +0200 - build 3743

1. Уточнение 3738.

drkns 13.12.2013 22:15:29 +0200 - build 3742

1. Уточнение 3738.

svs 13.12.2013 12:06:12 +0400 - build 3741

1. Mantis#0002545: GUID для меню параметров плагинов

    PluginsConfigMenuId   =  {B4C242E7-AA8E-4449-B0C3-BD8D9FA11AED} --> Menu.Id

drkns 13.12.2013 09:23:31 +0200 - build 3740

1. Уточнение 3738.

drkns 13.12.2013 01:21:33 +0200 - build 3739

1. VC10 fix.

drkns 13.12.2013 00:57:54 +0200 - build 3738

1. Рефакторинг.

drkns 09.12.2013 20:56:45 +0200 - build 3737

1. В 3733 погнулась раскраска файлов.

w17 09.12.2013 14:03:54 +0400 - build 3736

1. Уточнение 3678 (M#2496)

w17 09.12.2013 13:43:23 +0400 - build 3735

1. M#2543: неверная работа Panel.SetPosIdx при включенном фильтре в панели

svs 09.12.2013 10:55:43 +0400 - build 3734

1. SQLite 3.8.2

drkns 08.12.2013 23:04:44 +0200 - build 3733

1. Рефакторинг.

svs 06.12.2013 14:31:24 +0400 - build 3732

1. Mantis#0002331: Хоткеи и\или GUID для Folder Shortcuts

    FolderShortcutsDlgId  = {DC8D98AC-475C-4F37-AB1D-45765EF06269} --> Dlg.Id
      Диалог редактирования пути.
    FolderShortcutsMoreId = {601DD149-92FA-4601-B489-74C981BC8E38} --> Menu.Id
      Меню, показываемое, когда на один шорткат навешено больше одного пути.
      Ранее введенный FolderShortcutsId - это меню общего списка шорткатов (F9 c d).

2. В "построитель" DialogBuilder добавлены функции SetId/GetId присвоения GUID`а диалогу.

svs 05.12.2013 17:07:29 +0400 - build 3731

1. Mantis#0002537: лист с флагом DIF_LISTNOBOX в диалоге странно прокручивается мышью
   ...аналогичное поведение было и у PgDn

svs 05.12.2013 14:43:33 +0400 - build 3730

1. SysLog. Выходной файл в UTF-8; корректировка открытия/закрытия файла (с отладочной инфой по завершению работы программы)

drkns 04.12.2013 20:32:29 +0200 - build 3729

1. Рефакторинг.

2. В syslog'е использовались не те *printf-функции.

zg 29.11.2013 21:29:21 +0200 - build 3728

1. fg4bit и bg4bit при импорте экспорте были перепутаны местами.

drkns 27.11.2013 22:00:17 +0200 - build 3727

1. 0002533: не работает считывание настроек Xlat при старте Far

drkns 27.11.2013 21:13:16 +0200 - build 3726

1. 0002535: Crash при открытии History в маленьком EditBox

drkns 26.11.2013 23:03:45 +0200 - build 3725

1. Пара уточнений 3723.

drkns 25.11.2013 01:55:45 +0200 - build 3724

1. Пара уточнений 3723.

drkns 24.11.2013 21:37:36 +0200 - build 3723

1. Рефакторинг.

2. Удалён неиспользуемый код.

w17 21.11.2013 21:10:00 +0400 - build 3722

1. нажатия CtrlJ/C/F в панели, когда курсор стоит на .., вызывают исключения.

shmuel 21.11.2013 17:11:54 +0200 - build 3721

1. Уточнение билда 3708 (M#2440).

w17 20.11.2013 13:48:49 +0400 - build 3720

1. M#2527: Crash when restarting with rebuilding tree(fix b3673.2)

drkns 19.11.2013 21:18:07 +0200 - build 3719

1. 0002528: Падение при включении режима панели LCtrl8

svs 18.11.2013 15:42:46 +0400 - build 3718

1. Уточнения по TREEFILE_PROJECT (Mantis#0000186)

w17 18.11.2013 11:37:28 +0400 - build 3717

1. Уточнение 3713 (не пишем дубликаты команд из разных каталогов)

shmuel 16.11.2013 17:17:31 +0200 - build 3716

1. Уточнение 3713.

shmuel 16.11.2013 16:55:01 +0200 - build 3715

1. Уточнение 3714.

shmuel 16.11.2013 14:54:12 +0200 - build 3714

1. Добавлен тип события в Panel API: FE_CHANGESORTPARAMS.

w17 16.11.2013 03:05:43 +0400 - build 3713

1. M#2208: Запоминать, в какой папке была запущена команда (from fml2)

svs 15.11.2013 17:39:24 +0400 - build 3712

1. Уточнения (немного) по TREEFILE_PROJECT (Mantis#0000186)
   про сетевые пути

svs 15.11.2013 15:35:21 +0400 - build 3711

1. Уточнения (немного) по TREEFILE_PROJECT (Mantis#0000186)
   Изменены шаблоны tree-файлов:
    "LD.%D.%SN.tree"      шаблон имени файла-деревяхи для локальных дисков
    "ND.%D.%SN.tree"      шаблон имени файла-деревяхи для сетевых дисков
    "NP.%SR.%SH.tree"     шаблон имени файла-деревяхи для сетевых путей
    "RD.%SN.tree"         шаблон имени файла-деревяхи для сменных дисков
    "CD.%L.%SN.tree"      шаблон имени файла-деревяхи для CD/DVD/BD/etc дисков

   <АХТУНГ>

   1. Не надо ставить /D TREEFILE_PROJECT - проект в разработке. Только для тестирования.
   2. Идеи и замечания сюда - http://bugs.farmanager.com/view.php?id=186

   </АХТУНГ>

w17 13.11.2013 01:12:09 +0400 - build 3710

1. M#2524: Падает при переименовании файла на маковском сетевом диске
   Experimental workaround for buggy OSX SMB.

w17 12.11.2013 20:11:28 +0400 - build 3709

1. M#2525: Некорректное обрезание редактируемого файла на маковском сетевом диске
   Experimental workaround for buggy OSX SMB.

svs 11.11.2013 11:16:52 +0400 - build

1. Уточнения в хелпе про команду title

2. Из разделов хелпа про редактор и вьювер убраны упоминания про печать (Alt-F5) - в коде нет поддержки этой операции.

shmuel 08.11.2013 18:47:05 +0200 - build 3708

1. M#2440: akey(1) и одиночные нажатия модификаторов.

drkns 03.11.2013 01:25:39 +0200 - build 3707

1. 0002521: Far падает при запуске ANSI-плагина My Documents начиная с билда 3506

shmuel 02.11.2013 21:39:35 +0200 - build 3706

1. Find file (AltF7): падение при поиске на не-файловой плагиновой панели.

drkns 31.10.2013 22:34:33 +0200 - build 3705

1. Far самостоятельно обрабатывает команду "title".
   Переданная строка будет использоваться вместо стандартной логики формирования заголовка консоли до завершения текущего сеанса.
   Если строка не указана, будет восстановлено стандартное поведение.

w17 31.10.2013 02:35:53 +0400 - build 3704

1. Продолжение 3703: блокируем удаление если зажата клавиша

w17 30.10.2013 23:41:30 +0400 - build 3703

1. M#2419: Два почти идентичных диалога подтверждения множественного удаления (from SEt)

w17 28.10.2013 06:51:10 +0400 - build 3702

1. С форума: Use sort groups и Show selected first не могут быть принудительно включены или выключены

drkns 26.10.2013 21:11:58 +0200 - build 3701

1. Рефакторинг.

drkns 25.10.2013 09:03:21 +0200 - build 3700

1. Уточнение 3699.

drkns 24.10.2013 22:22:03 +0200 - build 3699

1. 0002517: Invalid line number supplied in "Go to position" dialog crashes Far Manager

w17 22.10.2013 22:30:45 +0400 - build 3698

1. M#2513: Far падает на файлах с пустым именем (from SEt)

svs 18.10.2013 11:41:12 +0400 - build 3697

1. SQLite 3.8.1

w17 18.10.2013 00:23:12 +0400 - build 3696

1. Уточнение 3300

drkns 07.10.2013 20:28:43 +0200 - build 3695

1. В 3694 забыли скальпель.

drkns 07.10.2013 20:15:52 +0200 - build 3694

1. Ещё раз на тему получения заголовка консоли.

w17 07.10.2013 14:31:23 +0400 - build 3693

1. M#2505: удвоение японских символов после исполнение команды

drkns 06.10.2013 13:26:56 +0200 - build 3692

1. Ввод некоторых букв в диалоге смены диска мог приводить к ислючительной ситуации.

drkns 04.10.2013 22:29:28 +0200 - build 3691

1. Ещё одно уточнение на тему CtrlZ в редакторе.

2. Рефакторинг.

drkns 04.10.2013 14:12:40 +0200 - build 3690

1. Уточнение 3654.

drkns 04.10.2013 12:40:35 +0200 - build 3689

1. Уточнение 3659.

w17 04.10.2013 07:04:27 +0400 - build 3688

1. С форума:
   Проблема 1. Фар запускается с %temp% только на одной панели, на другой какая-то старая папка.
   Проблема 2. Выходим из Фара --> в исходном cmd окне нет мигающего курсора.

drkns 02.10.2013 12:44:54 +0200 - build 3687

1. Динамически отслеживаем изменение формата даты и времени.

drkns 02.10.2013 11:23:30 +0200 - build 3686

1. Для формата даты с годом вначале годы отображались без лидирующего нуля.

drkns 01.10.2013 18:51:46 +0200 - build 3685

1. Восстановим обрезание пробелов при копировании текста с экрана.

2. Запуск с пустым заголовком консоли (start "" far.exe) приводил к зависанию.

w17 27.09.2013 18:12:55 +0400 - build 3684

1. M#2499: Exception при попытке поиска в файле в режиме просмотра

2. Editor Clipboard paste fix.vc10

svs 26.09.2013 13:02:27 +0400 - build 3683

1. Удалены политики (Policies.DisabledOptions)

drkns 25.09.2013 00:08:15 +0200 - build 3682

1. 0002498: Невозможность отключить фильтр, если среди расширений были похоже, но в разном регистре

w17 25.09.2013 00:36:10 +0400 - build 3681

1. уточнение 3680

drkns 24.09.2013 22:10:50 +0200 - build 3680

1. 0002497: Если не на последнем элементе меню нажать и удерживать стрелку вниз, то курсор убегает за пределы меню

w17 23.09.2013 20:33:42 +0400 - build 3679

1. M#2495: [Folders history] При отсутствии соответсвующего плагина в истории показывается пустая строка.
   (from Denis)

w17 23.09.2013 19:54:36 +0400 - build 3678

1. M#2496: Отключить подсветку горячих клавиш в историях, так как тормозит на большом количестве элементов
   (from Denis)

shmuel 22.09.2013 20:02:30 +0200 - build 3677

1. Макросы, экспериментально:
   - Plugin.Call() всегда работает в асинхронном режиме, то-есть как работал раньше после вызова mmode(3,1).
   - Если гарантированно нужен синхронный режим, пользуемся Plugin.SyncCall().
   - mmode(3,x) всегда возвращает 0 и ни на что не влияет.

drkns 22.09.2013 15:28:35 +0200 - build 3676

1. 0002492: Editor CtrlZ ещё раз.

drkns 22.09.2013 15:24:17 +0200 - build 3675

1. 0002492: Editor CtrlZ

2. Рефакторинг.

shmuel 21.09.2013 11:50:29 +0200 - build 3674

1. Рефакторинг.

drkns 20.09.2013 23:50:03 +0200 - build 3673

1. Рефакторинг.

2. Ручное обновление дерева папок приводило к падению.

drkns 20.09.2013 17:09:53 +0200 - build 3672

1. Рефакторинг.

w17 20.09.2013 16:53:54 +0400 - build 3671

1. vc10 build fix

drkns 20.09.2013 14:21:44 +0200 - build 3670

1. Уточнение 3668.

drkns 20.09.2013 13:56:44 +0200 - build 3669

1. Рефакторинг.

drkns 19.09.2013 20:07:18 +0200 - build 3668

1. Рефакторинг.

drkns 19.09.2013 13:31:43 +0200 - build 3667

1. Уточнение 3666.

drkns 19.09.2013 09:49:54 +0200 - build 3666

1. Уточнение 3656.

2. gcc warnings.

drkns 19.09.2013 09:31:02 +0200 - build 3665

1. 0002490: Editor kills end of line since ver. 3659

shmuel 19.09.2013 00:01:45 +0200 - build 3664

1. M#2486: Разрешить использование Plugin.Call в Condition.
   Добавлена макрофункция Plugin.SyncCall, см. macroapi_manual.chm.

drkns 18.09.2013 23:15:01 +0200 - build 3663

1. Рефакторинг.

drkns 18.09.2013 18:43:08 +0200 - build 3662

1. Рефакторинг.

w17 18.09.2013 17:12:50 +0400 - build 3661

1. Уточнение 3660 (from Denis)

w17 18.09.2013 13:23:02 +0400 - build 3660

1. M#2488: Special Symbols aren't shown in DialogTilte of "!?<title>?<init>!"
   Metasymbols replaced in the dialog caption (same as in the top level usermenu).

drkns 17.09.2013 20:50:44 +0200 - build 3659

1. Рефакторинг.

w17 17.09.2013 11:41:16 +0400 - build 3658

1. с форума: Перестал работать тест очистки буфера обмена

drkns 17.09.2013 00:07:58 +0200 - build 3657

1. Рефакторинг.

drkns 16.09.2013 21:51:26 +0200 - build 3656

1. Не создаём папки в профиле при ReadOnlyConfig==true.

shmuel 16.09.2013 20:04:27 +0200 - build 3655

1. Передача плагину LuaMacro значения опции Фара "ReadOnlyConfig", чтобы не создавал папки
   и не создавал/изменял/удалял файлы, когда нельзя.

drkns 16.09.2013 00:29:14 +0200 - build 3654

1. Переделка UCD-обёртки.
   Как выяснилось, UCD\nscore.h гадит в глобальное пространство всякими мутными дефайнами типа "#define typename"
   с предсказуемыми последствиями, поэтому уберём всё это из заголовков куда подальше.

drkns 15.09.2013 21:06:55 +0200 - build 3653

1. Рефакторинг.

shmuel 15.09.2013 21:01:09 +0200 - build 3652

1. Рефакторинг.

w17 12.09.2013 21:07:14 +0400 - build 3651

1. M#2483: Не работают &-модификаторы в главном меню.

drkns 12.09.2013 14:23:24 +0200 - build 3650

1. 0002482: Фар падает при попытке скопировать файлы с повышением прав.

2. Пара мелочей.

drkns 11.09.2013 23:06:23 +0200 - build 3649

1. Рефакторинг.

shmuel 10.09.2013 23:57:52 +0200 - build 3648

1. Переименование PluginPanelItemEx -> SortingPanelItem.

shmuel 10.09.2013 23:10:05 +0200 - build 3647

1. Кастомные сортировки в панелях используют структуру PluginPanelItemEx вместо PluginPanelItem.
   (Это ломающее изменение, пересмотрите свой код).

drkns 10.09.2013 20:40:20 +0200 - build 3646

1. Рефакторинг.

shmuel 10.09.2013 11:17:28 +0200 - build 3645

1. Кастомные сортировки панелей не получали значение 'ChangeTime'.

2. GCC warnings.

shmuel 10.09.2013 10:43:17 +0200 - build 3644

1. Уточнение 3643.

drkns 10.09.2013 09:48:29 +0200 - build 3643

1. Рефакторинг.

shmuel 08.09.2013 20:14:02 +0200 - build 3642

1. В 3641 сломалось направление сортировки при выборе режима сортировки из меню CtrlF12 по нажатию Enter.

drkns 08.09.2013 17:30:27 +0200 - build 3641

1. Рефакторинг.

2. cppcheck warnings.

3. уточение режима сортировки папок по расширению.

drkns 06.09.2013 13:04:00 +0200 - build 3640

1. С форума: "В интервале билдов 3597-3635 наблюдается падение при попытке вызвать операцию "Continue" плагина S&R в редакторе."

shmuel 05.09.2013 22:41:24 +0200 - build 3639

1. Рефакторинг.

drkns 05.09.2013 13:47:00 +0200 - build 3638

1. Пара уточнений 3636.

w17 05.09.2013 00:25:22 +0400 - build 3637

1. VC10 build fix.

2. -warnings.

drkns 04.09.2013 21:41:29 +0200 - build 3636

1. Рефакторинг.

2. cppcheck warnings.

shmuel 04.09.2013 19:31:48 +0200 - build 3635

1. Меню сортировок панели (CtrlF12) включает в себя и кастомные режимы сортировки, если таковые имеются.

w17 04.09.2013 12:57:16 +0400 - build 3634

1. Односимвольные префиксы плагинов допустимы, но с ограничениями:
   A-Z -- запрещены;
   остальные разрешены если в системе нет диска с таким именем (проверка через QueryDosDevice)

drkns 04.09.2013 00:06:16 +0200 - build 3633

1. При копировании в несколько приёмников кнопка на панели задач мигала после каждой операции.

svs 03.09.2013 23:42:01 +0400 - build 3632

1. SQLite 3.8.0.2

shmuel 03.09.2013 14:58:38 +0200 - build 3631

1. Если плагин, вызванный из макроса, вызывал MCTL_EXECSTRING, то после исполнения MCTL_EXECSTRING
   перерисовка экрана могла быть запрещена, и плагин не мог вывести на экран меню.

2. Мелкий рефакторинг.

shmuel 02.09.2013 11:19:10 +0200 - build 3630

1. FSF.CopyToClipboard() очищает буфер обмена при передаче Data==NULL.

shmuel 02.09.2013 07:25:59 +0200 - build 3629

1. Функция FSF.CopyToClipboard не копировала пустую строку.

zg 31.08.2013 04:12:54 +0200 - build 3628

1. с форума: Падение при вызове PCTL_GETPLUGININFORMATION.

drkns 30.08.2013 22:53:31 +0200 - build 3627

1. Посылка сообщений диалогу до выполнения DialogRun могла приводить к падению.

w17 29.08.2013 16:08:18 +0400 - build 3626

1. Уточнение 3261, допилим DialogBuilder

drkns 29.08.2013 10:01:04 +0200 - build 3625

1. Некорректно обрабатывался вызов OPEN_FINDLIST для ansi-плагинов.

t-rex 28.08.2013 20:06:09 +0200 - build 3624

1. Уточнение 3621, заюзаем DialogBuilder.

t-rex 28.08.2013 16:35:28 +0200 - build 3623

1. Уточнение 3621

2. sqlite 3.8.0

w17 28.08.2013 17:24:35 +0400 - build 3622

1. Уточнение 3621

w17 28.08.2013 14:59:22 +0400 - build 3621

1. Error text wrapping in ChDiskDlg error dialog

shmuel 20.08.2013 20:54:52 +0200 - build 3620

1. Кастомные сортировки панелей восстанавливаются при перезапуске Фара, если setup был сохранён,
   при условии, что соответствующие вызовы Panel.LoadCustomSortMode() производятся в процессе загрузки макросов.
   Восстановление происходит после окончания загрузки макросов, до начала исполнения автостартующих макросов.

t-rex 19.08.2013 14:09:16 +0200 - build 3619

1. $ как последний символ строки замены при поиске с регэкспами вставлял \x00 вместо того чтоб игнорироваться.

drkns 18.08.2013 13:22:27 +0200 - build 3618

1. Буфер экрана мог использовать больше памяти, чем требовалось.

shmuel 17.08.2013 11:56:31 +0200 - build 3617

1. M#2468: некорректная работа Editor.Value и Editor.GetStr() при наличии в строке символа \x00.

drkns 17.08.2013 01:36:21 +0200 - build 3616

1. Уточнение 1947.1 - копирование в буфер строк с позиции после нулевого символа приводило к падению.

t-rex 16.08.2013 23:42:58 +0200 - build 3615

1. Mantis#2465: символ \x00 нарушает поиск/замену с регэкспами.

svs 15.08.2013 12:09:54 +0400 - build 3614

1. Продолжение Mantis#0002442
   (from Smitis)

svs 15.08.2013 10:42:32 +0400 - build 3613

1. Корректировка System.Executor.ComSpecParams - пробелы сами добавим.

shmuel 15.08.2013 00:28:27 +0200 - build 3612

1. Рефакторинг.

svs 14.08.2013 18:52:13 +0400 - build 3611

1. Mantis#0002442: Добавить поддержку TakeCommand
   (from Smitis)
   Тестим.

2. Экспериментально: В запускаторе значение strComSpecParams (которое "/C ") перенесено в конфиг System.Executor.ComSpecParams

drkns 14.08.2013 09:40:14 +0200 - build 3610

1. Warnings.

w17 14.08.2013 04:32:30 +0400 - build 3609

1. Продолжение 3602

w17 12.08.2013 18:51:45 +0400 - build 3608

1. M#2462: Не работает выход в корень диска по cd\

2. -warnings

shmuel 10.08.2013 19:41:07 +0200 - build 3607

1. Продолжение 3604: кастомная сортировка в панелях уже работает.
   См. описание функции Panel.SetCustomSortMode в macroapi_manual.chm.

drkns 10.08.2013 18:58:13 +0200 - build 3606

1. Продолжение 3596. Для адаптеров добавлены функции BOOL Initialize(GlobalInfo*) (вызывается при загрузке)
   и void Free(ExitInfo*) (вызывается при выгрузке).
   Иметь надо обе, в Initialize надо правильно заполнить GlobalInfo.

drkns 09.08.2013 22:32:07 +0200 - build 3605

1. Уточнение загрузки плагинов.

2. Уточнение отрисовки заголовка панели.

3. В копире иногда использовались неинициализированные переменные.

shmuel 09.08.2013 20:01:49 +0200 - build 3604

1. Кастомная сортировка в панелях. Пока не работает.

w17 09.08.2013 11:15:48 +0400 - build 3603

1. Продолжение 3602. GetPathRoot некорректно работал для mountpoint-ов на XP

w17 09.08.2013 04:54:02 +0400 - build 3602

1. M#2461: auto-create directory on the file system mounted via NTFS folder

drkns 08.08.2013 21:19:33 +0200 - build 3601

1. Уточнение 3597.

w17 08.08.2013 17:46:03 +0400 - build 3600

1. Codepage names and typo (from Denis)

drkns 08.08.2013 14:46:51 +0200 - build 3599

1. В некоторых случаях не работал запуск URL из справки.

drkns 07.08.2013 23:21:18 +0200 - build 3598

1. far:config очень плохо работал с 64-битными числами.

2. Продолжаем истреблять FormatString.

drkns 07.08.2013 01:40:10 +0200 - build 3597

1. Частично переделан TPreRedrawFunc. Хранение указателей на что попало - это прекрасно,
   но данные по этим указателям вполне могут и не дожить до момента вызова.

2. Начинаем истреблять FormatString.

drkns 06.08.2013 19:28:53 +0200 - build 3596

1. Внедряем адаптеры плагинов.
   Подробности на http://forum.farmanager.com/viewtopic.php?t=8114, описание интерфейса там же.

shmuel 06.08.2013 11:44:50 +0200 - build 3595

1. В режиме панельной сортировки "Unsorted" при включенной опции "Show selected first" выделенные файлы
   показывались последними, а не первыми.

w17 05.08.2013 14:27:36 +0400 - build 3594

1. для параметра конфига Panel.Text.Highlight нет соответствующего пункта в меню настройки цветов (от ccaid)

w17 05.08.2013 09:33:40 +0400 - build 3593

1. Директория попадала в корзину при удалении по Alt-Del

drkns 04.08.2013 16:11:41 +0200 - build 3592

1. При отмене меню выбора плагина (CtrlPgDn) не освобождались ресурсы.

zg 04.08.2013 00:11:41 +0200 - build 3591

1. в DN_INPUT теперь приходит FOCUS_EVENT.

zg 01.08.2013 18:40:31 +0200 - build 3590

1. PluginStartupInfo.Menu падало если Title == nullptr.

drkns 01.08.2013 14:50:21 +0200 - build 3589

1. В колонке "владелец файла" владелец и домен были не в том порядке.

drkns 31.07.2013 21:56:29 +0200 - build 3588

1. Ещё на тему string и nullptr.

drkns 30.07.2013 20:58:19 +0200 - build 3587

1. Рефакторинг.

drkns 30.07.2013 19:28:34 +0200 - build 3586

1. Продолжение 3582.

w17 30.07.2013 18:13:20 +0400 - build 3585

1. fix copy to ..

drkns 30.07.2013 14:26:32 +0200 - build 3584

1. При получении списка с плагиновой панели могла дважды освобождаться память.

2. В ProcessOSAliases могли использоваться неинициализированные данные.

drkns 30.07.2013 10:31:31 +0200 - build 3583

1. Уточнение 3579.

drkns 30.07.2013 00:55:42 +0200 - build 3582

1. Рефакторинг.

drkns 29.07.2013 14:50:21 +0200 - build 3581

1. Заголовок правой панели некорректно центрировался при включенных часах.

drkns 28.07.2013 22:22:24 +0200 - build 3580

1. Уточнение предыдущего билда, были проблемы с копированием.

drkns 28.07.2013 19:55:27 +0200 - build 3579

1. Ещё немного на тему корректной обработки каталогов "." и ".." - убрано зацикливание при построении дерева с их участием.

drkns 28.07.2013 16:34:30 +0200 - build 3578

1. Ещё на тему поиска всех вхождений.

drkns 28.07.2013 15:56:53 +0200 - build 3577

1. Уточнение 3570.2.

w17 28.07.2013 15:17:50 +0400 - build 3576

1. Ещё уточнение 3475

drkns 28.07.2013 13:41:01 +0200 - build 3575

1. 0002453: Зависание ФАРа при удалении каталогов

drkns 28.07.2013 12:36:50 +0200 - build 3574

1. В некоторых случаях мог падать поиск всех вхождений в редакторе.

2. При поиске всех вхождений некорректно рассчитывался индикатор прогресса.

shmuel 28.07.2013 10:09:10 +0200 - build 3573

1. Падение при копировании через F5 на путь назначения ..\..

w17 28.07.2013 00:34:28 +0400 - build 3572

1. уточнение 3475

shmuel 27.07.2013 18:36:26 +0200 - build 3571

1. Ещё NullToEmpty (Фар падал с плагином Hash Calculator).

drkns 27.07.2013 16:48:32 +0200 - build 3570

1. Показывался не тот текст ошибки при попытке перейти на отстутствующий диск.

2. Пара мелочей во враппере.

drkns 27.07.2013 13:30:05 +0200 - build 3569

1. 0002452: Can't add new Mask to 'Groups of file masks' (since ver3566)

shmuel 27.07.2013 12:00:50 +0200 - build 3568

1. Ещё NullToEmpty (Фар падал с плагином AdvCmp).

shmuel 27.07.2013 07:27:14 +0200 - build 3567

1. Падение при вызове меню дисков.

2. GCC warnings.

w17 27.07.2013 01:23:56 +0400 - build 3566

1. -несколько 'весёлых' падений

drkns 26.07.2013 23:18:26 +0200 - build 3565

1. Расставляем NullToEmpty в нужных местах.

drkns 26.07.2013 22:25:11 +0200 - build 3564

1. Расставляем NullToEmpty в нужных местах.

drkns 26.07.2013 21:44:01 +0200 - build 3563

1. wstring включён по умолчанию. Возможны разнообразные весёлые падения.

drkns 26.07.2013 21:05:55 +0200 - build 3562

1. GetStringBuffer = 0;

2. В каком-то из предыдущих билдов сломался импорт настроек плагинов.

3. При выходе не сохранялась "информация под панелями".

shmuel 26.07.2013 17:46:54 +0200 - build 3561

1. Если Фар был запущен из существующей консоли, то, при завершении его из макроса, в консоли оставалось
   изображение панелей закрытого Фара.

drkns 25.07.2013 23:52:08 +0200 - build 3560

1. --GetStringBuffer

drkns 25.07.2013 23:04:09 +0200 - build 3559

1. --GetStringBuffer

drkns 25.07.2013 22:19:25 +0200 - build 3558

1. --GetStringBuffer

drkns 25.07.2013 21:32:10 +0200 - build 3557

1. --GetStringBuffer

w17 25.07.2013 12:23:31 +0400 - build 3556

1. fix fix 3551

w17 25.07.2013 11:11:29 +0400 - build 3555

1. fix 3551

w17 25.07.2013 10:55:50 +0400 - build 3554

1. GetStringBuffer -= 1

drkns 24.07.2013 22:04:58 +0200 - build 3553

1. --GetStringBuffer

drkns 24.07.2013 21:40:54 +0200 - build 3552

1. GetStringBuffer -= 2;

2. Рефакторинг array_ptr.

w17 24.07.2013 22:18:55 +0400 - build 3551

1. GetStringBuffer -= 2

drkns 24.07.2013 17:54:45 +0200 - build 3550

1. В настройках фильтров некорректно отображалась дата для локалей, использующих формат YYYY-MM-DD.

drkns 24.07.2013 12:33:57 +0200 - build 3549

1. --GetStringBuffer

w17 24.07.2013 12:43:43 +0400 - build 3548

1. GetStringBuffer -= 4

w17 24.07.2013 07:36:17 +0400 - build 3547

1. mf.date() UPPER

drkns 23.07.2013 23:38:13 +0200 - build 3546

1. В одном из предыдущих билдов погнулась mf.date() + ещё пара мелочей.

w17 24.07.2013 00:07:21 +0400 - build 3545

1. GetStringBuffer -= 1

drkns 23.07.2013 12:20:54 +0200 - build 3544

1. В некоторых колонках меню дисков мог отображаться мусор.

drkns 23.07.2013 01:05:58 +0200 - build 3543

1. Рефакторинг.

drkns 22.07.2013 22:15:54 +0200 - build 3542

1. Рефакторинг.

w17 22.07.2013 22:58:09 +0400 - build 3541

1. assertion -- lm:post Keys "a"

drkns 22.07.2013 20:24:28 +0200 - build 3540

1. 0002449: Far падает при выходе, инициированном макросом

drkns 20.07.2013 22:22:03 +0200 - build 3539

1. Уточнение 3528.

drkns 20.07.2013 21:45:17 +0200 - build 3538

1. Продолжение 3528.

drkns 20.07.2013 19:28:48 +0200 - build 3537

1. Продолжение 3528.

drkns 20.07.2013 19:14:34 +0200 - build 3536

1. Уточнение 3535.

drkns 20.07.2013 19:05:41 +0200 - build 3535

1. Продолжение 3528.

drkns 20.07.2013 16:57:35 +0200 - build 3534

1. Продолжение 3528.

drkns 20.07.2013 14:15:36 +0200 - build 3533

1. Продолжение 3528.

w17 20.07.2013 12:51:48 +0400 - build 3532

1. ещё 3528, CtrlPgDn на файлах

w17 20.07.2013 11:51:56 +0400 - build 3531

1. ещё 3528, ждём когда рефакторнесс избавится от deprecated...

drkns 20.07.2013 01:16:35 +0200 - build 3530

1. Продолжение 3528.

shmuel 19.07.2013 22:08:55 +0200 - build 3529

1. Уточнение 3509 для клавиши End.

drkns 19.07.2013 20:22:50 +0200 - build 3528

1. Рефакторинг.
   UnicodeString интерфейсно совместим с std::wstring, фар можно собрать со стандартными строками, используя дефайн USE_STD_STRING.
   Но делать этого пока что не рекомендуется, т. к. ещё присутствуют случаи инициализации строк нулевым указателем и обращения по индексу за пределами строки.

   Возможны баги, соблюдаем осторожность.

svs 18.07.2013 15:57:44 +0400 - build 3527

1. Уточнение 1609.3: Добавка кода для CF_HDROP на тему Cut ("здесь вырезали, в проводнике вставили - смувилось")
   Т.к. более приемлемое сочетание Ctrl-X для вырезания уже занято (прокрутка истории в ком.строке),
   то клавишу пока не назначили (место зарезервировано). Макрос?

drkns 18.07.2013 14:10:32 +0200 - build 3526

1. В CF_HDROP формате неправильно копировались файлы в буфер обмена.

shmuel 17.07.2013 21:51:48 +0200 - build

1. При загрузке макросов первым всегда исполняется макрофайл %FARPROFILE%\Macros\scripts\_macroinit.lua,
   если такой файл существует. Порядок исполнения прочих макрофайлов не определён.

drkns 17.07.2013 15:19:59 +0200 - build 3525

1. Продолжение M#2446: в событие EE_SAVE передаём не имя, а структуру EditorSaveFile.

shmuel 16.07.2013 14:59:58 +0200 - build 3524

1. M#2446: В событие EE_SAVE передавать параметром имя сохраняемого файла.

drkns 14.07.2013 19:12:10 +0200 - build 3523

1. refix refix. memset - типа плохо, да.

w17 14.07.2013 20:05:25 +0400 - build 3522

1. refix refactoring

drkns 14.07.2013 17:33:21 +0200 - build 3521

1. Поддержка компиляции в Intel C++ 14.

drkns 14.07.2013 12:17:59 +0200 - build 3520

1. Уточнение 3519.

drkns 14.07.2013 01:00:31 +0200 - build 3519

1. Рефакторинг.

shmuel 14.07.2013 00:25:05 +0200 - build 3518

1. Макросы: флаги "Selection" и "NoSelection" больше не применяются для областей редактора/вьювера/диалога.
   Для этих областей следует использовать соответственно "EVSelection" и "NoEVSelection".

drkns 13.07.2013 13:00:15 +0200 - build 3517

1. Рефакторинг.

2. Solution для VS2013 + для всех версий теперь используется общий far.vcxproj.

shmuel 13.07.2013 11:34:23 +0200 - build 3516

1. Рефакторинг.

drkns 13.07.2013 00:00:00 +0200 - build 3515

1. Рефакторинг.

shmuel 12.07.2013 21:16:04 +0200 - build 3514

1. Рефакторинг.

drkns 12.07.2013 12:49:43 +0200 - build 3513

1. Убраны проверки устаревших версий GCC.

shmuel 12.07.2013 12:04:01 +0200 - build 3512

1. Продолжение 3509:
   уточнение обработки одиночного нажатия клавиши Up на элементе в начале списка при активном VMENU_WRAPMODE.

drkns 12.07.2013 00:38:43 +0200 - build 3511

1. Уточнение 3510.

drkns 11.07.2013 22:07:42 +0200 - build 3510

1. Снято ограничение на количество колонок в панели.

shmuel 11.07.2013 17:00:14 +0200 - build 3509

1. В меню со скроллингом, при навигации клавишами End, PgDn, PgUp нельзя было сделать видимыми
   нефокусируемые элементы в начале или конце списка.

drkns 10.07.2013 23:48:04 +0200 - build 3508

1. Уточнение 3507.

drkns 10.07.2013 21:55:39 +0200 - build 3507

1. Рефакторинг.

2. Уточнение 3506.

drkns 10.07.2013 00:39:34 +0200 - build 3506

1. Рефакторинг.

svs 09.07.2013 16:52:15 +0400 - build

1. Уточнение хелпа, в т.ч. для TI:
    #26 System.CopyTimeRule

svs 09.07.2013 11:29:32 +0400 - build

1. Немного хелпа - про повышение полномочий.

drkns 08.07.2013 23:47:50 +0200 - build 3505

1. Рефакторинг.

shmuel 08.07.2013 20:15:33 +0200 - build 3504

1. Рефакторинг.

drkns 05.07.2013 18:34:35 +0200 - build 3503

1. Более надёжное сохранение состояния LastError / LastNtStatus для Message c MSG_ERRORTYPE.

2. 0002444: Поиск через "App Paths" перестал использовать %PathExt%.

drkns 04.07.2013 23:03:09 +0200 - build 3502

1. Рефакторинг.

2. Уточнение минимальной версии GCC (4.7.1).

w17 04.07.2013 16:45:06 +0400 - build 3501

1. gcc 4.7.1 compilation fix

shmuel 04.07.2013 15:27:46 +0200 - build 3500

1. Откат 3496. Той же цели можно достичь модификацией библиотеки LuaFAR.

drkns 04.07.2013 13:30:33 +0200 - build 3499

1. Рефакторинг.

drkns 04.07.2013 12:55:32 +0200 - build 3498

1. Рефакторинг.

drkns 04.07.2013 01:21:03 +0200 - build 3497

1. Рефакторинг.

shmuel 03.07.2013 21:13:37 +0200 - build 3496

1. Из форума: "Зачем фар создает каталоги с корне С".
   Внутренняя функция Фара CreatePath импортирована в плагин LuaMacro.

svs 03.07.2013 12:49:18 +0400 - build 3495

1. Уточнение хелпа, в т.ч. для TI:
    #80 XLat.Layouts
    #10 XLat.Flags
    описаны параметры "XLat.Table*" и "XLat.Rules*"

2. В xlat убираем баг с затиранием Правила3

drkns 03.07.2013 00:38:12 +0200 - build 3494

1. Не работал (или не всегда работал) запуск внешних ссылок из справки.

2. Прочие мелочи.

drkns 02.07.2013 16:34:23 +0200 - build 3493

1. Предотвращение рекурсии в группах масок файлов.

svs 02.07.2013 17:15:47 +0400 - build 3492

1. Уточнение в хелпе
   "так же" -> "также"
   @CopyAskOverwrite - не описана возможность F3 на элементах.
   @MaskGroupsSettings - не описаны клавиши управления списком.

2. Для диалога правки группы масок добавлена ссылка на "@MaskGroupsSettings"

svs 02.07.2013 11:40:49 +0400 - build

1. Уточнение в хелпе
   @MakeFolder
     создание связей
   @UserMenu
     описана возможность двигать пункты с помощью Ctrl-стрелки

drkns 02.07.2013 10:01:16 +0200 - build 3491

1. Уточнение 3490.

2. Рефакторинг.

drkns 02.07.2013 01:13:32 +0200 - build 3490

1. Рефакторинг.

svs 01.07.2013 16:30:04 +0400 - build 3489

1. Уточнение build 3488
   Убираем "отрицание". Теперь:
   В конфиге (far:config) ищем "Macros.ShowPlayIndicator", ставим false для отключения отображения 'P'
   По умолчанию 'P' показывать

svs 01.07.2013 15:09:19 +0400 - build 3488

1. Mantis#0002410: Optionally disable blinking 'P' macro execution indicator
   В конфиге (far:config) ищем "Macros.DisableShowPlayMacro", ставим true
   По умолчанию 'P' показывать

w17 01.07.2013 09:49:39 +0400 - build 3487

1. M#2439: Command line prompt format: environment variables don't work anymore

shmuel 30.06.2013 13:12:37 +0200 - build

1. Добавлена возможность вызывать скрипт-файлы с аргументами.
   Это касается: MCTL_SENDSTRING, MCTL_ADDMACRO, eval, lm:post, lm:check.

shmuel 30.06.2013 01:46:43 +0200 - build 3486

1. Рефакторинг.

zg 29.06.2013 22:58:03 +0200 - build 3485

1. уточнение 3482 для IsWordDiv: '\0' у нас всегда разделитель слов.

drkns 29.06.2013 14:58:18 +0200 - build 3484

1. Рефакторинг.

2. Поддержка компиляции в VC++ 2013.

shmuel 28.06.2013 23:29:19 +0200 - build 3483

1. Неправильные переименования некоторых констант в 3482.

drkns 28.06.2013 16:40:17 +0200 - build 3482

1. Рефакторинг.

w17 28.06.2013 16:12:45 +0400 - build 3481

1. 3475++, курсор не следовал за файлом при переименовании по Shift-F6

w17 28.06.2013 15:13:42 +0400 - build 3480

1. 3475++, M#2437: Copy/Move on a mapped drive doesn't work in nightly

w17 27.06.2013 20:08:50 +0400 - build 3479

1. Ещё одно уточнение 3475 -- работа с описаниями файлов

2. Добавлены кавычки для имени файла с лидирующими пробелами в диалоге установки атрибутов.

w17 27.06.2013 07:41:30 +0400 - build 3478

1. M#2435: При копировании файлов в директорию рядом с ней создается новая директория.
   Это фикс 3475.

drkns 26.06.2013 18:48:30 +0200 - build 3477

1. Добавим константности.

drkns 25.06.2013 21:41:36 +0200 - build 3476

1. Продолжение 3474.

w17 25.06.2013 19:24:28 +0400 - build 3475

1. M#2420: Проблема при перемещении файлов с временной панели по относительным путям

drkns 25.06.2013 14:15:35 +0200 - build 3474

1. Analyzer warnings.

2. Рефакторинг.

shmuel 24.06.2013 17:28:37 +0200 - build 3473

1. Рефакторинг.

shmuel 22.06.2013 15:16:19 +0200 - build 3472

1. Уточнения 3458.

lort 20.06.2013 18:59:22 +0400 - build 3471

1. Уточнение 3469.

drkns 20.06.2013 22:55:17 +0200 - build 3470

1. vc10.cpp/vc11.cpp теперь одним файлом.

lort 20.06.2013 20:50:11 +0400 - build 3469

1. Не работал вызов Menu.Filter(4) в макросах

drkns 20.06.2013 01:17:10 +0200 - build 3468

1. VC2012-сборка может запускаться в Windows 2000 SP4 + апдейты.

2. Ошибка инициализации дефолтной раскраски.

drkns 19.06.2013 20:11:42 +0200 - build 3467

1. Рефакторинг.

drkns 18.06.2013 23:40:14 +0200 - build 3466

1. Рефакторинг.

shmuel 18.06.2013 10:44:58 +0200 - build 3465

1. Имена флагов макросов перемещены из Фара в плагин LuaMacro.

drkns 17.06.2013 23:31:47 +0200 - build 3464

1. Рефакторинг.

w17 17.06.2013 14:53:30 +0400 - build 3463

1. Продолжение 3449 для каталогов. (M#2414: Не удаляется файл с длинным именем)

shmuel 15.06.2013 20:14:26 +0200 - build 3462

1. Уточнение 3461.

shmuel 15.06.2013 12:28:39 +0200 - build 3461

1. Plugins API: MCTL_EXECSTRING позволяет передавать аргументы вызываемому скрипту.

drkns 15.06.2013 02:40:00 +0200 - build 3460

1. Рефакторинг.

drkns 14.06.2013 20:12:14 +0200 - build 3459

1. Рефакторинг.

shmuel 14.06.2013 16:21:37 +0200 - build 3458

1. Добавление "типа" FMVT_NIL - расширяет возможности Plugin.Call и MacroControl(MCTL_EXECSTRING).
   Раньше при передаче из Lua в плагины делалось преобразование nil -> FMVT_BOOLEAN(0),
   а передать nil из плагинов в Lua было вообще невозможно.

drkns 14.06.2013 01:17:12 +0200 - build 3457

1. Рефакторинг.

shmuel 14.06.2013 00:06:14 +0200 - build 3456

1. Plugins API: в функцию MacroControl добавлена операция MCTL_EXECSTRING.

drkns 13.06.2013 21:35:16 +0200 - build 3455

1. Продолжение списка задач: добавляем только окна с непустым заголовком (как и было раньше) и сортируем по имени (как и было раньше),
   т. к. сортировка по PID особого смысла не имеет.

drkns 13.06.2013 17:27:23 +0400 - build 3454

1. Как-то не совсем понятен смысл предыдущего коммита: GetModuleFileNameEx есть в XP и уже используется в apiGetModuleFileNameEx.

w17 13.06.2013 18:23:56 +0400 - build 3453

1. Ещё уточнение 3451
   GetProcessImageNameW -- на xp есть

svs 13.06.2013 18:09:50 +0400 - build 3452

1. Уточнение 3451
   QueryFullProcessImageNameW -- на xp нет

svs 13.06.2013 13:34:37 +0400 - build 3451

1. Небольшие изменения в списке процессов (Ctrl-W).
   а) добавлено отображение PID процесса.
   б) клавишей F2 можно переключать вид:
      "PID + заголовок окна процесса"
      "PID + путь к исполняемому модулю процесса"
   в) список отсортирован по PID

   В список попадают дублированные элементы по PID - ничего страшного, "переход" в нужное окно осуществляется корректно.

drkns 12.06.2013 21:24:50 +0200 - build 3450

1. 0002424: Undo не восстанавливает закладки

w17 12.06.2013 15:06:41 +0400 - build 3449

1. M#2414: Не удаляется файл с длинным именем -- можно выбрать удаление без корзины

shmuel 12.06.2013 13:23:17 +0200 - build 3448

1. Рефакторинг.

shmuel 10.06.2013 14:38:45 +0200 - build 3447

1. Рефакторинг.

shmuel 10.06.2013 02:03:06 +0200 - build 3446

1. M#2307: При вызове msgbox из condition(), ключ закрытия msgbox передаётся дальше (не съедается).

svs 06.06.2013 16:03:29 +0400 - build

1. Про RAlt для фильтрации меню - в хелпе укажим.

drkns 06.06.2013 00:33:31 +0200 - build 3445

1. Рефакторинг.

2. Из диалогов локальных настроек редактора/вьювера убраны неактуальные элементы.

shmuel 04.06.2013 21:12:53 +0200 - build 3444

1. Рефакторинг.

2. GCC warnings.

w17 01.06.2013 17:07:58 +0400 - build 3443

1. Уточнение 3439.

drkns 01.06.2013 11:04:26 +0200 - build 3442

1. Уточнение 3440.

2. Пара мелочей.

w17 01.06.2013 09:41:07 +0400 - build 3441

1. gcc build fix

drkns 01.06.2013 01:31:00 +0200 - build 3440

1. Продолжаем ломать режимы панели:
   - в меню работают добавление и удаление (ins/del соответственно)

w17 31.05.2013 17:14:08 +0400 - build 3439

1. M#1511: кодировка Shift_jis -- должен работать просмотр для всех 2-х байтовых кодировок

w17 31.05.2013 11:51:32 +0400 - build 3438

1. M#2418: Проблема импорта shortcuts из Default.farconfig

drkns 30.05.2013 20:59:59 +0200 - build 3437

1. Продолжаем ломать режимы панели:
   - режим можно переименовывать;
   - режим можно сбросить к настройкам по умолчанию.

shmuel 30.05.2013 18:24:39 +0200 - build 3436

1. Plugins API:
   * KMFLAGS_DISABLEOUTPUT теперь является значением по умолчанию и игнорируется Фаром.
   * Добавлен новый флаг KMFLAGS_ENABLEOUTPUT.

shmuel 30.05.2013 11:29:22 +0200 - build 3435

1. Передача плагину LuaMacro точной информации о ключах запуска Фара /e или /v.

2. Уточнение 3434 (не собирался под VC).

drkns 30.05.2013 00:47:06 +0200 - build 3434

1. У нас теперь может быть сколько угодно режимов панели.
   Интерфейса для добавления/удаления режимов пока нет, но настоящие джедаи могут отредактировать panelmodes.db.

2. Переключать режимы можно по CtrlEnter в меню редактирования режимов панели.

shmuel 29.05.2013 17:52:04 +0200 - build 3433

1. Экспериментально: автостартующие макросы работают при запуске Фара с ключами /e и /v.

drkns 29.05.2013 17:12:23 +0200 - build 3432

1. Не работало чтение из стандартного входа во вьювере.

shmuel 28.05.2013 22:43:14 +0200 - build 3431

1. M#1662: Неадекватное поведение макросов с mmode().

w17 27.05.2013 12:24:16 +0400 - build 3430

1. GCC again -- динамическая загрузка NetDfsGetInfo, должны работать кривые сборки mingw

w17 27.05.2013 06:17:07 +0400 - build 3429

1. GCC++.

drkns 26.05.2013 19:53:59 +0200 - build 3428

1. GCC.

shmuel 26.05.2013 18:42:19 +0200 - build 3427

1. M#1663: Не работают макросы из user menu при большом количестве объектов на панели.

w17 26.05.2013 00:53:26 +0400 - build 3426

1. уточнение 3425 -- NetDfsGetInfo не нужна динамическая загрузка

w17 26.05.2013 00:04:03 +0400 - build 3425

1. M#2412: просмотр ссылок DFS по CtrlA

shmuel 24.05.2013 15:43:21 +0200 - build 3424

1. Из форума: После выполнения на файле макроса Keys("ShiftF6 End ! Enter")
              в заголовке Far'a остаётся "Rename/Move ..."

drkns 23.05.2013 23:02:08 +0200 - build 3423

1. Не работали определение и извлечение виртуальных дисков.

w17 23.05.2013 19:21:06 +0400 - build 3422

1. M#2413: Неправильно восстанавливается пометка после перемещения выделенного файла по ShiftF6

t-rex 22.05.2013 17:29:36 +0200 - build 3421

1. Поиск RegExp в просмотре некорректно использовал RegExp API, нельзя было использовать back reference (\NN).

2. Рефакторинг.

drkns 22.05.2013 01:35:24 +0200 - build 3420

1. В диалоге подтверждения замены криво отображались строки, содержащие кавычки.

drkns 20.05.2013 21:50:11 +0200 - build 3419

1. Рефакторинг.

svs 20.05.2013 21:13:22 +0400 - build 3418

1. SQLite 3.7.17

drkns 20.05.2013 17:31:22 +0200 - build 3417

1. Уточнение чтения конфигурации.

drkns 16.05.2013 20:30:12 +0200 - build 3416

1. Перенесём TreeList::FlushCache() в более подходящее место, дабы она при неудаче не блокировала выход.

drkns 16.05.2013 20:02:27 +0200 - build 3415

1. Опечатка в TreeList::FlushCache()

shmuel 16.05.2013 01:32:15 +0200 - build 3414

1. Уточнение 3412.

drkns 15.05.2013 23:43:01 +0200 - build 3413

1. Рефакторинг.

2. VC warning.

shmuel 15.05.2013 23:22:20 +0200 - build 3412

1. Рефакторинг (удалён enum MACROMODEAREA).

shmuel 15.05.2013 18:00:53 +0200 - build 3411

1. Рефакторинг.

t-rex 14.05.2013 23:43:54 +0200 - build 3410

1. Mantis#2409: FAR crashes when moving a directory (even with no plugin).

2. Эдакое расширение для анси плагинов, в VersionInfo можно задать GUID плагина в поле PluginGUID.
   Гуид должен быть строкой без {}.

w17 14.05.2013 23:16:28 +0400 - build 3409

1. Ещё одно уточнение 3388.

drkns 14.05.2013 16:47:32 +0200 - build 3408

1. Рефакторинг.

t-rex 14.05.2013 10:02:15 +0200 - build 3407

1. Разрешим плагинам создавать в своей базе значения с пустым именем, и заодно запретим создавать такие ключи.

drkns 14.05.2013 09:57:32 +0200 - build 3406

1. Рефакторинг.

shmuel 14.05.2013 09:33:00 +0200 - build 3405

1. Уточнение 3404.

shmuel 14.05.2013 09:03:57 +0200 - build 3404

1. GCC warnings.

w17 13.05.2013 14:54:22 +0400 - build 3403

1. Revert 3400

drkns 10.05.2013 14:49:03 +0200 - build 3402

1. Продолжение 3401.

drkns 10.05.2013 14:17:17 +0200 - build 3401

1. Продолжение 3157. Потребление памяти редакторной раскраской сокращено примерно на треть.

w17 08.05.2013 23:57:50 +0400 - build 3400

1. M#1479: The find function should let pass a not visible (hidden) files

w17 08.05.2013 17:27:18 +0400 - build 3399

1. M#2316: добавить FarGuid

w17 08.05.2013 15:09:55 +0400 - build 3398

1. M#2407: Allow to disable BOM generation for UTF codepages in new files

t-rex 07.05.2013 23:35:51 +0200 - build 3397

1. Коррекция 3342 + рефакторинг.
   Появлялся запрос повышения привилегий при заходе например в c:\Users\user\Application Data.

w17 07.05.2013 21:02:44 +0400 - build 3396

1. multiarc + folder shortcut

drkns 07.05.2013 17:13:55 +0200 - build 3395

1. Уточнение 3393.

shmuel 07.05.2013 16:42:49 +0200 - build 3394

1. M#2222: MacroControl MCTL_SENDSTRING возвращает 0 при "Keys('F11') Menu.Select('FarNet', 2) Keys('Enter')"

drkns 07.05.2013 15:05:37 +0200 - build 3393

1. Продолжение 3388: вынесем работу с versioninfo в отдельный класс.

w17 07.05.2013 14:52:09 +0400 - build 3392

1. Уточнение+ 3388 (unused code removed should fix gcc compilation)

w17 07.05.2013 11:05:10 +0400 - build 3391

1. fix gcc build

w17 07.05.2013 10:21:05 +0400 - build 3390

1. Уточнение 3388

t-rex 07.05.2013 00:03:07 +0200 - build 3389

1. Для ECTL_SAVEFILE можно задавать CodePage=CP_DEFAULT чтоб сохранить в текущей кодировке.

2. ECTL_SAVEFILE из анси плагинов не выставлял кодировку что могло портить файлы.

w17 06.05.2013 18:05:16 +0400 - build 3388

1. M#2079: Не запоминаются в ссылках на папки ссылки на FTP папки

drkns 04.05.2013 16:01:20 +0200 - build 3387

1. Уточнение 3358.1: трансляция исключений не выполнялась для неосновых нитей.

drkns 03.05.2013 16:44:16 +0200 - build 3386

1. Рефакторинг.

drkns 03.05.2013 01:07:27 +0200 - build 3385

1. Рефакторинг.

drkns 02.05.2013 22:08:17 +0200 - build 3384

1. С форума: ошибка в Help::MkTopic.

drkns 02.05.2013 17:47:12 +0200 - build 3383

1. Уточнение 3367.1.

drkns 02.05.2013 16:42:48 +0200 - build 3382

1. Грамматика в справке.

2. Поиск всех вхождений в редакторе теперь показывает всю строку и подсвечивает искомое.

drkns 02.05.2013 12:18:40 +0200 - build 3381

1. Криво работало дополнение в модальном режиме.

drkns 01.05.2013 16:06:56 +0200 - build 3380

1. cppcheck warnings.

drkns 30.04.2013 22:17:54 +0200 - build 3379

1. Продолжение 0002294.

drkns 30.04.2013 21:22:39 +0200 - build 3378

1. Продолжение 0002294.

zg 30.04.2013 09:19:06 +0200 - build 3377

1. EditorControl(EditorID,...) работает для текущего редактора при реальном EditorID из EE_READ и EE_CLOSE.

w17 30.04.2013 08:56:12 +0400 - build 3376

1. M#2403: Current file after deletion

drkns 29.04.2013 22:43:33 +0200 - build 3375

1. Рефакторинг.

t-rex 29.04.2013 17:25:29 +0200 - build 3374

1. Рефакторинг.

drkns 29.04.2013 00:30:39 +0200 - build 3373

1. Рефакторинг.

t-rex 28.04.2013 15:57:33 +0200 - build 3372

1. Mantis#2382: far /clearcache

t-rex 28.04.2013 12:04:51 +0200 - build 3371

1. Мелкое ломающее изменение в API.
   Эвент редактора EE_CHANGE теперь не посылается по умолчанию, плагин который заинтересован получать этот эвент
   должен на него подписаться. Подписка происходит для конкретной сессии редактора.
   Чтоб подписаться на эвент:

   EditorSubscribeChangeEvent esce = { sizeof(EditorSubscribeChangeEvent), PluginGuid };
   Info.EditorControl(EditorID, ECTL_SUBSCRIBECHANGEEVENT, 0, &esce);

   И отписаться (если нужно):
   Info.EditorControl(EditorID, ECTL_UNSUBSCRIBECHANGEEVENT, 0, &esce);

   P.S. Внутреняя имплемантация вроде как не ахти, но пока других идей нету.

t-rex 27.04.2013 23:30:06 +0200 - build 3370

1. Подготовка к переводу EE_CHANGE на подписываемый эвент,
   ибо он почти никому не нужен а при посылке всем и всегда приводит к тормозам.
   Пока что только заготовка, ничего не поменялось ещё.

t-rex 27.04.2013 22:33:02 +0200 - build 3369

1. Удалим вообще эти макросы из plugin.hpp, смысла в них особо нету.

t-rex 27.04.2013 17:23:23 +0200 - build 3368

1. Исправлены несколько редко используемых макросов в plugin.hpp.

drkns 25.04.2013 22:28:30 +0200 - build 3367

1. Осторожно пощупаем "оконную подсистему". Пока что просто удаление неиспользуемого кода.

2. В некоторых случаях наблюдалось зависание при закрытии консоли.

3. Пара мелочей.

t-rex 25.04.2013 14:06:10 +0200 - build 3366

1. Mantis#2395: Невозможно добавить фильтр если список фильтров пустой.
   Для FFT_CUSTOM.

t-rex & drkns 25.04.2013 10:12:00 +0200 - build 3365

1. Рефакторинг FileSystemWatcher, оптимизация и также решает странную проблему с плагинами типа PicView при просмотре в QuickView, появившеюся в 3348.

w17 23.04.2013 18:48:10 +0400 - build 3364

1. M#2370: артефакты в редакторе/просмотрщике при вызове из usermenu

w17 23.04.2013 01:00:56 +0400 - build 3363

1. 2394: FAR 3 build 3348: панели рисуются в то время как активен редактор -- next try

t-rex 21.04.2013 23:51:13 +0200 - build 3362

1. Оптимизация поиска в редакторе.

drkns 21.04.2013 19:52:22 +0200 - build 3361

1. Уточнение 3301.

t-rex 21.04.2013 00:13:24 +0200 - build 3360

1. В 3342 не заметил что StartFSWatcher() виртуальная.
   Могло приводить к странным глюкам перерисовки в неопределённых случаях (Mantis#2394).

w17 20.04.2013 20:29:56 +0400 - build 3359

1. С форума: приводим настоящие имена областей кейбаров в соответствие с макро-апи.

drkns 20.04.2013 17:32:12 +0200 - build 3358

1. Обрабатываем структурные исключения как C++-исключения.

2. Ключа /x и параметра ExceptRules больше нет.

drkns 20.04.2013 02:39:36 +0200 - build 3357

1. Пара мелочей.

drkns 20.04.2013 02:30:33 +0200 - build 3356

1. Рефакторинг.

drkns 18.04.2013 23:11:39 +0200 - build 3355

1. В 3322 погнулась асинхронная работа с БД.

t-rex 18.04.2013 16:43:02 +0200 - build 3354

1. Корекция 3349, фар падал при наличие больше одного плагина с одним и тем же GUID.

drkns 18.04.2013 16:37:58 +0200 - build 3353

1. Откат 3352.

drkns 18.04.2013 16:24:32 +0200 - build 3352

1. Уточнение 3351.

t-rex 18.04.2013 16:04:54 +0200 - build 3351

1. Не очень важный мемори лик.

svs 18.04.2013 15:31:10 +0400 - build 3350

1. Уточнение 3346

t-rex 18.04.2013 13:14:37 +0200 - build 3349

1. Корекция 3343.1, должно также исправить разные странные глюки которые появились после 3343.

t-rex 18.04.2013 11:30:20 +0200 - build 3348

1. Ещё немного Mantis#2350.
   Асинхронная подписка на change notification.

drkns 18.04.2013 09:39:27 +0200 - build 3347

1. 0002377: Far Manager v3.0 build 3345 создает пустые файлы при копировании

svs 18.04.2013 09:29:05 +0400 - build 3346

1. UserMenu. Если пункт меню выводит диалог запроса доп.параметров, то в заголовке диалога показываем имя этого пункта меню.

   <inside>
     fnparce.cpp::SubstFileName()    - первым параметром идет то, что будет в качестве заголовка диалога.
